
#ifndef CONFIG_H
#define CONFIG_H


#define RCOS_SIM

/* Global */
#define RCOS_MAINBOARD_V1_0
//#define RCOS_MAINBOARD_FC16
#define PLATFORM_STM32
//#define RCOS_SDLSIM
//#define PLATFORM_SDL


/* Interfaces */
#define SUPPORT_SPI
//#define SUPPORT_I2C
#define SUPPORT_PPM1
//#define SUPPORT_PPM2
//#define SUPPORT_USART

/* Functions */
#define SUPPORT_MENU
#define SUPPORT_3D

/* Hardware */
#define SUPPORT_MMC
#define SUPPORT_LCD
//#define SUPPORT_SDLCD
//#define SUPPORT_S65
#define SUPPORT_DOGM128
//#define SUPPORT_NOKIA3310

/* LCD-Setup */
//#define LCD_WELLCOME_MSG
#define LCD_FLIP
//#define LCD_INVERT
#ifdef SUPPORT_S65
#define S65_LANDSCAPE
#ifdef S65_LANDSCAPE
#define LCD_W				176
#define LCD_H				128
#else
#define LCD_W				132
#define LCD_H				176
#endif
#define LCD_Update			S65_Update
#define LCD_Init			S65_Init
#endif
#ifdef SUPPORT_DOGM128
#define DOGM128_BOOST
#define LCD_W				128
#define LCD_H				64
#define LCD_Init			DOGM128_Init
#define LCD_Update			DOGM128_Update
#endif
#ifdef SUPPORT_NOKIA3310
#define LCD_W				84
#define LCD_H				48
#define LCD_Init			N3310_Init
#define LCD_Update			N3310_Update
#endif
#ifdef SUPPORT_SDLCD
#define LCD_W				240
#define LCD_H				184
#define LCD_Init			SDLCD_Init
#define LCD_Update			SDLCD_Update
#endif
#define BATT_W				20
#define BATT_X				LCD_W - BATT_W - 1
#define GLCD_SEL_LO			SPI_Select2_LO()
#define GLCD_SEL_HI			SPI_Select2_HI()
#define GLCD_DS_LO			SPI_AddressData_LO()
#define GLCD_DS_HI			SPI_AddressData_HI()
#define GLCD_RST_LO			SPI_Reset_LO()
#define GLCD_RST_HI			SPI_Reset_HI()
#define GLCD_Read			SPI_Read_Byte
#define GLCD_Write			SPI_Write_Byte

/* MMC-Setup */
#define MMC_SPI_Enable()		SPI_Select1_LO()
#define MMC_SPI_Disable()		SPI_Select1_HI()
#define MMC_SPI_Read_Byte		SPI_Read_Byte
#define MMC_SPI_Write_Byte		SPI_Write_Byte
#define MMC_Enable()			SPI_Select1_LO()
#define MMC_Disable()			SPI_Select1_HI()
#define MMC_SPI_Slow()			SPI_Slow()
#define MMC_SPI_Fast()			SPI_Fast()

/* Soft-SPI */
#define SUPPORT_HWSPI
#define HWSPI				SPI2
#define SPI_CLK_PORT			GPIOB
#define SPI_CLK_PIN			GPIO_Pin_13
#define SPI_MISO_PORT			GPIOB
#define SPI_MISO_PIN			GPIO_Pin_14
#define SPI_MOSI_PORT			GPIOB
#define SPI_MOSI_PIN			GPIO_Pin_15
#define SPI_SEL1_PORT			GPIOB
#define SPI_SEL1_PIN			GPIO_Pin_12
#define SPI_SEL2_PORT			GPIOB
#define SPI_SEL2_PIN			GPIO_Pin_9
#define SPI_SEL3_PORT			GPIOB
#define SPI_SEL3_PIN			GPIO_Pin_8
#define SPI_AD_PORT			GPIOC
#define SPI_AD_PIN			GPIO_Pin_10
#define SPI_RST_PORT			GPIOC
#define SPI_RST_PIN			GPIO_Pin_11
#define SPI_DELAY			delay(2)

/* Beeper-Setup */
#ifdef RCOS_MAINBOARD_V1_0
#define BEEPER_PORT			GPIOA
#define BEEPER_PIN			GPIO_Pin_15
#endif
#ifdef RCOS_MAINBOARD_FC16
#define BEEPER_PORT			GPIOC
#define BEEPER_PIN			GPIO_Pin_12
#endif

/* Analog-Input's */
#ifdef RCOS_MAINBOARD_V1_0
#define ADC_INPUT_LIST			{ADC_Channel_0, ADC_Channel_1, ADC_Channel_2, ADC_Channel_3, ADC_Channel_4, ADC_Channel_5, ADC_Channel_6, ADC_Channel_7, ADC_Channel_8, ADC_Channel_9, ADC_Channel_10, ADC_Channel_11, ADC_Channel_12, ADC_Channel_13, ADC_Channel_14, ADC_Channel_16}
#define ADC_INPUT_PINS_A		GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7
#define ADC_INPUT_PINS_B		GPIO_Pin_0 | GPIO_Pin_1
#define ADC_INPUT_PINS_C		GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4
#endif
#ifdef RCOS_MAINBOARD_FC16
#define ADC_INPUT_LIST			{ADC_Channel_14, ADC_Channel_1, ADC_Channel_0, ADC_Channel_12, ADC_Channel_13, ADC_Channel_4, ADC_Channel_2, ADC_Channel_5, ADC_Channel_6, ADC_Channel_7, ADC_Channel_8, ADC_Channel_9, ADC_Channel_10, ADC_Channel_11, ADC_Channel_3, ADC_Channel_16}
#define ADC_INPUT_PINS_A		GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7
#define ADC_INPUT_PINS_B		GPIO_Pin_0 | GPIO_Pin_1
#define ADC_INPUT_PINS_C		GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4
#endif

/* Digital-Input's */
#define RC_SW_START 30
#define RC_CONTROL_SW0_A_PORT	GPIOE
#define RC_CONTROL_SW0_A_PIN 	GPIO_Pin_0
#define RC_CONTROL_SW0_B_PORT	GPIOE
#define RC_CONTROL_SW0_B_PIN 	GPIO_Pin_1
#define RC_CONTROL_SW0_C_PORT	GPIOD
#define RC_CONTROL_SW0_C_PIN 	GPIO_Pin_7
#define RC_CONTROL_SW1_A_PORT	GPIOE
#define RC_CONTROL_SW1_A_PIN 	GPIO_Pin_2
#define RC_CONTROL_SW1_B_PORT	GPIOE
#define RC_CONTROL_SW1_B_PIN 	GPIO_Pin_3
#define RC_CONTROL_SW1_C_PORT	GPIOD
#define RC_CONTROL_SW1_C_PIN 	GPIO_Pin_6
#define RC_CONTROL_SW2_A_PORT	GPIOE
#define RC_CONTROL_SW2_A_PIN 	GPIO_Pin_4
#define RC_CONTROL_SW2_B_PORT	GPIOE
#define RC_CONTROL_SW2_B_PIN 	GPIO_Pin_5
#define RC_CONTROL_SW2_C_PORT	GPIOD
#define RC_CONTROL_SW2_C_PIN 	GPIO_Pin_5
#define RC_CONTROL_SW3_A_PORT	GPIOE
#define RC_CONTROL_SW3_A_PIN 	GPIO_Pin_6
#define RC_CONTROL_SW3_B_PORT	GPIOE
#define RC_CONTROL_SW3_B_PIN 	GPIO_Pin_7
#define RC_CONTROL_SW3_C_PORT	GPIOD
#define RC_CONTROL_SW3_C_PIN 	GPIO_Pin_4
#define RC_CONTROL_SW4_A_PORT	GPIOE
#define RC_CONTROL_SW4_A_PIN 	GPIO_Pin_8
#define RC_CONTROL_SW4_B_PORT	GPIOE
#define RC_CONTROL_SW4_B_PIN 	GPIO_Pin_9
#define RC_CONTROL_SW4_C_PORT	GPIOD
#define RC_CONTROL_SW4_C_PIN 	GPIO_Pin_3
#define RC_CONTROL_SW5_A_PORT	GPIOE
#define RC_CONTROL_SW5_A_PIN 	GPIO_Pin_10
#define RC_CONTROL_SW5_B_PORT	GPIOE
#define RC_CONTROL_SW5_B_PIN 	GPIO_Pin_11
#define RC_CONTROL_SW5_C_PORT	GPIOD
#define RC_CONTROL_SW5_C_PIN 	GPIO_Pin_1
#define RC_CONTROL_SW6_A_PORT	GPIOE
#define RC_CONTROL_SW6_A_PIN 	GPIO_Pin_12
#define RC_CONTROL_SW6_B_PORT	GPIOB
#define RC_CONTROL_SW6_B_PIN 	GPIO_Pin_5
#define RC_CONTROL_SW6_C_PORT	GPIOD
#define RC_CONTROL_SW6_C_PIN 	GPIO_Pin_0
#define RC_CONTROL_SW7_A_PORT	GPIOE
#define RC_CONTROL_SW7_A_PIN 	GPIO_Pin_14
#define RC_CONTROL_SW7_B_PORT	GPIOE
#define RC_CONTROL_SW7_B_PIN 	GPIO_Pin_15
#define RC_CONTROL_SW8_A_PORT	GPIOD
#define RC_CONTROL_SW8_A_PIN 	GPIO_Pin_15
#define RC_CONTROL_SW8_B_PORT	GPIOD
#define RC_CONTROL_SW8_B_PIN 	GPIO_Pin_14
#define RC_CONTROL_SW9_A_PORT	GPIOD
#define RC_CONTROL_SW9_A_PIN 	GPIO_Pin_13
#define RC_CONTROL_SW9_B_PORT	GPIOD
#define RC_CONTROL_SW9_B_PIN 	GPIO_Pin_12
#define RC_CONTROL_SW10_A_PORT	GPIOD
#define RC_CONTROL_SW10_A_PIN 	GPIO_Pin_11
#define RC_CONTROL_SW10_B_PORT	GPIOD
#define RC_CONTROL_SW10_B_PIN 	GPIO_Pin_10
#define RC_CONTROL_SW11_A_PORT	GPIOD
#define RC_CONTROL_SW11_A_PIN 	GPIO_Pin_9
#define RC_CONTROL_SW11_B_PORT	GPIOD
#define RC_CONTROL_SW11_B_PIN 	GPIO_Pin_8
#define RC_CONTROL_SW12_A_PORT	GPIOB
#define RC_CONTROL_SW12_A_PIN 	GPIO_Pin_3
#define RC_CONTROL_SW12_B_PORT	GPIOB
#define RC_CONTROL_SW12_B_PIN 	GPIO_Pin_4
#define RC_CONTROL_SW13_A_PORT	GPIOC
#define RC_CONTROL_SW13_A_PIN 	GPIO_Pin_5
#define RC_CONTROL_SW13_B_PORT	GPIOC
#define RC_CONTROL_SW13_B_PIN 	GPIO_Pin_7

#endif


