
#ifdef SUPPORT_LCD
#ifdef SUPPORT_HD44100

#ifndef HD44100_H
#define HD44100_H


#define LCD_DELAY1		delay_ms(10);
#define LCD_DELAY2		delay_ms(1);

#define LCD_Write_Port(cmd)	SPI_74xx595_Write(cmd);

/* over Shiftreg (74HC595) */
#define LCD_Pin_Rs		0
#define LCD_Pin_E		1
#define LCD_Pin_Data_0		2
#define LCD_Pin_Data_1		3
#define LCD_Pin_Data_2		4
#define LCD_Pin_Data_3		5

/* over I2C
#define LCD_Pin_Data_0		0
#define LCD_Pin_Data_1		1
#define LCD_Pin_Data_2		2
#define LCD_Pin_Data_3		3
#define LCD_Pin_Rs		4
#define LCD_Pin_E		5
*/


/* LCD commands (Text-Display's) */
#define LCD_CMD			0
#define LCD_CHAR		1
#define LCD_CLEAR		0x01
#define LCD_HOME		0x02
#define LCD_INC			0x06
#define LCD_OFF			0x08
#define LCD_CURSOR_LEFT		0x10
#define LCD_CURSOR_RIGHT	0x14
#define LCD_SCROLL_LEFT		0x18
#define LCD_ON			0x0C
#define LCD_ON_BLINK		0x0D
#define LCD_ON_CURSOR		0x0E
#define LCD_ON_BLINK_BLOCK	0x0F
#define LCD_SCROLL_RIGHT	0x1E
#define LCD_TYPE_4BIT_1LINE	0x20
#define LCD_TYPE_4BIT_2LINE	0x28
#define LCD_TYPE_8BIT_1LINE	0x30
#define LCD_TYPE_8BIT_2LINE	0x38
#define LCD_CGRAM(n)		(0x40 + ((n) << 3))
#define LCD_CGRAM_ADDR		0x40
#define LCD_DDRAM_ADDR		0x80
#define LCD_LINE_1		0x80
#define LCD_LINE_2		0xC0
#define LCD_LINE_3		0x90
#define LCD_LINE_4		0xd0


extern void LCD_Init(void);
extern void LCD_Clear (void);
extern void LCD_Write_Port(uint8_t cmd);
extern void LCD_Write(uint8_t Data, uint8_t Rs);
extern void LCD_Print (uint8_t zeile, uint8_t spalte, char *Buffer);

#endif

#endif
#endif

