
#include <stdint.h>
#include <string.h>
#include <rc.h>
#include <rc_adc.h>
#include <glcd.h>
#include <sdlcd.h>

#ifdef SUPPORT_LCD
#ifdef SUPPORT_SDLCD

#include <SDL.h>
#include <SDL_events.h>

SDL_Surface *Screen;
SDL_Event event;

#define OUT_W	300

uint16_t offset_x = 10;
uint16_t offset_y = 10;
uint16_t screen_w = LCD_W + 20 + OUT_W;
uint16_t screen_h = LCD_H + 20;



void SDLCD_Init (void) {
	if ((Screen = SDL_SetVideoMode(screen_w, screen_h, 32, SDL_SWSURFACE)) == NULL) {
		fprintf(stderr, "Couldn't set Video-Mode: %s\n", SDL_GetError());
		return -1;
	}
	boxRGBA(Screen, 0, 0, screen_w, screen_h, 64, 64, 64, 255);
	SDL_UpdateRect(Screen, 0, 0, 0, 0);
	SDL_WM_SetCaption("rCos-sim", "rCos-sim");
}

void SDLCD_Update (void) {
	uint16_t n;
	uint16_t n2;
	uint16_t n3;
	uint8_t h2 = LCD_H / 8;
	for (n = 0; n < h2; n++) {
		for (n2 = 0; n2 < 8; n2++) {
			for (n3 = 0; n3 < LCD_W; n3++) {
				if (Framebuffer[n * LCD_W + n3] & (1<<n2)) {
					boxRGBA(Screen, offset_x + n3, offset_y + n * 8 + n2, offset_x + n3 + 1, offset_y + n * 8 + n2 + 1, Rc_Model_forecolor, Rc_Model_forecolor / 2 + 128, 255 - Rc_Model_forecolor, 255);
				} else {
					boxRGBA(Screen, offset_x + n3, offset_y + n * 8 + n2, offset_x + n3 + 1, offset_y + n * 8 + n2 + 1, Rc_Model_backcolor + n, Rc_Model_backcolor / 2 + 128, n * 255 / (LCD_H / 8), 255);
				}
			}
		}
	}

	boxRGBA(Screen, LCD_W + 20, 0, screen_w, screen_h, 200, 200, 200, 255);
	for (n = 0; n < 8; n++) {
		boxRGBA(Screen, LCD_W + 20 + (OUT_W / 2), (LCD_H / 20) + n * (LCD_H / 8), LCD_W + 20 + (OUT_W / 2) + (Rc_Output_value[n] / 16), (LCD_H / 20) + n * (LCD_H / 8) + (LCD_H / 10), 23, 123, 123, 255);
		rectangleRGBA(Screen, LCD_W + 20 + (OUT_W / 2) - 64, (LCD_H / 20) + n * (LCD_H / 8), LCD_W + 20 + (OUT_W / 2) + 64, (LCD_H / 20) + n * (LCD_H / 8) + (LCD_H / 10), 23, 123, 23, 255);
		stringRGBA(Screen, LCD_W + 20 + (OUT_W / 2) - 60, (LCD_H / 20) + n * (LCD_H / 8) + 5, Rc_Output_name[n], 0, 0, 220, 255);
	}


	SDL_UpdateRect(Screen, 0, 0, 0, 0);
	SDL_Delay(40);
}

#endif
#endif

