/*
Copyright (C) 2008-2009  Oliver Dippel <o.dippel@gmx.de>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

On Debian GNU/Linux systems, the complete text of the GNU General
Public License can be found in `/usr/share/common-licenses/GPL'.
*/

#include "rc.h"
#include "rc_adc.h"
#include "rc_control.h"

int8_t ControlRead (uint8_t id) {
	int8_t new_value;
	if (id == CONTROL_OFF) {
		new_value = 0;
	} else if (id == CONTROL_ON) {
		new_value = 100;
	} else if (id < INPUT_ADC_MAX + 1) {
		int16_t v1;
		v1 = Rc_AdcRead(id) * 128 / 1024;
		if (v1 > 127) {
			v1 = 127;
		} else if (v1 < -127) {
			v1 = -127;
		}
		new_value = v1;
	} else {
		new_value = Rc_Control_value[id];
	}
	return new_value;
}

void ControlWrite (int8_t id, int8_t value) {
	Rc_Control_value[id] = value;
}

void Rc_ControlInit (void) {
	uint8_t num;
	for (num = 0; num < 255; num++) {
		Rc_Control_value[num] = 0;
	}
	return;
}















