/*
	Don't edit this file: rc_drv_stm32/rc_switches.c
	it is generated by: scripts/pins_txt2switches_c.sh
*/

/*
Copyright (C) 2008-2009  Oliver Dippel <o.dippel@gmx.de>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

On Debian GNU/Linux systems, the complete text of the GNU General
Public License can be found in `/usr/share/common-licenses/GPL'.
*/

#include <stdint.h>
#include <string.h>
#include <rc.h>
#include <rc_shiftreg.h>
#include <rc_ppm-encoder.h>
#include <rc_adc.h>
#include <rc_control.h>
#include <rc_systick.h>
#include <rc_sd.h>
#include <spi_sw.h>

#ifdef PLATFORM_STM32
#define RC_SW_START 30
#define RC_CONTROL_SW0_A_PORT	GPIOE
#define RC_CONTROL_SW0_A_PIN 	GPIO_Pin_0
#define RC_CONTROL_SW0_B_PORT	GPIOE
#define RC_CONTROL_SW0_B_PIN 	GPIO_Pin_1
#define RC_CONTROL_SW0_C_PORT	GPIOD
#define RC_CONTROL_SW0_C_PIN 	GPIO_Pin_7
#define RC_CONTROL_SW1_A_PORT	GPIOE
#define RC_CONTROL_SW1_A_PIN 	GPIO_Pin_2
#define RC_CONTROL_SW1_B_PORT	GPIOE
#define RC_CONTROL_SW1_B_PIN 	GPIO_Pin_3
#define RC_CONTROL_SW1_C_PORT	GPIOD
#define RC_CONTROL_SW1_C_PIN 	GPIO_Pin_6
#define RC_CONTROL_SW2_A_PORT	GPIOE
#define RC_CONTROL_SW2_A_PIN 	GPIO_Pin_4
#define RC_CONTROL_SW2_B_PORT	GPIOE
#define RC_CONTROL_SW2_B_PIN 	GPIO_Pin_5
#define RC_CONTROL_SW2_C_PORT	GPIOD
#define RC_CONTROL_SW2_C_PIN 	GPIO_Pin_5
#define RC_CONTROL_SW3_A_PORT	GPIOE
#define RC_CONTROL_SW3_A_PIN 	GPIO_Pin_6
#define RC_CONTROL_SW3_B_PORT	GPIOE
#define RC_CONTROL_SW3_B_PIN 	GPIO_Pin_7
#define RC_CONTROL_SW3_C_PORT	GPIOD
#define RC_CONTROL_SW3_C_PIN 	GPIO_Pin_4
#define RC_CONTROL_SW4_A_PORT	GPIOE
#define RC_CONTROL_SW4_A_PIN 	GPIO_Pin_8
#define RC_CONTROL_SW4_B_PORT	GPIOE
#define RC_CONTROL_SW4_B_PIN 	GPIO_Pin_9
#define RC_CONTROL_SW4_C_PORT	GPIOD
#define RC_CONTROL_SW4_C_PIN 	GPIO_Pin_3
#define RC_CONTROL_SW5_A_PORT	GPIOE
#define RC_CONTROL_SW5_A_PIN 	GPIO_Pin_10
#define RC_CONTROL_SW5_B_PORT	GPIOE
#define RC_CONTROL_SW5_B_PIN 	GPIO_Pin_11
#define RC_CONTROL_SW5_C_PORT	GPIOD
#define RC_CONTROL_SW5_C_PIN 	GPIO_Pin_1
#define RC_CONTROL_SW6_A_PORT	GPIOE
#define RC_CONTROL_SW6_A_PIN 	GPIO_Pin_12
#define RC_CONTROL_SW6_B_PORT	GPIOB
#define RC_CONTROL_SW6_B_PIN 	GPIO_Pin_5
#define RC_CONTROL_SW6_C_PORT	GPIOD
#define RC_CONTROL_SW6_C_PIN 	GPIO_Pin_0
#define RC_CONTROL_SW7_A_PORT	GPIOE
#define RC_CONTROL_SW7_A_PIN 	GPIO_Pin_14
#define RC_CONTROL_SW7_B_PORT	GPIOE
#define RC_CONTROL_SW7_B_PIN 	GPIO_Pin_15
#define RC_CONTROL_SW8_A_PORT	GPIOD
#define RC_CONTROL_SW8_A_PIN 	GPIO_Pin_15
#define RC_CONTROL_SW8_B_PORT	GPIOD
#define RC_CONTROL_SW8_B_PIN 	GPIO_Pin_14
#define RC_CONTROL_SW9_A_PORT	GPIOD
#define RC_CONTROL_SW9_A_PIN 	GPIO_Pin_13
#define RC_CONTROL_SW9_B_PORT	GPIOD
#define RC_CONTROL_SW9_B_PIN 	GPIO_Pin_12
#define RC_CONTROL_SW10_A_PORT	GPIOD
#define RC_CONTROL_SW10_A_PIN 	GPIO_Pin_11
#define RC_CONTROL_SW10_B_PORT	GPIOD
#define RC_CONTROL_SW10_B_PIN 	GPIO_Pin_10
#define RC_CONTROL_SW11_A_PORT	GPIOD
#define RC_CONTROL_SW11_A_PIN 	GPIO_Pin_9
#define RC_CONTROL_SW11_B_PORT	GPIOD
#define RC_CONTROL_SW11_B_PIN 	GPIO_Pin_8
#define RC_CONTROL_SW12_A_PORT	GPIOB
#define RC_CONTROL_SW12_A_PIN 	GPIO_Pin_3
#define RC_CONTROL_SW12_B_PORT	GPIOB
#define RC_CONTROL_SW12_B_PIN 	GPIO_Pin_4
#define RC_CONTROL_SW13_A_PORT	GPIOC
#define RC_CONTROL_SW13_A_PIN 	GPIO_Pin_5
#define RC_CONTROL_SW13_B_PORT	GPIOC
#define RC_CONTROL_SW13_B_PIN 	GPIO_Pin_7
#endif


enum {
	RC_SWITCH_TYPE_UPDOWN,
	RC_SWITCH_TYPE_ONOFF,
	RC_SWITCH_TYPE_ONOFFON,
	RC_SWITCH_TYPE_ENCODER,
};

char switch_type[CONTROL_MAX];

void switches_init (void) {
#ifdef PLATFORM_STM32
	GPIO_InitTypeDef GPIO_InitStructure;
	switch_type[RC_SW_START + 0] = RC_SWITCH_TYPE_ENCODER;
	switch_type[RC_SW_START + 1] = RC_SWITCH_TYPE_ENCODER;
	switch_type[RC_SW_START + 2] = RC_SWITCH_TYPE_ENCODER;
	switch_type[RC_SW_START + 3] = RC_SWITCH_TYPE_ENCODER;
	switch_type[RC_SW_START + 4] = RC_SWITCH_TYPE_ENCODER;
	switch_type[RC_SW_START + 5] = RC_SWITCH_TYPE_ENCODER;
	switch_type[RC_SW_START + 6] = RC_SWITCH_TYPE_ENCODER;
	switch_type[RC_SW_START + 7] = RC_SWITCH_TYPE_ONOFFON;
	switch_type[RC_SW_START + 8] = RC_SWITCH_TYPE_ONOFFON;
	switch_type[RC_SW_START + 9] = RC_SWITCH_TYPE_ONOFFON;
	switch_type[RC_SW_START + 10] = RC_SWITCH_TYPE_ONOFFON;
	switch_type[RC_SW_START + 11] = RC_SWITCH_TYPE_ONOFFON;
	switch_type[RC_SW_START + 12] = RC_SWITCH_TYPE_ONOFFON;
	switch_type[RC_SW_START + 13] = RC_SWITCH_TYPE_ONOFFON;

	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW12_A_PIN | RC_CONTROL_SW12_B_PIN | RC_CONTROL_SW6_B_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW13_A_PIN | RC_CONTROL_SW13_B_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(GPIOC, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW6_C_PIN | RC_CONTROL_SW5_C_PIN | RC_CONTROL_SW4_C_PIN | RC_CONTROL_SW3_C_PIN | RC_CONTROL_SW2_C_PIN | RC_CONTROL_SW1_C_PIN | RC_CONTROL_SW0_C_PIN | RC_CONTROL_SW11_B_PIN | RC_CONTROL_SW11_A_PIN | RC_CONTROL_SW10_B_PIN | RC_CONTROL_SW10_A_PIN | RC_CONTROL_SW9_B_PIN | RC_CONTROL_SW9_A_PIN | RC_CONTROL_SW8_B_PIN | RC_CONTROL_SW8_A_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(GPIOD, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW0_A_PIN | RC_CONTROL_SW0_B_PIN | RC_CONTROL_SW1_A_PIN | RC_CONTROL_SW1_B_PIN | RC_CONTROL_SW2_A_PIN | RC_CONTROL_SW2_B_PIN | RC_CONTROL_SW3_A_PIN | RC_CONTROL_SW3_B_PIN | RC_CONTROL_SW4_A_PIN | RC_CONTROL_SW4_B_PIN | RC_CONTROL_SW5_A_PIN | RC_CONTROL_SW5_B_PIN | RC_CONTROL_SW6_A_PIN | RC_CONTROL_SW7_A_PIN | RC_CONTROL_SW7_B_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(GPIOE, &GPIO_InitStructure);
#endif
}

void switch_update (uint8_t control_num, uint8_t type, uint8_t pins, uint8_t a, uint8_t b, uint8_t c) {
	if (pins >= 2 && type == RC_SWITCH_TYPE_UPDOWN) {
		if (a == 0) {
			Rc_Control_value[control_num]--;
		} else if (b == 0) {
			Rc_Control_value[control_num]++;
		} else if (pins >= 3 && c == 0) {
			Rc_Control_value[control_num] = 0;
		}
	} else if (pins >= 1 && type == RC_SWITCH_TYPE_ONOFF) {
		if (a == 0) {
			Rc_Control_value[control_num] = 127;
		} else if (pins >= 2 && b == 0) {
			Rc_Control_value[control_num] = -127;
		} else if (pins >= 3 && c == 0) {
			Rc_Control_value[control_num] = 0;
		}
	} else if (pins >= 1 && type == RC_SWITCH_TYPE_ONOFFON) {
		if (a == 0) {
			Rc_Control_value[control_num] = 127;
		} else if (pins >= 2 && b == 0) {
			Rc_Control_value[control_num] = -127;
		} else {
			Rc_Control_value[control_num] = 0;
		}
	} else if (pins >= 2 && type == RC_SWITCH_TYPE_ENCODER) {
		uint8_t enc_data = 0;
		if (a != 0) {
			enc_data |= 1;
		}
		if (b != 0) {
			enc_data |= 2;
		}
		if (pins >= 3 && c != 0) {
			enc_data |= 4;
		}
		Rc_REncoderDecode_byte(enc_data, 0, 1, 2, control_num);
	}
}

void switches_check (void) {
#ifdef PLATFORM_STM32
	switch_update(RC_SW_START + 1, switch_type[RC_SW_START + 1], 3, GPIO_ReadInputDataBit(RC_CONTROL_SW1_A_PORT, RC_CONTROL_SW1_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW1_B_PORT, RC_CONTROL_SW1_B_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW1_C_PORT, RC_CONTROL_SW1_C_PIN));
	switch_update(RC_SW_START + 2, switch_type[RC_SW_START + 2], 3, GPIO_ReadInputDataBit(RC_CONTROL_SW2_A_PORT, RC_CONTROL_SW2_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW2_B_PORT, RC_CONTROL_SW2_B_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW2_C_PORT, RC_CONTROL_SW2_C_PIN));
	switch_update(RC_SW_START + 3, switch_type[RC_SW_START + 3], 3, GPIO_ReadInputDataBit(RC_CONTROL_SW3_A_PORT, RC_CONTROL_SW3_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW3_B_PORT, RC_CONTROL_SW3_B_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW3_C_PORT, RC_CONTROL_SW3_C_PIN));
	switch_update(RC_SW_START + 4, switch_type[RC_SW_START + 4], 3, GPIO_ReadInputDataBit(RC_CONTROL_SW4_A_PORT, RC_CONTROL_SW4_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW4_B_PORT, RC_CONTROL_SW4_B_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW4_C_PORT, RC_CONTROL_SW4_C_PIN));
	switch_update(RC_SW_START + 5, switch_type[RC_SW_START + 5], 3, GPIO_ReadInputDataBit(RC_CONTROL_SW5_A_PORT, RC_CONTROL_SW5_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW5_B_PORT, RC_CONTROL_SW5_B_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW5_C_PORT, RC_CONTROL_SW5_C_PIN));
	switch_update(RC_SW_START + 6, switch_type[RC_SW_START + 6], 3, GPIO_ReadInputDataBit(RC_CONTROL_SW6_A_PORT, RC_CONTROL_SW6_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW6_B_PORT, RC_CONTROL_SW6_B_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW6_C_PORT, RC_CONTROL_SW6_C_PIN));
	switch_update(RC_SW_START + 7, switch_type[RC_SW_START + 7], 2, GPIO_ReadInputDataBit(RC_CONTROL_SW7_A_PORT, RC_CONTROL_SW7_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW7_B_PORT, RC_CONTROL_SW7_B_PIN), 0);
	switch_update(RC_SW_START + 8, switch_type[RC_SW_START + 8], 2, GPIO_ReadInputDataBit(RC_CONTROL_SW8_A_PORT, RC_CONTROL_SW8_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW8_B_PORT, RC_CONTROL_SW8_B_PIN), 0);
	switch_update(RC_SW_START + 9, switch_type[RC_SW_START + 9], 2, GPIO_ReadInputDataBit(RC_CONTROL_SW9_A_PORT, RC_CONTROL_SW9_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW9_B_PORT, RC_CONTROL_SW9_B_PIN), 0);
	switch_update(RC_SW_START + 10, switch_type[RC_SW_START + 10], 2, GPIO_ReadInputDataBit(RC_CONTROL_SW10_A_PORT, RC_CONTROL_SW10_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW10_B_PORT, RC_CONTROL_SW10_B_PIN), 0);
	switch_update(RC_SW_START + 11, switch_type[RC_SW_START + 11], 2, GPIO_ReadInputDataBit(RC_CONTROL_SW11_A_PORT, RC_CONTROL_SW11_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW11_B_PORT, RC_CONTROL_SW11_B_PIN), 0);
	switch_update(RC_SW_START + 12, switch_type[RC_SW_START + 12], 2, GPIO_ReadInputDataBit(RC_CONTROL_SW12_A_PORT, RC_CONTROL_SW12_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW12_B_PORT, RC_CONTROL_SW12_B_PIN), 0);
	switch_update(RC_SW_START + 13, switch_type[RC_SW_START + 13], 2, GPIO_ReadInputDataBit(RC_CONTROL_SW13_A_PORT, RC_CONTROL_SW13_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW13_B_PORT, RC_CONTROL_SW13_B_PIN), 0);
#endif
}

