/*
Copyright (C) 2008  Oliver Dippel <o.dippel@gmx.de>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

On Debian GNU/Linux systems, the complete text of the GNU General
Public License can be found in `/usr/share/common-licenses/GPL'.
*/

#include <rc.h>


void MotionTimer_reset (void) {
#ifdef PLATFORM_STM32
	SysTick_CounterCmd(SysTick_Counter_Disable);
	SysTick_CounterCmd(SysTick_Counter_Clear);
	SysTick_CounterCmd(SysTick_Counter_Enable);
#endif
}

#ifdef PLATFORM_STM32
void SysTickHandler (void) {
	uint8_t n = 0;
	MotionTimer++;
	SystemTimer++;
	for (n = 0; n < TIMER_MAX; n++) {
		if (SystemTimer_stat[n] != 0) {
			SystemTimer_time[n]++;
		}
	}
}
#endif

#ifdef PLATFORM_SDL
Uint32 SDLCALL SysTickHandler (Uint32 interval) {
	uint8_t n = 0;
	MotionTimer += 10;
	SystemTimer += 10;
	for (n = 0; n < TIMER_MAX; n++) {
		if (SystemTimer_stat[n] != 0) {
			SystemTimer_time[n] += 10;
		}
	}
	return(interval);
}
#endif

void init_systick (void) {
#ifdef PLATFORM_STM32
	SysTick_SetReload(8000);
	SysTick_ITConfig(ENABLE);
	SysTick_CounterCmd(SysTick_Counter_Enable);
#endif
#ifdef PLATFORM_SDL
	SDL_SetTimer(1, SysTickHandler);
#endif
}


