
#ifndef SD_H
#define SD_H

enum {
	MMC_CARD_NONE,
	MMC_CARD_UNKNOWN,
	MMC_CARD_MMC,
	MMC_CARD_SD,
	MMC_CARD_SDHC,
};

enum {
	MMC_OK,
	MMC_CMD0_TIMEOUT,
	MMC_CMD1_TIMEOUT,
	MMC_CMD41_TIMEOUT,
	MMC_CSD_ERROR,
	MMC_PATTERN_ERROR,
	MMC_VOLTAGE_ERROR,
	MMC_SET_BLOCKLEN_ERROR,
};

#define MMC_IDLE_STATE		1
#define MMC_ILLEGAL_COMMAND	4
#define MMC_BYTE_PER_SEC	512
#define MMC_START_BLOCK_TOKEN	0xFE
#define MMC_INIT		(0x40 + 1)
#define MMC_RESET		(0x40 + 0)
#define MMC_CMD0		(0x40 + 0)
#define MMC_CMD1		(0x40 + 1)
#define MMC_CMD8		(0x40 + 8)
#define MMC_READ_CSD		(0x40 + 9)
#define MMC_READ_CID		(0x40 + 10)
#define MMC_STOP_TRANSMISSION	(0x40 + 12)
#define MMC_SEND_STATUS		(0x40 + 13)
#define MMC_SET_BLOCKLEN	(0x40 + 16)
#define MMC_READ_BLOCK		(0x40 + 17)
#define MMC_READ_MULTI_BLOCK	(0x40 + 18)
#define MMC_WRITE_BLOCK		(0x40 + 24)
#define MMC_WRITE_MULTI_BLOCK	(0x40 + 25)
#define MMC_CMD41		(0x40 + 41)
#define MMC_CMD55		(0x40 + 55)
#define MMC_CMD58		(0x40 + 58)

extern uint8_t mmc_autocheck (void);
extern uint8_t mmc_send_cmd (uint8_t command, unsigned long adress);
extern uint8_t mmc_read_sector (unsigned long sector, uint8_t *buffer);
extern uint8_t mmc_write_sector (unsigned long sector, uint8_t *buffer);
extern uint8_t mmc_init (void);
#endif

