/*
Copyright (C) 2008-2009  Oliver Dippel <o.dippel@gmx.de>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

On Debian GNU/Linux systems, the complete text of the GNU General
Public License can be found in `/usr/share/common-licenses/GPL'.
*/

#include <stdint.h>
#include <rc.h>
#include <sound.h>

uint8_t beeper_count = 0;
uint16_t beeper_freq = 10;
uint8_t beeper_len = 2;

void beep (uint16_t freq, uint8_t len) {
	beeper_count = 0;
	beeper_freq = freq;
	beeper_len = 2;
}

void sound (uint16_t freq, uint8_t len) {
#ifdef PLATFORM_STM32
	uint8_t n;
	uint16_t delay;
	for (n = 0; n < len; n++) {
		GPIO_SetBits(BEEPER_PORT, BEEPER_PIN);
		for (delay = freq; delay > 0; delay--) {
			asm volatile ("nop");
		}
		GPIO_ResetBits(BEEPER_PORT, BEEPER_PIN);
		for (delay = freq; delay > 0; delay--) {
			asm volatile ("nop");
		}
	}
#endif
}

void sound_init (void) {
#ifdef PLATFORM_STM32
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = BEEPER_PIN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(BEEPER_PORT, &GPIO_InitStructure);
#endif
	sound(1250, 100);
}

