/*
Copyright (C) 2008  Oliver Dippel <o.dippel@gmx.de>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

On Debian GNU/Linux systems, the complete text of the GNU General
Public License can be found in `/usr/share/common-licenses/GPL'.
*/

#include <string.h>
#include <rc.h>
#include <sd.h>

#ifdef SUPPORT_USART

uint8_t TxBuffer2[10];
volatile uint16_t TxCounter2 = 0;
uint16_t NbrOfDataToTransfer2 = 0;


void init_usart2 (void) {
	/* Configure USART2 Rx as input floating */
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* Configure USART2 Tx as alternate function push-pull */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* Enable the USART2 Interrupt */
	NVIC_InitTypeDef NVIC_InitStructure;
	NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQChannel;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 4;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 4;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	USART_InitTypeDef USART_InitStructure;
	USART_InitStructure.USART_BaudRate = 115200;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART2, &USART_InitStructure);

	USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);
	USART_ITConfig(USART2, USART_IT_TXE, DISABLE);
	USART_Cmd(USART2, ENABLE);
}

void USART2_SEND (char *data, uint16_t count) {
	memcpy(&TxBuffer2, data, count);
	NbrOfDataToTransfer2 = count;
	TxCounter2 = 0;
	USART_ITConfig(USART2, USART_IT_TXE, ENABLE);
}

void USART2_SEND_STR (char *data) {
	uint16_t count = strlen(data);
	memcpy(&TxBuffer2, data, count);
	NbrOfDataToTransfer2 = count;
	TxCounter2 = 0;
	USART_ITConfig(USART2, USART_IT_TXE, ENABLE);
}

void USART2_IRQHandler (void) {
	uint8_t RX;
	if(USART_GetITStatus(USART2, USART_IT_TXE) != RESET) {
		USART_SendData(USART2, TxBuffer2[TxCounter2++]);
		if(TxCounter2 == NbrOfDataToTransfer2) {
			USART_ITConfig(USART2, USART_IT_TXE, DISABLE);
			NbrOfDataToTransfer2 = 0;
			TxCounter2 = 0;
		}    
	}
	if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET) {
		RX = USART_ReceiveData(USART2);
	}
}

#endif
