
#ifdef SUPPORT_LCD

#ifndef GLCD_H
#define GLCD_H

#define MENU_HEIGHT	((LCD_H - 20) / 10)

extern char input_name[16][16];
extern char output_name[16][16];
extern uint8_t Framebuffer[((LCD_W * LCD_H) / 8)];
extern uint8_t *font[];
extern const uint8_t font_w[];
extern const uint8_t font_h[];
extern uint8_t font_num;

/* Pin-Setup-Default's */
#define GLCD_SEL_LO		SPI_Select2_LO()
#define GLCD_SEL_HI		SPI_Select2_HI()
#define GLCD_DS_LO		SPI_AddressData_LO()
#define GLCD_DS_HI		SPI_AddressData_HI()
#define GLCD_RST_LO		SPI_Reset_LO()
#define GLCD_RST_HI		SPI_Reset_HI()
#define GLCD_Read		SPI_Read_Byte
#define GLCD_Write		SPI_Write_Byte

#define LCD_CMD			0
#define LCD_DATA		1

#define LCD_TRANS		0
#define LCD_WHITE		1
#define LCD_BLACK		2
#define LCD_XOR			3

void LCD_Font(uint8_t num);
inline void LCD_Clear (void);
void LCD_Pixel (uint8_t x, uint8_t y, uint8_t data);
uint8_t LCD_Write (uint8_t x, uint8_t y, uint8_t ch, uint8_t fg, uint8_t bg);
uint8_t LCD_CheckWidth (char ch);
uint8_t LCD_CheckStrWidth (char *text);
uint8_t LCD_Print_Center (uint8_t y, char *text, uint8_t fg, uint8_t bg);
uint8_t LCD_Print_Right (uint8_t y, char *text, uint8_t fg, uint8_t bg);
uint8_t LCD_PrintXY (uint8_t x, uint8_t y, char *text, uint8_t fg, uint8_t bg);
void LCD_Icon (uint8_t x, uint8_t y, uint8_t w, uint8_t h, char *icon_data, char color);
void LCD_Draw_Rec (uint16_t xstart, uint16_t ystart, uint16_t width, uint16_t height);
void LCD_Draw_Box (uint16_t xstart, uint16_t ystart, uint16_t width, uint16_t height);
void LCD_Draw_BoxInverted (uint16_t xstart, uint16_t ystart, uint16_t width, uint16_t height);
void LCD_Bar (uint8_t pos_x, uint8_t pos_y, uint8_t w, uint8_t h, uint8_t percent, char *text);
void LCD_Header (char *text);
void LCD_Draw_Line(uint8_t px1, uint8_t py1, uint8_t px2, uint8_t py2, uint8_t color);


#endif
#endif
