
#include <stdint.h>
#include <string.h>
#include <rc.h>
#include <glcd.h>
#include <rc_adc.h>
#include <rc_control.h>
#include <rc_menu_support.h>
#include <rc_sd.h>

#ifdef SUPPORT_MENU

const char *name_ok = "Ok";
const char *name_back = "Back";
static const char *name_aileron = "Querruder";
static const char *name_aileron1 = "Querruder R";
static const char *name_aileron2 = "Querruder L";
static const char *name_elevator = "Hohenruder";
static const char *name_elevator1 = "Hohenruder R";
static const char *name_elevator2 = "Hohenruder L";
static const char *name_rudder = "Seitenruder";
static const char *name_throttle = "Drossel";
static const char *name_flaps = "Landeklappen";
static const char *name_nick = "Nick";
static const char *name_pitch = "Pitch";
static const char *name_roll = "Roll";
static const char *name_roll1 = "Roll-Rechts";
static const char *name_roll2 = "Roll-Links";

extern uint8_t redraw;

void print_mixer (uint8_t offset_x, uint8_t offset_y, uint8_t width, uint8_t height, uint8_t id, uint8_t point, uint8_t xy) {
	uint8_t n;
	uint8_t x;
	uint8_t y;
	uint8_t last_x = 0;
	uint8_t last_y = 0;

	if (xy != 2) {
		for (n = 0; n < MIXER_POINTS_MAX; n++) {
			char tmp_str[10];
			if (n == point) {
				if (xy == 0) {
					LCD_PrintXY(offset_x, offset_y + n * 6, ">", LCD_XOR, LCD_TRANS);
				} else {
					LCD_PrintXY(offset_x + 18, offset_y + n * 6, ">", LCD_XOR, LCD_TRANS);
				}
			}
			LCD_PrintXY(offset_x + 5, offset_y + n * 6, (char *)int2str((char *)tmp_str, Rc_Mixer_point[id][n][1], 0), LCD_XOR, LCD_TRANS);
			LCD_PrintXY(offset_x + 23, offset_y + n * 6, (char *)int2str((char *)tmp_str, Rc_Mixer_point[id][n][0], 0), LCD_XOR, LCD_TRANS);
		}
	}

	offset_x += 35;
	width -= 35;

	for (n = offset_x; n < offset_x + width; n++) {
		LCD_Pixel(n, offset_y, 1);
		LCD_Pixel(n, offset_y + height - 1, 1);
	}
	for (n = offset_y; n < offset_y + height; n++) {
		LCD_Pixel(offset_x, n, 1);
		LCD_Pixel(offset_x + width - 1, n, 1);
	}
	x = Rc_Mixer_point[id][0][0] * (width - 2) / 100 + 1;
	y = Rc_Mixer_point[id][0][1] * (height - 2) / 100 + 1;

	last_x = x;
	last_y = y;
	for (n = 0; n < MIXER_POINTS_MAX; n++) {
		x = Rc_Mixer_point[id][n][0] * (width - 2) / 100 + 1;
		y = (Rc_Mixer_point[id][n][1] * (height - 2) / 100 + 1);
		y = (y - (height / 2)) * ControlSet(Rc_Mixer_percent_control[id], Rc_Mixer_percent_value[id]) / 100 + (height / 2);
		if (n == point) {
			if (xy == 1) {
				LCD_Pixel(offset_x + x + 6, offset_y + y, LCD_WHITE);
				LCD_Pixel(offset_x + x - 6, offset_y + y, LCD_WHITE);
			} else {
				LCD_Pixel(offset_x + x, offset_y + y + 6, LCD_WHITE);
				LCD_Pixel(offset_x + x, offset_y + y - 6, LCD_WHITE);
			}
			LCD_Pixel(offset_x + x + 4, offset_y + y, LCD_WHITE);
			LCD_Pixel(offset_x + x + 3, offset_y + y, LCD_WHITE);
			LCD_Pixel(offset_x + x + 2, offset_y + y, LCD_WHITE);
			LCD_Pixel(offset_x + x + 1, offset_y + y, LCD_WHITE);
			LCD_Pixel(offset_x + x - 1, offset_y + y, LCD_WHITE);
			LCD_Pixel(offset_x + x - 2, offset_y + y, LCD_WHITE);
			LCD_Pixel(offset_x + x - 3, offset_y + y, LCD_WHITE);
			LCD_Pixel(offset_x + x - 4, offset_y + y, LCD_WHITE);
			LCD_Pixel(offset_x + x, offset_y + y + 4, LCD_WHITE);
			LCD_Pixel(offset_x + x, offset_y + y + 3, LCD_WHITE);
			LCD_Pixel(offset_x + x, offset_y + y + 2, LCD_WHITE);
			LCD_Pixel(offset_x + x, offset_y + y + 1, LCD_WHITE);
			LCD_Pixel(offset_x + x, offset_y + y - 1, LCD_WHITE);
			LCD_Pixel(offset_x + x, offset_y + y - 2, LCD_WHITE);
			LCD_Pixel(offset_x + x, offset_y + y - 3, LCD_WHITE);
			LCD_Pixel(offset_x + x, offset_y + y - 4, LCD_WHITE);
		}
		LCD_Draw_Line(offset_x + last_x, offset_y + last_y, offset_x + x, offset_y + y, LCD_WHITE);
		last_x = x;
		last_y = y;
	}
	x = (Rc_Control_buffer[Rc_Mixer_channel_in[id]] / 8 + 127) * (width - 2) / 255 + 1;
	y = (Rc_Output_value[Rc_Mixer_channel_out[id]] / 8 + 127) * (height - 2) / 255 + 1;
	LCD_Draw_Line(offset_x + x, offset_y, offset_x + x, offset_y + height, LCD_WHITE);
	LCD_Draw_Line(offset_x, offset_y + y, offset_x + width, offset_y + y, LCD_WHITE);
	y = ControlSet(Rc_Mixer_percent_control[id], Rc_Mixer_percent_value[id]) * (height - 2) / 200;
	for (n = offset_x; n < offset_x + width; n += 2) {
		LCD_Pixel(n, offset_y + (height / 2) + y - 1, LCD_WHITE);
		LCD_Pixel(n, offset_y + (height / 2) - y - 1, LCD_WHITE);
	}
	for (n = 0; n < MIXER_POINTS_MAX; n++) {
		x = Rc_Mixer_point[id][n][0] * (width - 2) / 100 + 1;
		y = (Rc_Mixer_point[id][n][1] * (height - 2) / 100 + 1);
		y = (y - (height / 2)) * ControlSet(Rc_Mixer_percent_control[id], Rc_Mixer_percent_value[id]) / 100 + (height / 2);
		if (n == point) {
			char tmp_str[10];
			if (y < (height / 2)) {
				LCD_Draw_Box(offset_x + x, offset_y + y, 20, 7);
				LCD_PrintXY(offset_x + x + 1, offset_y + y + 1, (char *)int2str((char *)tmp_str, Rc_Mixer_point[id][n][0], 0), LCD_XOR, LCD_TRANS);
				LCD_PrintXY(offset_x + x + 12, offset_y + y + 1, (char *)int2str((char *)tmp_str, Rc_Mixer_point[id][n][1], 0), LCD_XOR, LCD_TRANS);
			} else {
				LCD_Draw_Box(offset_x + x - 20, offset_y + y - 7, 20, 7);
				LCD_PrintXY(offset_x + x + 1 - 20, offset_y + y + 1 - 7, (char *)int2str((char *)tmp_str, Rc_Mixer_point[id][n][0], 0), LCD_XOR, LCD_TRANS);
				LCD_PrintXY(offset_x + x + 12 - 20, offset_y + y + 1 - 7, (char *)int2str((char *)tmp_str, Rc_Mixer_point[id][n][1], 0), LCD_XOR, LCD_TRANS);
			}
			break;
		}
	}
	LCD_Font(1);
}

void print_bar (uint8_t offset_x, uint8_t offset_y, uint8_t width, uint8_t height, uint8_t value) {
	uint8_t n;
	LCD_Draw_Line(offset_x, offset_y, offset_x + width, offset_y, LCD_XOR);
	LCD_Draw_Line(offset_x, offset_y + height, offset_x + width, offset_y + height, LCD_XOR);
	LCD_Draw_Line(offset_x, offset_y, offset_x, offset_y + height, LCD_XOR);
	LCD_Draw_Line(offset_x + width, offset_y, offset_x + width, offset_y + height, LCD_XOR);
	LCD_Draw_Line(offset_x + (value * width / 255), offset_y, offset_x + (value * width / 255), offset_y + height, LCD_XOR);
	for (n = offset_y; n < offset_y + height; n += 2) {
		LCD_Pixel(offset_x + (width / 2), n, LCD_XOR);
	}
}

void print_control (uint8_t x, uint8_t y, uint8_t control_id, uint8_t fg, uint8_t bg) {
	uint8_t tmp_str[10];
	if (Rc_Control_name[control_id][0] != 0) {
		LCD_PrintXY(x, y, (char *)Rc_Control_name[control_id], fg, bg);
	} else {
		LCD_PrintXY(x, y, (char *)int2str((char *)tmp_str, control_id, 0), fg, bg);
	}
}

void print_point (uint8_t x, uint8_t y, uint8_t control_id, uint8_t fg, uint8_t bg) {
	LCD_PrintXY(x, y, (char *)"->", fg, bg);
}

void print_time (uint8_t x, uint8_t y, uint32_t timer_count, uint8_t fg, uint8_t bg) {
	uint8_t tmp_str[20];
	uint8_t pos_x = x;
	int2str_new((char *)tmp_str, (timer_count / 1000) / 60, 1, 0, 1);
	pos_x = LCD_PrintXY(pos_x, y, (char *)tmp_str, fg, bg);
	pos_x = LCD_PrintXY(pos_x, y, (char *)":", fg, bg);
	int2str_new((char *)tmp_str, (uint16_t)((timer_count / 1000) - ((timer_count / 1000) / 60 * 60)), 1, 0, 1);
	pos_x = LCD_PrintXY(pos_x, y, (char *)tmp_str, fg, bg);
}

void print_control_value (uint8_t control_id) {
	uint8_t tmp_str[20];
	uint8_t n;
	int16_t new_value = ControlRead(control_id);

	LCD_Font(2);
	print_control(255, 24, control_id, LCD_XOR, LCD_TRANS);
	int2str_new((char *)tmp_str, (int16_t)new_value, 0, 0, 1);
	LCD_PrintXY(255, 32, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	LCD_Font(1);

	for (n = 10; n < LCD_W - 10; n++) {
		LCD_Pixel(n, LCD_H - 12, 1);
		LCD_Pixel(n, LCD_H - 2, 1);
	}
	for (n = LCD_H - 12; n < LCD_H - 2; n++) {
		LCD_Pixel(10, n, 1);
		LCD_Pixel(LCD_W - 10, n, 1);
	}
	for (n = LCD_H - 10; n < LCD_H - 3; n += 2) {
		LCD_Pixel((LCD_W / 2), n, 1);
	}
	for (n = LCD_H - 12; n < LCD_H - 2; n++) {
		LCD_Pixel((LCD_W / 2) + (new_value) * (LCD_W - 20) / 255, n, 1);
	}
}

void print_output (uint8_t y, uint8_t x, uint8_t output_id, uint8_t fg, uint8_t bg) {
	uint8_t tmp_str[20];
	if (Rc_Output_name[output_id][0] != 0) {
		LCD_PrintXY(y, x, (char *)Rc_Output_name[output_id], fg, bg);
	} else {
		LCD_PrintXY(y, x, (char *)int2str((char *)tmp_str, output_id, 0), fg, bg);
	}
}


void setup_default (void) {
	int8_t num = 0;
	Rc_Cmd_Init();
	for (num = 0; num < 8 && num < CONTROL_ON && num < MIXER_MAX && num < OUTPUT_MAX; num++) {
		Rc_Mixer_switch[num] = CONTROL_ON;
		Rc_Mixer_channel_in[num] = num;
		Rc_Mixer_channel_out[num] = num;
		Rc_Mixer_percent_value[num] = 100;
		Rc_Mixer_percent_control[num] = CONTROL_ON;
	}
	Rc_Output_center_control[0] = 21;
	Rc_Output_center_value[0] = 50;
	Rc_Output_center_control[1] = 20;
	Rc_Output_center_value[1] = 50;
	Rc_Output_center_control[2] = 23;
	Rc_Output_center_value[2] = 50;
	Rc_Output_center_control[3] = 22;
	Rc_Output_center_value[3] = 50;
}

void setup_plane1 (void) {
	setup_default();
	Rc_Model_icon = 0;
	strcpy((char *)Rc_Model_name, "Std.-Plane");
	strcpy((char *)Rc_Control_name[0], (char *)name_aileron);
	strcpy((char *)Rc_Control_name[1], (char *)name_elevator);
	strcpy((char *)Rc_Control_name[2], (char *)name_throttle);
	strcpy((char *)Rc_Control_name[3], (char *)name_rudder);
	strcpy((char *)Rc_Control_name[4], (char *)name_flaps);
	strcpy((char *)Rc_Output_name[0], (char *)name_aileron);
	strcpy((char *)Rc_Output_name[1], (char *)name_elevator);
	strcpy((char *)Rc_Output_name[2], (char *)name_throttle);
	strcpy((char *)Rc_Output_name[3], (char *)name_rudder);
	strcpy((char *)Rc_Output_name[4], (char *)name_flaps);
}

void setup_plane2 (void) {
	setup_default();
	Rc_Model_icon = 0;
	strcpy((char *)Rc_Model_name, "Acro-Plane");
	strcpy((char *)Rc_Control_name[0], (char *)name_aileron);
	strcpy((char *)Rc_Control_name[1], (char *)name_elevator);
	strcpy((char *)Rc_Control_name[2], (char *)name_throttle);
	strcpy((char *)Rc_Control_name[3], (char *)name_rudder);
	strcpy((char *)Rc_Control_name[4], (char *)name_flaps);
	strcpy((char *)Rc_Output_name[0], (char *)name_aileron1);
	strcpy((char *)Rc_Output_name[1], (char *)name_aileron2);
	strcpy((char *)Rc_Output_name[2], (char *)name_elevator1);
	strcpy((char *)Rc_Output_name[3], (char *)name_elevator2);
	strcpy((char *)Rc_Output_name[4], (char *)name_rudder);
	strcpy((char *)Rc_Output_name[5], (char *)name_throttle);
	Rc_Mixer_channel_in[0] = 0;
	Rc_Mixer_channel_out[0] = 0;
	Rc_Mixer_channel_in[1] = 0;
	Rc_Mixer_channel_out[1] = 1;
	Rc_Mixer_percent_value[1] = -100;
	Rc_Mixer_channel_in[2] = 1;
	Rc_Mixer_channel_out[2] = 2;
	Rc_Mixer_channel_in[3] = 1;
	Rc_Mixer_channel_out[3] = 3;
	Rc_Mixer_channel_in[4] = 2;
	Rc_Mixer_channel_out[4] = 5;
	Rc_Mixer_channel_in[5] = 3;
	Rc_Mixer_channel_out[5] = 4;
	Rc_Mixer_channel_in[6] = 4;
	Rc_Mixer_channel_out[6] = 0;
	Rc_Mixer_channel_in[7] = 4;
	Rc_Mixer_channel_out[7] = 1;
}

void setup_heli1 (void) {
	setup_default();
	Rc_Model_icon = 1;
	strcpy((char *)Rc_Model_name, "Heli-1");
	strcpy((char *)Rc_Control_name[0], (char *)name_roll);
	strcpy((char *)Rc_Control_name[1], (char *)name_nick);
	strcpy((char *)Rc_Control_name[2], (char *)name_pitch);
	strcpy((char *)Rc_Control_name[3], (char *)name_rudder);
	strcpy((char *)Rc_Control_name[4], (char *)name_throttle);
	strcpy((char *)Rc_Output_name[0], (char *)name_roll1);
	strcpy((char *)Rc_Output_name[1], (char *)name_roll2);
	strcpy((char *)Rc_Output_name[2], (char *)name_nick);
	strcpy((char *)Rc_Output_name[3], (char *)name_rudder);
	strcpy((char *)Rc_Output_name[4], (char *)name_throttle);
	// Roll
	Rc_Mixer_channel_in[0] = 0;
	Rc_Mixer_channel_out[0] = 0;
	Rc_Mixer_channel_in[1] = 0;
	Rc_Mixer_channel_out[1] = 1;
	// Nick
	Rc_Mixer_channel_in[2] = 1;
	Rc_Mixer_channel_out[2] = 0;
	Rc_Mixer_percent_value[2] = -75;
	Rc_Mixer_channel_in[3] = 1;
	Rc_Mixer_channel_out[3] = 1;
	Rc_Mixer_percent_value[3] = -75;
	Rc_Mixer_channel_in[4] = 1;
	Rc_Mixer_channel_out[4] = 2;
	// Pitch
	Rc_Mixer_channel_in[5] = 2;
	Rc_Mixer_channel_out[5] = 0;
	Rc_Mixer_channel_in[6] = 2;
	Rc_Mixer_channel_out[6] = 1;
	Rc_Mixer_channel_in[7] = 2;
	Rc_Mixer_channel_out[7] = 2;
}

void setup_delta (void) {
	setup_default();
	Rc_Model_icon = 0;
	strcpy((char *)Rc_Model_name, "Delta");
	strcpy((char *)Rc_Control_name[0], (char *)name_aileron);
	strcpy((char *)Rc_Control_name[1], (char *)name_elevator);
	strcpy((char *)Rc_Control_name[2], (char *)name_throttle);
	strcpy((char *)Rc_Control_name[3], (char *)name_rudder);
	strcpy((char *)Rc_Output_name[0], (char *)name_aileron1);
	strcpy((char *)Rc_Output_name[1], (char *)name_aileron2);
	strcpy((char *)Rc_Output_name[2], (char *)name_throttle);
	strcpy((char *)Rc_Output_name[3], (char *)name_rudder);
	Rc_Mixer_channel_in[0] = 0;
	Rc_Mixer_channel_out[0] = 0;
	Rc_Mixer_percent_value[0] = 100;
	Rc_Mixer_channel_in[1] = 0;
	Rc_Mixer_channel_out[1] = 1;
	Rc_Mixer_percent_value[1] = -100;
	Rc_Mixer_channel_in[2] = 1;
	Rc_Mixer_channel_out[2] = 0;
	Rc_Mixer_percent_value[2] = 100;
	Rc_Mixer_channel_in[3] = 1;
	Rc_Mixer_channel_out[3] = 1;
	Rc_Mixer_percent_value[3] = 100;
	Rc_Mixer_channel_in[4] = 2;
	Rc_Mixer_channel_out[4] = 2;
	Rc_Mixer_channel_in[5] = 3;
	Rc_Mixer_channel_out[5] = 3;
}

void menu_hw_init (void) {

#ifdef PLATFORM_STM32
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW0_A_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(RC_CONTROL_SW0_A_PORT, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW0_B_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(RC_CONTROL_SW0_B_PORT, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW0_C_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(RC_CONTROL_SW0_C_PORT, &GPIO_InitStructure);
#endif

	int8_t num = 0;
	for (num = 0; num < 16; num++) {
		Rc_Control_name[num][0] = 0;
		Rc_Output_name[num][0] = 0;
	}
	setup_plane1();
}

uint8_t menu_control_overview (uint8_t cmd) {
	static uint8_t entry = 0;
	uint8_t tmp_str[40];
	uint8_t num = 0;
	uint8_t x = 0;

	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP && entry < 5) {
		entry++;
	} else if (cmd == CMD_DOWN && entry > 0) {
		entry--;
	}

	LCD_Clear();
	LCD_Header((char *)Rc_Model_name);
	x = LCD_PrintXY(0, 10, (char *)int2str((char *)tmp_str, (entry * 4) + 1, 0), LCD_XOR, LCD_TRANS);
	x = LCD_PrintXY(x + 2, 10, "->", LCD_XOR, LCD_TRANS);
	LCD_PrintXY(x + 2, 10, (char *)int2str((char *)tmp_str, (entry * 4) + 7, 0), LCD_XOR, LCD_TRANS);
	for (num = 0; num < 4; num++) {
		print_bar(3, 16 + num * ((LCD_H - 16) / 4) + 1, LCD_W - 6, ((LCD_H - 16) / 4) - 2, (Rc_AdcRead((entry * 4) + num) / 8) + 128);
	}
	return 0;
}

uint8_t menu_output_overview (uint8_t cmd) {
	static uint8_t entry = 0;
	uint8_t tmp_str[40];
	uint8_t num = 0;
	uint8_t x = 0;

	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP && entry < 5) {
		entry++;
	} else if (cmd == CMD_DOWN && entry > 0) {
		entry--;
	}

	LCD_Clear();
	LCD_Header((char *)Rc_Model_name);
	x = LCD_PrintXY(0, 10, (char *)int2str((char *)tmp_str, (entry * 4) + 1, 0), LCD_XOR, LCD_TRANS);
	x = LCD_PrintXY(x + 2, 10, "->", LCD_XOR, LCD_TRANS);
	LCD_PrintXY(x + 2, 10, (char *)int2str((char *)tmp_str, (entry * 4) + 7, 0), LCD_XOR, LCD_TRANS);
	for (num = 0; num < 4; num++) {
		print_bar(3, 16 + num * ((LCD_H - 16) / 4) + 1, LCD_W - 6, ((LCD_H - 16) / 4) - 2, (Rc_Output_value[(entry * 4) + num] / 8) + 128);
	}
	return 0;
}

uint8_t menu_calibrate (uint8_t cmd) {
	static uint8_t entry = 0;
	int8_t num = 0;
	if (cmd == CMD_ENTER) {
		redraw = 2;
		if (entry == 0) {
			entry++;
			for (num = 0; num < 4; num++) {
				Rc_Calibrate_center[num] = 0;
				Rc_Calibrate_min[num] = -1024;
				Rc_Calibrate_max[num] = 1024;
			}
			MotionTimer = 0; while (MotionTimer < 250) {}
			MotionTimer = 0; while (MotionTimer < 250) {}
			for (num = 0; num < 4; num++) {
				Rc_Calibrate_center[num] = Rc_AdcRead(num) * -1;
				Rc_Calibrate_min[num] = 1024;
				Rc_Calibrate_max[num] = -1024;
			}
		} else if (entry == 1) {
			return 1;
		}
	}


	LCD_Clear();
	LCD_Header((char *)Rc_Model_name);
	LCD_PrintXY(0, 10, (char *)"Calibrate:", LCD_XOR, LCD_TRANS);

	LCD_Font(2);

	if (entry == 0) {
		LCD_Print_Center(20, "Center", LCD_XOR, LCD_TRANS);
		LCD_Print_Center(30, "all", LCD_XOR, LCD_TRANS);
		LCD_Print_Center(40, "sticks", LCD_XOR, LCD_TRANS);
	} else if (entry == 1) {
		LCD_Print_Center(20, "Move sticks", LCD_XOR, LCD_TRANS);
		LCD_Print_Center(30, "to each", LCD_XOR, LCD_TRANS);
		LCD_Print_Center(40, "korner", LCD_XOR, LCD_TRANS);
	} else {
		LCD_Print_Center(50, "> DONE <", LCD_XOR, LCD_TRANS);
	}

	LCD_Font(1);

	return 0;
}

uint8_t menu_adc (uint8_t cmd) {
	static uint8_t entry = 0;
	static uint8_t pos = 10;
	uint8_t tmp_str[40];

	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP && entry < 5) {
		entry++;
	} else if (cmd == CMD_DOWN && entry > 0) {
		entry--;
	}

	if (pos < LCD_W - 10) {
		LCD_Pixel(pos, 30 + ((Rc_AdcRead(entry) / 8) + 128) / 16 + 1, 1);
		pos++;
	} else {
		LCD_Update();
		LCD_Clear();
		LCD_Header((char *)Rc_Model_name);
		LCD_PrintXY(8, 0, "ADC-Input:     ", LCD_XOR, LCD_TRANS);
		LCD_PrintXY(8, 12, (char *)int2str((char *)tmp_str, entry + 1, 0), LCD_XOR, LCD_TRANS);
		pos = 10;
	}
	return 0;
}


#ifdef SUPPORT_MMC

uint8_t menu_mmc_load (uint8_t cmd) {
	static uint8_t entry = 0;
	uint8_t tmp_str[40];
	int8_t num = 0;
	int8_t x = 0;
	int16_t start_num = 0;


	if (cmd == CMD_ENTER) {
		if (entry > 0) {
			load_setup_mmc(entry - 1);
		}
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP) {
		if (entry < 10) {
			entry++;
		}
	} else if (cmd == CMD_DOWN) {
		if (entry > 0) {
			entry--;
		}
	}

	LCD_Clear();
	LCD_Header((char *)Rc_Model_name);
	LCD_PrintXY(0, 10, "Load:", LCD_XOR, LCD_TRANS);

	num = 0;
	start_num = entry - MENU_HEIGHT / 2;
	if (start_num < 0) {
		start_num = 0;
	}
	for (num = 0; num < MENU_HEIGHT && num + start_num < 10; num++) {
		if (num + start_num == entry) {
			LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);
		}

		if (num + start_num == 0) {
			x = LCD_PrintXY(3, 22 + (num * 10), (char *)"Back", LCD_XOR, LCD_TRANS);
		} else {
			load_name_mmc((char *)tmp_str, num + start_num - 1);
			x = LCD_PrintXY(3, 22 + (num * 10), (char *)tmp_str, LCD_XOR, LCD_TRANS);
		}

	}

	LCD_Draw_Rec(0, 18, LCD_W - 1, LCD_H - 19);
	LCD_Draw_Rec(LCD_W - 10, 18, 9, LCD_H - 19);
	LCD_Draw_Box(LCD_W - 8, 19 + entry * (LCD_H - 19 - 3) / 10, 6, 3);

	return 0;
}

uint8_t menu_mmc_save (uint8_t cmd) {
	static uint8_t entry = 0;
	uint8_t tmp_str[40];
	int8_t num = 0;
	int8_t x = 0;
	int16_t start_num = 0;

	if (cmd == CMD_ENTER) {
		if (entry > 0) {
			save_setup_mmc(entry - 1);
		}
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP) {
		if (entry < 10) {
			entry++;
		}
	} else if (cmd == CMD_DOWN) {
		if (entry > 0) {
			entry--;
		}
	}

	LCD_Clear();
	LCD_Header((char *)Rc_Model_name);
	LCD_PrintXY(0, 10, "Save:", LCD_XOR, LCD_TRANS);

	num = 0;
	start_num = entry - MENU_HEIGHT / 2;
	if (start_num < 0) {
		start_num = 0;
	}
	for (num = 0; num < MENU_HEIGHT && num + start_num < 10; num++) {
		if (num + start_num == entry) {
			LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);
		}

		if (num + start_num == 0) {
			x = LCD_PrintXY(3, 22 + (num * 10), (char *)"Back", LCD_XOR, LCD_TRANS);
		} else {
			load_name_mmc((char *)tmp_str, num + start_num - 1);
			x = LCD_PrintXY(3, 22 + (num * 10), (char *)tmp_str, LCD_XOR, LCD_TRANS);
		}

	}

	LCD_Draw_Rec(0, 18, LCD_W - 1, LCD_H - 19);
	LCD_Draw_Rec(LCD_W - 10, 18, 9, LCD_H - 19);
	LCD_Draw_Box(LCD_W - 8, 19 + entry * (LCD_H - 19 - 3) / 10, 6, 3);

	return 0;
}


uint8_t menu_mmc_new____ (uint8_t cmd) {
	static uint8_t entry = 0;
	uint8_t tmp_str[40];
	int8_t num = 0;
	int8_t x = 0;
	int16_t start_num = 0;

	if (cmd == CMD_ENTER) {
		if (entry == 1) {
			setup_plane1();
		} else if (entry == 2) {
			setup_plane2();
		} else if (entry == 3) {
			setup_delta();
		} else if (entry == 4) {
			setup_heli1();
		}
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP) {
		if (entry < 5) {
			entry++;
		}
	} else if (cmd == CMD_DOWN) {
		if (entry > 0) {
			entry--;
		}
	}

	LCD_Clear();
	LCD_Header("------");
	LCD_PrintXY(0, 10, "New:", LCD_XOR, LCD_TRANS);

	const char *menu_text[] = {"Back", "Std.-Plane", "Acro-Plane", "Delta", "Heli-H3"};

	num = 0;
	start_num = entry - MENU_HEIGHT / 2;
	if (start_num < 0) {
		start_num = 0;
	}
	for (num = 0; num < MENU_HEIGHT && num + start_num < 5; num++) {
		if (num + start_num == entry) {
			LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);
		}
		x = LCD_PrintXY(3, 22 + (num * 10), (char *)menu_text[num + start_num], LCD_XOR, LCD_TRANS);
	}
	LCD_Draw_Rec(0, 18, LCD_W - 1, LCD_H - 19);
	LCD_Draw_Rec(LCD_W - 10, 18, 9, LCD_H - 19);
	LCD_Draw_Box(LCD_W - 8, 19 + entry * (LCD_H - 19 - 3) / 10, 6, 3);

	return 0;
}

uint8_t menu_mmc_new (uint8_t cmd) {
	char tmp_str[10];
	uint8_t x = 0;
	int8_t num = 0;
	int16_t start_num = 0;
	static uint8_t entry = 0;
	static uint8_t stage = 0;
	static uint8_t stage2 = 0;

	LCD_Clear();
	LCD_Header((char *)Rc_Model_name);

	const char *menu_text[] = {"Back", "Stick-Mode", "Model-Type", "Servo-Mode", "Create"};
	const char *menu_text_modeltype[] = {"Plane", "Heli", "Car", "Boat", "Function"};
	const char *menu_text_servotype[] = {"Futaba", "Graupner/JR", "Multiplex"};

	const uint8_t menu_len[] = {4, 5, 3};
	static uint8_t menu_value[] = {1, 0, 0, 0, 0, 0, 0, 0};


	x = LCD_PrintXY(0, 8, (char *)"Wizard", LCD_XOR, LCD_TRANS) + 8;
	if (stage != 0) {
		x = LCD_PrintXY(x, 8, (char *)menu_text[stage], LCD_XOR, LCD_TRANS);
	}

	switch (stage) {
		case 0:

			if (cmd == CMD_ENTER) {
				redraw = 2;
				if (entry == 0) {
					entry = 0;
					return 1;
				} else {
					cmd = 0;
					stage = entry;
				}
			} else if (cmd == CMD_UP) {
				if (entry < 4) {
					entry++;
				} else {
					entry = 0;
				}
			} else if (cmd == CMD_DOWN) {
				if (entry > 0) {
					entry--;
				} else {
					entry = 4;
				}
			}
			LCD_Font(1);
		break;
		default:
			if (cmd == CMD_ENTER) {
				redraw = 2;
				stage = 0;
			} else if (cmd == CMD_UP) {
				if (menu_value[stage - 1] < menu_len[stage - 1] - 1) {
					menu_value[stage - 1]++;
				} else {
					menu_value[stage - 1] = 0;
				}
			} else if (cmd == CMD_DOWN) {
				if (menu_value[stage - 1] > 0) {
					menu_value[stage - 1]--;
				} else {
					menu_value[stage - 1] = menu_len[stage - 1] - 1;
				}
			}
		break;
	}

		num = 0;
		start_num = entry - MENU_HEIGHT / 2;
		if (start_num < 0) {
			start_num = 0;
		}
		for (num = 0; num < MENU_HEIGHT && num + start_num < 5; num++) {
			if (num + start_num == entry) {
				LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);
			}
			x = LCD_PrintXY(3, 22 + (num * 10), (char *)menu_text[num + start_num], LCD_XOR, LCD_TRANS);
			switch (num + start_num) {
				case 1:
					x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)":", LCD_XOR, LCD_TRANS);
					int2str_new(tmp_str, menu_value[num + start_num - 1] + 1, 0, 0, 1);
					LCD_PrintXY(x + 3, 22 + (num * 10), (char *)tmp_str, LCD_XOR, LCD_TRANS);
				break;
				case 2:
					x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)":", LCD_XOR, LCD_TRANS);
					LCD_PrintXY(x + 3, 22 + (num * 10), (char *)menu_text_modeltype[menu_value[num + start_num - 1]], LCD_XOR, LCD_TRANS);
				break;
				case 3:
					x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)":", LCD_XOR, LCD_TRANS);
					LCD_PrintXY(x + 3, 22 + (num * 10), (char *)menu_text_servotype[menu_value[num + start_num - 1]], LCD_XOR, LCD_TRANS);
				break;
				case 4:
					x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)":", LCD_XOR, LCD_TRANS);
					int2str_new(tmp_str, menu_value[num + start_num - 1], 0, 0, 1);
					LCD_PrintXY(x + 3, 22 + (num * 10), (char *)tmp_str, LCD_XOR, LCD_TRANS);
				break;
			}
		}
		LCD_Font(1);


	return 0;
}


#endif

uint8_t menu_volt_temp (uint8_t cmd) {
	uint8_t tmp_str[40];

	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	}

	LCD_Clear();
	LCD_Header((char *)Rc_Model_name);

	uint16_t temperature = (int16_t)(((1.4 - (float)GetADCChanel(ADC_CHANNELS_MAX - 1) * 3.3 / 4096.0) / 0.004478) + 25.0);
	uint16_t voltage = (int16_t)((float)GetADCChanel(ADC_CHANNELS_MAX - 2) * 15.6 / 4096.0 * 100.0);
	tmp_str[0] = (temperature / 100) + 0x30;
	tmp_str[1] = ((temperature % 100) / 10) + 0x30;
	tmp_str[2] = '.';
	tmp_str[3] = ((temperature % 100) % 10) + 0x30;
	tmp_str[4] = 'C';
	tmp_str[5] = 0;
	LCD_PrintXY(0, 8, "CPU-Temp.  ", LCD_XOR, LCD_TRANS);
	LCD_Font(2);
	LCD_PrintXY(255, 16, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	LCD_Font(1);
	tmp_str[0] = ' ';
	if (voltage > 1000) {
		tmp_str[1] = (voltage / 1000) + 0x30;
	} else {
		tmp_str[1] = ' ';
	}
	tmp_str[2] = ((voltage % 1000) / 100) + 0x30;
	tmp_str[3] = '.';
	tmp_str[4] = (((voltage % 1000) % 100) / 10) + 0x30;
	tmp_str[5] = (((voltage % 1000) % 100) % 10) + 0x30;
	tmp_str[6] = 'V';
	tmp_str[7] = 0;
	LCD_PrintXY(0, 24, "Battery   ", LCD_XOR, LCD_TRANS);
	LCD_Font(2);
	LCD_PrintXY(255, 32, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	LCD_Font(1);

	return 0;
}

uint8_t menu_edit_uint8 (uint8_t cmd, uint8_t *value) {
	uint8_t tmp_str[40];
	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP) {
		if (value[0] < 255) {
			value[0]++;
		} else {
			value[0] = 0;
		}
	} else if (cmd == CMD_DOWN) {
		if (value[0] > 0) {
			value[0]--;
		} else {
			value[0] = 255;
		}
	}
	LCD_PrintXY(0, 24, (char *)"Value (uint8)", LCD_XOR, LCD_TRANS);

	int2str_new((char *)tmp_str, (int16_t)(value[0]), 0, 0, 1);
	LCD_PrintXY(255, 32, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	LCD_PrintXY(255, 48, (char *)"%", LCD_XOR, LCD_TRANS);

	return 0;
}

uint8_t menu_edit_int8 (int8_t cmd, int8_t *value) {
	uint8_t tmp_str[40];
	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP) {
		if (value[0] < 127) {
			value[0]++;
		} else {
			value[0] = 0;
		}
	} else if (cmd == CMD_DOWN) {
		if (value[0] > -127) {
			value[0]--;
		} else {
			value[0] = 127;
		}
	}
	LCD_PrintXY(0, 24, (char *)"Value (int8)", LCD_XOR, LCD_TRANS);

	int2str_new((char *)tmp_str, (int16_t)(value[0]), 0, 0, 1);
	LCD_PrintXY(255, 32, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	LCD_PrintXY(255, 48, (char *)"%", LCD_XOR, LCD_TRANS);

	return 0;
}

uint8_t menu_edit_int16 (int8_t cmd, int16_t *value) {
	uint8_t tmp_str[40];
	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP) {
		if (value[0] < 0xFFFF / 2) {
			value[0]++;
		} else {
			value[0] = 0;
		}
	} else if (cmd == CMD_DOWN) {
		if (value[0] > -32000) {
			value[0]--;
		} else {
			value[0] = 0xFFFF / 2;
		}
	}
	LCD_PrintXY(0, 24, (char *)"Value (int16)", LCD_XOR, LCD_TRANS);

	int2str_new((char *)tmp_str, (int16_t)(value[0]), 0, 0, 1);
	LCD_PrintXY(255, 32, (char *)tmp_str, LCD_XOR, LCD_TRANS);

	return 0;
}

uint8_t menu_edit_uint16 (int8_t cmd, uint16_t *value) {
	uint8_t tmp_str[40];
	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP) {
		if (value[0] < 0xFFFF) {
			value[0]++;
		} else {
			value[0] = 0;
		}
	} else if (cmd == CMD_DOWN) {
		if (value[0] > 0) {
			value[0]--;
		} else {
			value[0] = 0xFFFF;
		}
	}
	LCD_PrintXY(0, 24, (char *)"Value (uint16)", LCD_XOR, LCD_TRANS);
	int2str_new((char *)tmp_str, (int16_t)(value[0]), 0, 0, 1);
	LCD_PrintXY(0, 32, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	return 0;
}

uint8_t menu_edit_text (int8_t cmd, char *text) {
	static uint8_t entry = 0;
	uint8_t tmp_str[40];
	if (cmd == CMD_ENTER) {
		if (text[entry] == 31) {
			entry = 0;
		} else if (text[entry] == 30) {
			text[entry] = 0;
			entry = 0;
			redraw = 2;
			return 1;
		} else {
			entry++;
		}
		redraw = 2;
	} else if (cmd == CMD_UP) {
		if (text[entry] < 124) {
			text[entry]++;
		} else {
			text[entry] = 124;
		}
	} else if (cmd == CMD_DOWN) {
		if (text[entry] > 30) {
			text[entry]--;
		} else {
			text[entry] = 30;
		}
	}
	strcpy((char *)tmp_str, text);
	tmp_str[entry] = 0;
	uint8_t next_x = LCD_PrintXY(10, 32, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	LCD_Font(2);
	strcpy((char *)tmp_str, text + entry);
	tmp_str[1] = 0;
	next_x = LCD_PrintXY(next_x + 5, 32, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	LCD_Font(1);
	strcpy((char *)tmp_str, text + entry + 1);
	next_x = LCD_PrintXY(next_x + 5, 32, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	LCD_Font(2);
	if (text[entry] == 30) {
		LCD_Print_Center(48, (char *)name_ok, LCD_XOR, LCD_TRANS);
	} else if (text[entry] == 31) {
		LCD_Print_Center(48, (char *)name_back, LCD_XOR, LCD_TRANS);
	}
	LCD_Font(1);
	return 0;
}


uint8_t menu_edit_alarm (int8_t cmd, uint32_t *timer_alarm) {
	static uint8_t entry = 0;
	uint8_t tmp_str[20];
	uint8_t pos_x = 10;
	if (cmd == CMD_ENTER) {
		redraw = 2;
		if (entry == 0) {
			entry++;
		} else if (entry == 1) {
			entry = 0;
			return 1;
		}
	} else if (cmd == CMD_UP) {
		if (entry == 0) {
			timer_alarm[0] += 60000;
		} else {
			timer_alarm[0] += 1000;
		}
	} else if (cmd == CMD_DOWN) {
		if (entry == 0) {
			timer_alarm[0] -= 60000;
		} else {
			timer_alarm[0] -= 1000;
		}
	}

	if (entry == 0) {
		LCD_Font(2);
	} else {
		LCD_Font(1);
	}
	int2str_new((char *)tmp_str, (timer_alarm[0] / 1000) / 60, 1, 0, 1);
	pos_x = LCD_PrintXY(pos_x, 48, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	LCD_Font(1);
	pos_x = LCD_PrintXY(pos_x, 48, (char *)":", LCD_XOR, LCD_TRANS);
	if (entry == 1) {
		LCD_Font(2);
	}
	int2str_new((char *)tmp_str, (uint16_t)((timer_alarm[0] / 1000) - ((timer_alarm[0] / 1000) / 60 * 60)), 1, 0, 1);
	pos_x = LCD_PrintXY(pos_x, 48, (char *)tmp_str, LCD_XOR, LCD_TRANS);

	LCD_Font(1);

	return 0;
}


uint8_t menu_edit_points (uint8_t cmd, uint8_t mixer_id) {
	static uint8_t entry = 0;
	static uint8_t stage = 0;
	if (stage == 0) {
		if (cmd == CMD_ENTER) {
			redraw = 2;
			if (entry == 0) {
				return 1;
			} else {
				cmd = 0;
				stage = entry;
			}
		} else if (cmd == CMD_UP) {
			if (entry < (MIXER_POINTS_MAX * 2) - 1) {
				entry++;
			}
		} else if (cmd == CMD_DOWN) {
			if (entry > 0) {
				entry--;
			}
		}
	} else {
		if (cmd == CMD_ENTER) {
			redraw = 2;
			stage = 0;
		} else if (cmd == CMD_UP) {
			if (Rc_Mixer_point[mixer_id][entry / 2][entry - (entry / 2 * 2)] < 100) {
				Rc_Mixer_point[mixer_id][entry / 2][entry - (entry / 2 * 2)]++;
			}
		} else if (cmd == CMD_DOWN) {
			if (Rc_Mixer_point[mixer_id][entry / 2][entry - (entry / 2 * 2)] > 0) {
				Rc_Mixer_point[mixer_id][entry / 2][entry - (entry / 2 * 2)]--;
			}
		}
	}

	if (entry == 0) {
		LCD_Font(2);
		LCD_Print_Center(24, (char *)name_back, LCD_XOR, LCD_TRANS);
	} else {
		LCD_Font(0);
		print_mixer(0, (LCD_H / 3), (LCD_W - 2), (LCD_H * 2 / 3), mixer_id, (entry) / 2, entry - (entry / 2 * 2));
	}
	LCD_Font(1);

	return 0;
}

uint8_t menu_edit_control (uint8_t cmd, uint8_t *value) {
	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP) {
		if (value[0] < CONTROL_MAX) {
			value[0]++;
		} else {
			value[0] = 0;
		}
	} else if (cmd == CMD_DOWN) {
		if (value[0] > 0) {
			value[0]--;
		} else {
			value[0] = CONTROL_MAX;
		}
	}

	if (Last_Control != 255) {
		value[0] = Last_Control;
		Last_Control = 255;
	}

	LCD_PrintXY(0, 24, (char *)"Control", LCD_XOR, LCD_TRANS);
	print_control(16, 32, value[0], LCD_XOR, LCD_TRANS);
	return 0;
}

uint8_t menu_edit_output (uint8_t cmd, uint8_t *value) {
	if (cmd == CMD_ENTER) {
		redraw = 2;
		return 1;
	} else if (cmd == CMD_UP) {
		if (value[0] < OUTPUT_MAX) {
			value[0]++;
		} else {
			value[0] = 0;
		}
	} else if (cmd == CMD_DOWN) {
		if (value[0] > 0) {
			value[0]--;
		} else {
			value[0] = OUTPUT_MAX;
		}
	}
	LCD_PrintXY(0, 24, (char *)"Control", LCD_XOR, LCD_TRANS);
	print_output(10, 32, value[0], LCD_XOR, LCD_TRANS);

	return 0;
}

uint8_t menu_edit_flag (int8_t cmd, int8_t *value) {
	value[0] = 1 - value[0];
	redraw = 2;
	return 1;
}

uint8_t menu_system (uint8_t cmd) {
	static uint8_t entry = 0;
	static uint8_t stage = 0;
	const char *text[] = {name_back, "Info", "New", "Load", "Save", "Control-Monitor", "Servo-Monitor", "ADC-Monitor", "Calibrate", "Reload-MMC", "---", "---"};

	if (cmd == CMD_ENTER) {
		redraw = 2;
		if (stage == 0) {
			if (entry == 0) {
				return 1;
			} else {
				cmd = 0;
				stage = entry;
			}
		}
	} else if (cmd == CMD_UP && entry < 10) {
		entry++;
	} else if (cmd == CMD_DOWN && entry > 0) {
		entry--;
	}

	if (stage == 0) {
		LCD_Clear();
		LCD_Header((char *)Rc_Model_name);
		LCD_PrintXY(0, 10, (char *)"System-Menu", LCD_XOR, LCD_TRANS);
		int8_t num = 0;
		int16_t start_num = entry - MENU_HEIGHT / 2;
		if (start_num < 0) {
			start_num = 0;
		}
		for (num = 0; num < MENU_HEIGHT && num + start_num < 10; num++) {
			if (num + start_num == entry) {
				LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);
			}
			LCD_PrintXY(10, 22 + (num * 10), (char *)text[num + start_num], LCD_XOR, LCD_TRANS);
		}
		LCD_Draw_Rec(0, 18, LCD_W - 1, LCD_H - 19);
		LCD_Draw_Rec(LCD_W - 10, 18, 9, LCD_H - 19);
		LCD_Draw_Box(LCD_W - 8, 19 + entry * (LCD_H - 19 - 3) / 5, 6, 3);
	} else if (stage == 1) {
		if (menu_volt_temp(cmd) == 1) {
			stage = 0;
		}

#ifdef SUPPORT_MMC
	} else if (stage == 2) {
		if (menu_mmc_new(cmd) == 1) {
			stage = 0;
		}
	} else if (stage == 3) {
		if (menu_mmc_load(cmd) == 1) {
			stage = 0;
		}
	} else if (stage == 4) {
		if (menu_mmc_save(cmd) == 1) {
			stage = 0;
		}
#endif

	} else if (stage == 5) {
		if (menu_control_overview(cmd) == 1) {
			stage = 0;
		}
	} else if (stage == 6) {
		if (menu_output_overview(cmd) == 1) {
			stage = 0;
		}
	} else if (stage == 7) {
		if (menu_adc(cmd) == 1) {
			stage = 0;
		}
	} else if (stage == 8) {
		if (menu_calibrate(cmd) == 1) {
			stage = 0;
		}
	} else if (stage == 9) {
#ifdef SUPPORT_MMC
		rc_mmc_init();
#endif
		stage = 0;
	}
	return 0;
}

void menu_list_view_id (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected) {
	uint8_t text[20];
	strcpy(text, "ID:");
	text[3] = ' ';
	text[4] = '0' + id;
	text[5] = 0;
	if (selected == 1) {
		LCD_Draw_Box(x, y, w, h);
	}
	LCD_PrintXY(x + 4, y + 2, (char *)text, LCD_XOR, LCD_TRANS);
}

void menu_list_view_Timer (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected) {
	uint8_t tmp_str[20];
	if (selected == 1) {
		LCD_Draw_Box(x, y, w, h);
	}
	LCD_Font(1);
	x = LCD_PrintXY(x + 4, y + 2, (char *)SystemTimer_name[id], LCD_XOR, LCD_TRANS);
	x = LCD_PrintXY(x, y + 2, (char *)":", LCD_XOR, LCD_TRANS);
	int2str_new((char *)tmp_str, (SystemTimer_time[id] / 1000) / 60, 1, 0, 1);
	x = LCD_PrintXY(x + 10, y + 2, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	x = LCD_PrintXY(x, y + 2, (char *)":", LCD_XOR, LCD_TRANS);
	int2str_new((char *)tmp_str, (uint16_t)((SystemTimer_time[id] / 1000) - ((SystemTimer_time[id] / 1000) / 60 * 60)), 1, 0, 1);
	x = LCD_PrintXY(x, y + 2, (char *)tmp_str, LCD_XOR, LCD_TRANS);
}

void menu_list_view_Control (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected) {
	if (selected == 1) {
		LCD_Draw_Box(x, y, w, h);
	}
	print_control(x + 4, y + 2, id, LCD_XOR, LCD_TRANS);
}

void menu_list_view_Dualrate (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected) {
	menu_list_view_Control(x, y, w, h, Rc_Dualrate_channel[id], selected);
}

void menu_list_view_Expo (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected) {
	menu_list_view_Control(x, y, w, h, Rc_Expo_channel[id], selected);
}

void menu_list_view_Atv (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected) {
	menu_list_view_Output(x, y, w, h, Rc_Atv_channel[id], selected);
}

void menu_list_view_Limiter (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected) {
	menu_list_view_Output(x, y, w, h, Rc_Limiter_channel[id], selected);
}

void menu_list_view_Mixer (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected) {
	if (selected == 1) {
		LCD_Draw_Box(x, y, w, h);
	}
	LCD_Font(0);
	print_control(x + 4, y + 3, Rc_Mixer_channel_in[id], LCD_XOR, LCD_TRANS);
	LCD_PrintXY(x + (w / 2) - 2, y + 3, (char *)">", LCD_XOR, LCD_TRANS);
	print_output(x + (w / 2) + 6, y + 3, Rc_Mixer_channel_out[id], LCD_XOR, LCD_TRANS);
	LCD_Font(1);
}

void menu_list_view_Output (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected) {
	if (selected == 1) {
		LCD_Draw_Box(x, y, w, h);
	}
	print_output(x + 4, y + 2, id, LCD_XOR, LCD_TRANS);
}

uint8_t menu_select (char *title, uint8_t cmd, uint8_t len, void (*list_view) (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected), uint8_t (*view)(uint8_t cmd, uint8_t id)) {
	static uint8_t entry = 0;
	static uint8_t stage = 0;
	if (stage == 0) {
		if (cmd == CMD_ENTER) {
			redraw = 2;
			if (stage == 0) {
				if (entry == 0) {
					return 1;
				} else {
					cmd = 0;
					stage = entry;
					entry = 0;
				}
			}
		} else if (cmd == CMD_UP && entry < len + 1) {
			entry++;
		} else if (cmd == CMD_DOWN && entry > 0) {
			entry--;
		}

		LCD_Clear();
		LCD_Header((char *)Rc_Model_name);
		LCD_PrintXY(0, 10, (char *)title, LCD_XOR, LCD_TRANS);
		int8_t num = 0;
		int16_t start_num = entry - MENU_HEIGHT / 2;
		if (start_num < 0) {
			start_num = 0;
		}
		for (num = 0; num < MENU_HEIGHT && num + start_num < len + 1; num++) {
			if (num + start_num == 0) {
				if (num + start_num == entry) {
					LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);
				}
				LCD_PrintXY(2, 20 + (num * 10), (char *)name_back, LCD_XOR, LCD_TRANS);
			} else {
				if (num + start_num == entry) {
					(*list_view)(2, 20 + (num * 10), LCD_W - 13, 10, start_num + num - 1, 1);
				} else {
					(*list_view)(2, 20 + (num * 10), LCD_W - 13, 10, start_num + num - 1, 0);
				}
			}
		}
		LCD_Draw_Rec(0, 18, LCD_W - 1, LCD_H - 19);
		LCD_Draw_Rec(LCD_W - 10, 18, 9, LCD_H - 19);
		LCD_Draw_Box(LCD_W - 8, 19 + entry * (LCD_H - 19 - 3) / 5, 6, 3);
	} else {
		LCD_Clear();
		LCD_Header((char *)Rc_Model_name);
		LCD_PrintXY(0, 10, (char *)title, LCD_XOR, LCD_TRANS);
		if ((*view)(cmd, stage - 1) == 1) {
			entry = stage;
			stage = 0;
		}
	}
	return 0;
}

uint8_t menu_find_next_mixer (void) {
	uint8_t num;
	for (num = 0; num < MIXER_MAX; num++) {
		if (Rc_Mixer_channel_in[num] == 255 || Rc_Mixer_channel_out[num] == 255) {
			return 0;
		}
	}
	return 255;
}

uint8_t menu_find_next_expo (void) {
	uint8_t num;
	for (num = 0; num < EXPO_MAX; num++) {
		if (Rc_Expo_channel[num] == 255) {
			return 0;
		}
	}
	return 255;
}

uint8_t menu_find_next_dualrate (void) {
	uint8_t num;
	for (num = 0; num < DUALRATE_MAX; num++) {
		if (Rc_Dualrate_channel[num] == 255) {
			return 0;
		}
	}
	return 255;
}

uint8_t menu_find_next_atv (void) {
	uint8_t num;
	for (num = 0; num < ATV_MAX; num++) {
		if (Rc_Atv_channel[num] == 255) {
			return 0;
		}
	}
	return 255;
}

uint8_t menu_find_next_motion (void) {
	uint8_t num;
	for (num = 0; num < MOTION_MAX; num++) {
		if (Rc_Motion_channel[num] == 255) {
			return 0;
		}
	}
	return 255;
}

uint8_t menu_find_next_limiter (void) {
	uint8_t num;
	for (num = 0; num < LIMITER_MAX; num++) {
		if (Rc_Limiter_channel[num] == 255) {
			return 0;
		}
	}
	return 255;
}


#endif


