
enum {
	TYPE_NONE,
	TYPE_SINGLE,
	TYPE_MULTI,
	TYPE_CONTROL,
	TYPE_CHANNEL_IN,
	TYPE_CHANNEL_OUT,
	TYPE_CHANNEL,
	TYPE_POINT,
	TYPE_POINT_X,
	TYPE_POINT_Y,
	TYPE_POINT_INVERT,
	TYPE_POINT_LINEAR,
	TYPE_POINT_HALF,
	TYPE_MAX
};

#ifdef RCOS_MAINBOARD_V1_0
#define RC_CONTROL_SW0_A_PORT	GPIOE
#define RC_CONTROL_SW0_A_PIN 	GPIO_Pin_0
#define RC_CONTROL_SW0_B_PORT	GPIOE
#define RC_CONTROL_SW0_B_PIN 	GPIO_Pin_1
#define RC_CONTROL_SW0_C_PORT	GPIOD
#define RC_CONTROL_SW0_C_PIN 	GPIO_Pin_7
#endif

#ifdef RCOS_MAINBOARD_FC16
#define RC_CONTROL_SW0_A_PORT	GPIOC
#define RC_CONTROL_SW0_A_PIN 	GPIO_Pin_10
#define RC_CONTROL_SW0_B_PORT	GPIOB
#define RC_CONTROL_SW0_B_PIN 	GPIO_Pin_5
#define RC_CONTROL_SW0_C_PORT	GPIOA
#define RC_CONTROL_SW0_C_PIN 	GPIO_Pin_6
#endif


extern uint8_t load_name_mmc (char *name_str, uint8_t model_id);
extern uint8_t load_setup_mmc (uint16_t model_id);
extern uint8_t save_setup_mmc (uint16_t model_id);
extern char *int2str (char *str, int value, char mode);
extern char *int2str_new (char *str, int16_t value, uint8_t mode, uint8_t digit, uint8_t close_str);
extern char input_name[16][16];
extern char output_name[16][16];


void print_mixer (uint8_t offset_x, uint8_t offset_y, uint8_t width, uint8_t height, uint8_t id, uint8_t point, uint8_t xy);
void print_bar (uint8_t offset_x, uint8_t offset_y, uint8_t width, uint8_t height, uint8_t value);
void print_control (uint8_t x, uint8_t y, uint8_t control_id, uint8_t fg, uint8_t bg);
void print_point (uint8_t x, uint8_t y, uint8_t control_id, uint8_t fg, uint8_t bg);
void print_time (uint8_t x, uint8_t y, uint32_t timer_count, uint8_t fg, uint8_t bg);
void print_control_value (uint8_t control_id);
void print_output (uint8_t y, uint8_t x, uint8_t output_id, uint8_t fg, uint8_t bg);
void setup_default (void);
void setup_plane1 (void);
void setup_plane2 (void);
void setup_heli1 (void);
void menu_hw_init (void);
void menu_list_view_id (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected);
void menu_list_view_Timer (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected);
void menu_list_view_Control (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected);
void menu_list_view_Dualrate (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected);
void menu_list_view_Expo (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected);
void menu_list_view_Atv (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected);
void menu_list_view_Limiter (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected);
void menu_list_view_Mixer (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected);
void menu_list_view_Output (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected);
uint8_t menu_select (char *title, uint8_t cmd, uint8_t len, void (*list_view) (uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t id, uint8_t selected), uint8_t (*view)(uint8_t cmd, uint8_t id));
uint8_t menu_find_next_mixer (void);
uint8_t menu_find_next_expo (void);
uint8_t menu_find_next_dualrate (void);
uint8_t menu_find_next_atv (void);
uint8_t menu_find_next_motion (void);
uint8_t menu_find_next_limiter (void);
uint8_t menu_edit_uint8 (uint8_t cmd, uint8_t *value);
uint8_t menu_edit_int8 (int8_t cmd, int8_t *value);
uint8_t menu_edit_int16 (int8_t cmd, int16_t *value);
uint8_t menu_edit_uint16 (int8_t cmd, uint16_t *value);
uint8_t menu_edit_text (int8_t cmd, char *text);
uint8_t menu_edit_alarm (int8_t cmd, uint32_t *timer_alarm);
uint8_t menu_edit_points (uint8_t cmd, uint8_t mixer_id);
uint8_t menu_edit_control (uint8_t cmd, uint8_t *value);
uint8_t menu_edit_output (uint8_t cmd, uint8_t *value);
uint8_t menu_edit_flag (int8_t cmd, int8_t *value);








