/*
Copyright (C) 2008  Oliver Dippel <o.dippel@gmx.de>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

On Debian GNU/Linux systems, the complete text of the GNU General
Public License can be found in `/usr/share/common-licenses/GPL'.
*/

#include "rc.h"


int16_t Rc_MixPoints (int16_t value, int8_t level, uint8_t mixer_num) {
	int16_t new_value = 0;
	int16_t mixer_p1;
	int16_t mixer_v1;
	int16_t mixer_p2;
	int16_t mixer_v2;
	int8_t num;
	mixer_p1 = (Rc_Mixer_point[mixer_num][0][0] - 50) * 2048 / 100;
	mixer_p2 = (Rc_Mixer_point[mixer_num][MIXER_POINTS_MAX - 1][0] - 50) * 2048 / 100;
	if (value <= mixer_p1) {
		value = mixer_p1;
	} else if (value >= mixer_p2) {
		value = mixer_p2;
	}
	for (num = 0; num < MIXER_POINTS_MAX - 1; num++) {
		mixer_p1 = (Rc_Mixer_point[mixer_num][num][0] - 50) * 2048 / 100;
		mixer_v1 = (Rc_Mixer_point[mixer_num][num][1] - 50) * 2048 / 100;
		mixer_p2 = (Rc_Mixer_point[mixer_num][num + 1][0] - 50) * 2048 / 100;
		mixer_v2 = (Rc_Mixer_point[mixer_num][num + 1][1] - 50) * 2048 / 100;
		if (value >= mixer_p1 && value <= mixer_p2) {
			new_value = (int)((float)mixer_v1 + (((float)(value - mixer_p1) / (float)(mixer_p2 - mixer_p1)) * (float)(mixer_v2 - mixer_v1)));
			break;
		}
	}

	return new_value * level / 100;
}

void Rc_Stage_Mixer (void) {
	uint16_t num;
	uint16_t new_value;
	for (num = 0; num < OUTPUT_MAX; num++) {
		Rc_Output_value[num] = 0;
	}
	for (num = 0; num < MIXER_MAX; num++) {

		if (Rc_Mixer_channel_in[num] < CONTROL_OFF && Rc_Mixer_channel_out[num] < 255 && (Rc_Mixer_switch[num] == CONTROL_ON || ControlRead(Rc_Mixer_switch[num]) > 10)) {
			if (Rc_Mixer_percent_control[num] > 0) {
				new_value = ControlSet(Rc_Mixer_percent_control[num], Rc_Mixer_percent_value[num]);
				Rc_Output_value[Rc_Mixer_channel_out[num]] += Rc_MixPoints(Rc_Control_buffer[Rc_Mixer_channel_in[num]], new_value, num);
			}
		}
	}
}



