/*
Copyright (C) 2008  Oliver Dippel <o.dippel@gmx.de>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

On Debian GNU/Linux systems, the complete text of the GNU General
Public License can be found in `/usr/share/common-licenses/GPL'.
*/

#include "rc.h"


void Rc_Stage_Output (void) {
	uint16_t num;
	uint16_t new_value;
	uint16_t new_value2;
	int16_t new_value3;

	// Servo-Center-Correction
	for (num = 0; num < OUTPUT_MAX; num++) {
		if (Rc_Output_center_control[num] == CONTROL_ON) {
			Rc_Output_value[num] = Rc_Output_value[num] + (Rc_Output_center_value[num] * 5);
		} else {
			new_value3 = ControlSet(Rc_Output_center_control[num], Rc_Output_center_value[num]);
			Rc_Output_value[num] = Rc_Output_value[num] + (new_value3 * 5);
		}
	}

	// ATV-Function
	for (num = 0; num < ATV_MAX; num++) {
		if (Rc_Atv_channel[num] < OUTPUT_MAX && (Rc_Atv_switch[num] == 255 || ControlRead(Rc_Atv_switch[num]) > 10)) {
			new_value = ControlSet(Rc_Atv_up_control[num], Rc_Atv_up_value[num]);
			new_value2 = ControlSet(Rc_Atv_down_control[num], Rc_Atv_down_value[num]);
			if (Rc_Output_value[Rc_Atv_channel[num]] > 0 && new_value != 0) {
				if (new_value > 100) {
					new_value = 100;
				}
				Rc_Output_value[Rc_Atv_channel[num]] = Rc_Output_value[Rc_Atv_channel[num]] * new_value / 100;
			} else if (Rc_Output_value[Rc_Atv_channel[num]] < 0 && new_value2 != 0) {
				if (new_value2 > 100) {
					new_value2 = 100;
				}
				Rc_Output_value[Rc_Atv_channel[num]] = Rc_Output_value[Rc_Atv_channel[num]] * new_value2 / 100;
			}
		}
	}

	// Servo-Limiter
	for (num = 0; num < LIMITER_MAX; num++) {
		if (Rc_Limiter_channel[num] < OUTPUT_MAX && (Rc_Limiter_switch[num] == CONTROL_ON || ControlRead(Rc_Limiter_switch[num]) > 10)) {
			new_value = ControlSet(Rc_Limiter_up_control[num], Rc_Limiter_up_value[num]);
			new_value2 = ControlSet(Rc_Limiter_down_control[num], Rc_Limiter_down_value[num]);
			if (Rc_Output_value[Rc_Limiter_channel[num]] > 0 && new_value != 0) {
				if (new_value > 100) {
					new_value = 100;
				}
				if (Rc_Output_value[Rc_Limiter_channel[num]] > new_value * 1024 / 100) {
					Rc_Output_value[Rc_Limiter_channel[num]] = new_value * 1024 / 100;
				}
			} else if (Rc_Output_value[Rc_Limiter_channel[num]] < 0 && new_value2 != 0) {
				if (new_value2 > 100) {
					new_value2 = 100;
				}
				if (Rc_Output_value[Rc_Limiter_channel[num]] < new_value2 * -1024 / 100) {
					Rc_Output_value[Rc_Limiter_channel[num]] = new_value2 * -1024 / 100;
				}
			}
		}
	}

	// Servo-Direction
	for (num = 0; num < OUTPUT_MAX; num++) {
		if (Rc_Output_reverse[num] == 1) {
			Rc_Output_value[num] *= -1;
		}
	}

}





