/*
Copyright (C) 2008  Oliver Dippel <o.dippel@gmx.de>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

On Debian GNU/Linux systems, the complete text of the GNU General
Public License can be found in `/usr/share/common-licenses/GPL'.
*/

#include <rc.h>
#include <rc_ppm-encoder.h>
#include <rc_adc.h>
#include <rc_control.h>
#include <sound.h>

extern void beep (uint16_t freq, uint8_t len);
extern char *int2str(char *str, int value, char mode);


void Rc_REncoderDecode_byte (uint8_t byte, uint8_t bit_a, uint8_t bit_b, uint8_t bit_sw, uint8_t control_id) {
	static int8_t last[255];
	int8_t new = 0;
	int8_t diff;
	int8_t delta;
	if(! (byte & (1<<bit_a)) ) {
		new = 3;
	}
	if(! (byte & (1<<bit_b)) ) {
		new ^= 1;
	}
	if(! (byte & (1<<bit_sw)) ) {
		Rc_Control_value[control_id] = 0;
		sound(1000, 20);
		return;		
	}
	diff = last[control_id] - new;
	if( diff & 1 ) {
		last[control_id] = new;
		delta = (diff & 2) - 1;
		if (delta > 0 && Rc_Control_value[control_id] < 126) {
			Rc_Control_value[control_id] += delta;
		} else if (delta < 0 && Rc_Control_value[control_id] > -126) {
			Rc_Control_value[control_id] += delta;
		}
		if (Rc_Control_value[control_id] == 0) {
			sound(1000, 20);
		} else if (Rc_Control_value[control_id] == -126) {
			sound(1200, 20);
		} else if (Rc_Control_value[control_id] == 126) {
			sound(1400, 20);
		}
	}
}

