#!/bin/sh
#
#

cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $2}' | cut -d"_" -f2 | grep -v "\<Flag\>" | grep -v "\<Servo\>" | grep -v "\<Calibrate\>" | uniq > /tmp/menu.txt

echo -n > text.txt
echo "" > text.h2
echo "" > text.h
echo "enum {" >> text.h2
echo "static const char *global_text[] = {" >> text.h

echo "TEXTNUM_BACK=Back" >> text.txt
echo "TEXTNUM_MAIN=Main" >> text.txt
echo "TEXTNUM_SYSTEM=System" >> text.txt
echo "	TEXTNUM_BACK," >> text.h2
echo "	TEXTNUM_MAIN," >> text.h2
echo "	TEXTNUM_SYSTEM," >> text.h2
echo "	\"Back\"," >> text.h
echo "	\"Main\"," >> text.h
echo "	\"System\"," >> text.h

cat <<EOF
/*
	Don't edit this file: menu.c
	it is generated by: scripts/header2lcd-fe.sh
*/

#include <stdint.h>
#include <string.h>
#include <rc.h>
#include <glcd.h>
#include <rc_adc.h>
#include <rc_menu_support.h>
#include <rc_control.h>
#include <text.h>
#include <sound.h>

#ifdef SUPPORT_MENU

/* Main-Menu */
EOF

echo -n "enum {MENU_MAIN, MENU_SYSTEM"

for ENTRY in `cat /tmp/menu.txt`
do
	echo -n ", MENU_${ENTRY}"
done
cat <<EOF
, MENU_HF, MENU_MAX};
EOF

echo -n "const uint8_t textnum_MAIN[] = {TEXTNUM_MAIN, TEXTNUM_SYSTEM"
for ENTRY in `cat /tmp/menu.txt`
do
	if ! grep -s -q "^TEXTNUM_$ENTRY=" text.txt
	then
		echo "TEXTNUM_$ENTRY=$ENTRY" >> text.txt
		echo "	TEXTNUM_$ENTRY," >> text.h2
		echo "	\"$ENTRY\"," >> text.h
	fi
	TEXT_NUM="`grep -n "^TEXTNUM_$ENTRY=.*" text.txt | cut -d":" -f1`"
	echo -n ", TEXTNUM_${ENTRY}"
done
echo "};"
echo ""

for ENTRY in `cat /tmp/menu.txt`
do
	echo "/* ${ENTRY} */"
	echo -n "enum {MENU_${ENTRY}_BACK"
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
	do
		TYPE="`echo "$LINE" | awk '{print $1}'`"
		NAME="`echo "$LINE" | awk '{print $2}'`"
		SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
		LEN="`echo "$LINE" | awk '{print $3}'`"
		LEN2="`echo "$LINE" | sed "s|//.*||g" | awk '{print $4}'`"
		echo -n ", MENU_${ENTRY}_MODE_${SUB_NAME}"
	done
	if test "${ENTRY}" = "Control"
	then
		echo -n ", MENU_${ENTRY}_MODE_Expo, MENU_${ENTRY}_MODE_Dualrate, MENU_${ENTRY}_MODE_Mixer, MENU_${ENTRY}_MODE_Motion"
	elif test "${ENTRY}" = "Output"
	then
		echo -n ", MENU_${ENTRY}_MODE_Limiter, MENU_${ENTRY}_MODE_Atv, MENU_${ENTRY}_MODE_Mixer"
	fi
	echo ", MENU_${ENTRY}_MAX};"

	echo -n "const uint8_t textnum_${ENTRY}[] = {TEXTNUM_BACK"
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
	do
		TYPE="`echo "$LINE" | awk '{print $1}'`"
		NAME="`echo "$LINE" | awk '{print $2}'`"
		SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
		LEN="`echo "$LINE" | awk '{print $3}'`"
		LEN2="`echo "$LINE" | sed "s|//.*||g" | awk '{print $4}'`"
		TITLE="`echo "${SUB_NAME}" | tr "_" "-" | awk '{printf("%s%s\n",toupper(substr($0,1,1)),substr($0,2))}'`"
		if grep -s -q "^$TITLE|" translate.txt
		then
			TITLE="`grep "^$TITLE|" translate.txt | cut -d"|" -f2-`"
		else
			echo "$TITLE|$TITLE" >> translate.txt
		fi

		if ! grep -s -q "^TEXTNUM_$SUB_NAME=" text.txt
		then
			echo "TEXTNUM_$SUB_NAME=$TITLE" >> text.txt
			echo "	TEXTNUM_$SUB_NAME," >> text.h2
			echo "	\"$TITLE\"," >> text.h
		fi
		TEXT_NUM="`grep -n "^TEXTNUM_$SUB_NAME=.*" text.txt | cut -d":" -f1`"
		echo -n ", TEXTNUM_$SUB_NAME"
	done
	if test "${ENTRY}" = "Control"
	then
		echo -n ", TEXTNUM_Expo, TEXTNUM_Dualrate, TEXTNUM_Mixer, TEXTNUM_Motion"
	elif test "${ENTRY}" = "Output"
	then
		echo -n ", TEXTNUM_Limiter, TEXTNUM_Atv, TEXTNUM_Mixer"
	fi
	echo "};"

	echo -n "//const uint8_t entrytype_${ENTRY}[] = {ENTRY_TYPE_BACK"
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
	do
		TYPE="`echo "$LINE" | awk '{print $1}'`"
		NAME="`echo "$LINE" | awk '{print $2}'`"
		SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
		LEN="`echo "$LINE" | awk '{print $3}'`"
		LEN2="`echo "$LINE" | sed "s|//.*||g" | awk '{print $4}'`"
		TITLE="`echo "${SUB_NAME}" | tr "_" "-" | awk '{printf("%s%s\n",toupper(substr($0,1,1)),substr($0,2))}'`"
		echo -n ", ENTRY_TYPE_$SUB_NAME"
	done
	if test "${ENTRY}" = "Control"
	then
		echo -n ", ENTRY_TYPE_Expo, ENTRY_TYPE_Dualrate, ENTRY_TYPE_Mixer, ENTRY_TYPE_Motion"
	elif test "${ENTRY}" = "Output"
	then
		echo -n ", ENTRY_TYPE_Limiter, ENTRY_TYPE_Atv, ENTRY_TYPE_Mixer"
	fi
	echo "};"
	echo ""
done
echo ""

for ENTRY in `cat /tmp/menu.txt`
do
	echo "uint8_t menu_${ENTRY} (uint8_t cmd, uint8_t id);"
done
echo ""

cat <<EOF
extern uint8_t load_name_mmc (char *name_str, uint8_t model_id);
extern uint8_t load_setup_mmc (uint16_t model_id);
extern uint8_t save_setup_mmc (uint16_t model_id);
extern uint16_t GetADCChanel (uint8_t channel);
extern char *int2str (char *str, int value, char mode);
extern char *int2str_new (char *str, int16_t value, uint8_t mode, uint8_t digit, uint8_t close_str);

uint8_t MainEntry = 0;
uint8_t SubEntry = 1;
uint8_t Select = 0;
uint8_t ModeEntry = 0;
uint8_t cmd = 0;
uint8_t entry = 0;
uint8_t redraw = 10;

enum {
	VTYPE_BACK,
	VTYPE_CONTROL,
	VTYPE_OUTPUT,
	VTYPE_POINT,
	VTYPE_TEXT,
	VTYPE_TIME,
	VTYPE_NUM,
};


uint8_t menu_nav (uint8_t cmd, uint8_t id, uint8_t max, uint8_t *stage, uint8_t *entry) {
	char tmp_str[10];
	if (cmd == CMD_ENTER) {
		redraw = 2;
		if (entry[0] == 0) {
			entry[0] = 0;
			return 1;
		} else {
			cmd = 0;
			stage[0] = entry[0];
			entry[0] = 0;
		}
	} else if (cmd == CMD_UP) {
		if (entry[0] < max - 1) {
			entry[0]++;
		} else {
			entry[0] = 0;
		}
	} else if (cmd == CMD_DOWN) {
		if (entry[0] > 0) {
			entry[0]--;
		} else {
			entry[0] = max - 1;
		}
	}
	LCD_Font(1);
	int2str_new(tmp_str, id, 0, 0, 1);
	LCD_PrintXY(LCD_W / 3 * 2, 8, (char *)tmp_str, LCD_XOR, LCD_TRANS);
	if (LCD_W < 140) {
		LCD_Font(0);
	} else {
		LCD_Font(1);
	}
	LCD_Draw_Rec(0, 18, LCD_W - 1, LCD_H - 19);
	LCD_Draw_Rec(LCD_W - 10, 18, 9, LCD_H - 19);
	LCD_Draw_Box(LCD_W - 8, 19 + entry[0] * (LCD_H - 19 - 3) / max, 6, 3);
	return 0;
}

EOF

for ENTRY in `cat /tmp/menu.txt`
do
cat <<EOF
/* ${ENTRY} */
uint8_t menu_${ENTRY} (uint8_t cmd, uint8_t id) {
	char tmp_str[10];
	uint8_t x = 0;
	int8_t num = 0;
	int16_t start_num = 0;
	static uint8_t stage = 0;
	static uint8_t stage2 = 0;
EOF


cat <<EOF

	LCD_Clear();
	LCD_Header((char *)Rc_Model_name);

	x = LCD_PrintXY(0, 8, (char *)global_text[TEXTNUM_${ENTRY}], LCD_XOR, LCD_TRANS) + 8;
	if (stage != MENU_${ENTRY}_BACK) {
		x = LCD_PrintXY(x, 8, (char *)global_text[textnum_${ENTRY}[stage]], LCD_XOR, LCD_TRANS);
	}

	switch (stage) {
		case MENU_${ENTRY}_BACK:

			if (menu_nav(cmd, id, MENU_${ENTRY}_MAX, &stage, &entry) == 1) {
				return 1;
			}
			LCD_Font(1);

			num = 0;
			start_num = entry - MENU_HEIGHT / 2;
			if (start_num < 0) {
				start_num = 0;
			}
			for (num = 0; num < MENU_HEIGHT && num + start_num < MENU_${ENTRY}_MAX; num++) {
				if (num + start_num == entry) {
					LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);
				}
				x = LCD_PrintXY(3, 22 + (num * 10), (char *)global_text[textnum_${ENTRY}[num + start_num]], LCD_XOR, LCD_TRANS);

				switch (num + start_num) {

EOF

if test "${ENTRY}" = "Control"
then
	for TT in Expo Dualrate Mixer Motion
	do
		echo "//					case MENU_${ENTRY}_MODE_${TT}:"
		echo "//					break;"
	done
elif test "${ENTRY}" = "Output"
then
	for TT in Limiter Atv Mixer
	do
		echo "//					case MENU_${ENTRY}_MODE_${TT}:"
		echo "//					break;"
	done
fi

cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
do
	TYPE="`echo "$LINE" | awk '{print $1}'`"
	NAME="`echo "$LINE" | awk '{print $2}'`"
	SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
	LEN="`echo "$LINE" | sed "s|//.*||g" | awk '{print $3}'`"
	LEN2="`echo "$LINE" | sed "s|//.*||g" | awk '{print $4}'`"

	if test "$ENTRY" = "Model" || test "$ENTRY" = "PPMEncoder1" || test "$ENTRY" = "PPMEncoder2"
	then
		LEN=""
	fi
	if test "$LEN" = ""
	then
		if test "${SUB_NAME}" = "name"
		then
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						LCD_PrintXY(x + 3, 22 + (num * 10), (char *)Rc_${ENTRY}_${SUB_NAME}, LCD_XOR, LCD_TRANS);"
			echo "					break;"
		else
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						int2str_new(tmp_str, Rc_${ENTRY}_${SUB_NAME}, 0, 0, 1);"
			echo "						LCD_PrintXY(x + 3, 22 + (num * 10), (char *)tmp_str, LCD_XOR, LCD_TRANS);"
			echo "					break;"
		fi
	else
		if test "${SUB_NAME}" = "channel_in"
		then
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						print_control(x + 3, 22 + (num * 10), Rc_${ENTRY}_${SUB_NAME}[id], LCD_XOR, LCD_TRANS);"
			echo "					break;"
		elif test "${SUB_NAME}" = "channel_out"
		then
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						print_output(x + 3, 22 + (num * 10), Rc_${ENTRY}_${SUB_NAME}[id], LCD_XOR, LCD_TRANS);"
			echo "					break;"
		elif test "${SUB_NAME}" = "channel" && (test "${ENTRY}" = "Atv" || test "${ENTRY}" = "Limiter")
		then
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						print_output(x + 3, 22 + (num * 10), Rc_${ENTRY}_${SUB_NAME}[id], LCD_XOR, LCD_TRANS);"
			echo "					break;"
		elif test "${SUB_NAME}" = "channel"
		then
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						print_control(x + 3, 22 + (num * 10), Rc_${ENTRY}_${SUB_NAME}[id], LCD_XOR, LCD_TRANS);"
			echo "					break;"
		elif test "${SUB_NAME}" = "point"
		then
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						print_point(x + 3, 22 + (num * 10), Rc_${ENTRY}_${SUB_NAME}[id], LCD_XOR, LCD_TRANS);"
			echo "					break;"
		elif test "${SUB_NAME}" = "name"
		then
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						LCD_PrintXY(x + 3, 22 + (num * 10), (char *)Rc_${ENTRY}_${SUB_NAME}[id], LCD_XOR, LCD_TRANS);"
			echo "					break;"
		elif echo "${SUB_NAME}" | grep -s -q "control$\|switch$"
		then
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						print_control(x + 3, 22 + (num * 10), Rc_${ENTRY}_${SUB_NAME}[id], LCD_XOR, LCD_TRANS);"
			echo "					break;"
		elif echo "${SUB_NAME}" | grep -s -q "alarm\|time$"
		then
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						print_time(x + 3, 22 + (num * 10), Rc_${ENTRY}_${SUB_NAME}[id], LCD_XOR, LCD_TRANS);"
			echo "					break;"
		else
			echo "					case MENU_${ENTRY}_MODE_${SUB_NAME}:"
			echo "						x = LCD_PrintXY(x + 2, 22 + (num * 10), (char *)\":\", LCD_XOR, LCD_TRANS);"
			echo "						int2str_new(tmp_str, Rc_${ENTRY}_${SUB_NAME}[id], 0, 0, 1);"
			echo "						LCD_PrintXY(x + 3, 22 + (num * 10), (char *)tmp_str, LCD_XOR, LCD_TRANS);"
			echo "					break;"
		fi
	fi
done

cat <<EOF
				}

			}
			LCD_Font(1);

		break;
EOF

if test "${ENTRY}" = "Output"
then
	echo "		case MENU_${ENTRY}_MODE_Mixer:"
	echo "			if (stage2 == 0) {"
	echo "				if (menu_nav(cmd, id, MIXER_MAX + 1, &stage2, &entry) == 1) {"
	echo "					stage = 0;"
	echo "				}"
	echo "				LCD_Font(1);"
	echo "				num = 0;"
	echo "				start_num = entry - MENU_HEIGHT / 2;"
	echo "				if (start_num < 0) {"
	echo "					start_num = 0;"
	echo "				}"
	echo "				for (num = 0; num < MENU_HEIGHT && num + start_num < MIXER_MAX + 1; num++) {"
	echo "					if (num + start_num == entry) {"
	echo "						LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);"
	echo "					}"
	echo "					if (num + start_num == 0) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Back\", LCD_XOR, LCD_TRANS);"
	echo "					} else if (Rc_Mixer_channel_out[num + start_num - 1] == id) {"
	echo "						LCD_Font(2);"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\">\", LCD_XOR, LCD_TRANS);"
	echo "						print_control(x + 3, 22 + (num * 10), Rc_Mixer_channel_in[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "						LCD_Font(1);"
	echo "					} else if (Rc_Mixer_channel_out[num + start_num - 1] == CONTROL_NONE) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Unbelegt\", LCD_XOR, LCD_TRANS);"
	echo "					} else {"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\"Belegt\", LCD_XOR, LCD_TRANS);"
	echo "						print_output(x + 3, 22 + (num * 10), Rc_Mixer_channel_out[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "					}"
	echo "				}"
	echo "			} else {"
	echo "				if (Rc_Mixer_channel_out[stage2 - 1] == CONTROL_NONE) {"
	echo "					Rc_Mixer_channel_out[stage2 - 1] = id;"
	echo "					stage2 = 0;"
	echo "				}"
	echo "				if (menu_Mixer(cmd, stage2 - 1) == 1) {"
	echo "					stage2 = 0;"
	echo "				}"
	echo "			}"
	echo "		break;"

	echo "		case MENU_${ENTRY}_MODE_Limiter:"
	echo "			if (stage2 == 0) {"
	echo "				if (menu_nav(cmd, id, LIMITER_MAX + 1, &stage2, &entry) == 1) {"
	echo "					stage = 0;"
	echo "				}"
	echo "				LCD_Font(1);"
	echo "				num = 0;"
	echo "				start_num = entry - MENU_HEIGHT / 2;"
	echo "				if (start_num < 0) {"
	echo "					start_num = 0;"
	echo "				}"
	echo "				for (num = 0; num < MENU_HEIGHT && num + start_num < LIMITER_MAX + 1; num++) {"
	echo "					if (num + start_num == entry) {"
	echo "						LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);"
	echo "					}"
	echo "					if (num + start_num == 0) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Back\", LCD_XOR, LCD_TRANS);"
	echo "					} else if (Rc_Limiter_channel[num + start_num - 1] == id) {"
	echo "						LCD_Font(2);"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\">\", LCD_XOR, LCD_TRANS);"
	echo "						print_output(x + 3, 22 + (num * 10), Rc_Limiter_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "						LCD_Font(1);"
	echo "					} else if (Rc_Limiter_channel[num + start_num - 1] == CONTROL_NONE) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Unbelegt\", LCD_XOR, LCD_TRANS);"
	echo "					} else {"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\"Belegt\", LCD_XOR, LCD_TRANS);"
	echo "						print_output(x + 3, 22 + (num * 10), Rc_Limiter_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "					}"
	echo "				}"
	echo "			} else {"
	echo "				if (Rc_Limiter_channel[stage2 - 1] == CONTROL_NONE) {"
	echo "					Rc_Limiter_channel[stage2 - 1] = id;"
	echo "					stage2 = 0;"
	echo "				}"
	echo "				if (menu_Limiter(cmd, stage2 - 1) == 1) {"
	echo "					stage2 = 0;"
	echo "				}"
	echo "			}"
	echo "		break;"

	echo "		case MENU_${ENTRY}_MODE_Atv:"
	echo "			if (stage2 == 0) {"
	echo "				if (menu_nav(cmd, id, ATV_MAX + 1, &stage2, &entry) == 1) {"
	echo "					stage = 0;"
	echo "				}"
	echo "				LCD_Font(1);"
	echo "				num = 0;"
	echo "				start_num = entry - MENU_HEIGHT / 2;"
	echo "				if (start_num < 0) {"
	echo "					start_num = 0;"
	echo "				}"
	echo "				for (num = 0; num < MENU_HEIGHT && num + start_num < ATV_MAX + 1; num++) {"
	echo "					if (num + start_num == entry) {"
	echo "						LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);"
	echo "					}"
	echo "					if (num + start_num == 0) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Back\", LCD_XOR, LCD_TRANS);"
	echo "					} else if (Rc_Atv_channel[num + start_num - 1] == id) {"
	echo "						LCD_Font(2);"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\">\", LCD_XOR, LCD_TRANS);"
	echo "						print_output(x + 3, 22 + (num * 10), Rc_Atv_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "						LCD_Font(1);"
	echo "					} else if (Rc_Atv_channel[num + start_num - 1] == CONTROL_NONE) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Unbelegt\", LCD_XOR, LCD_TRANS);"
	echo "					} else {"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\"Belegt\", LCD_XOR, LCD_TRANS);"
	echo "						print_output(x + 3, 22 + (num * 10), Rc_Atv_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "					}"
	echo "				}"
	echo "			} else {"
	echo "				if (Rc_Atv_channel[stage2 - 1] == CONTROL_NONE) {"
	echo "					Rc_Atv_channel[stage2 - 1] = id;"
	echo "					stage2 = 0;"
	echo "				}"
	echo "				if (menu_Atv(cmd, stage2 - 1) == 1) {"
	echo "					stage2 = 0;"
	echo "				}"
	echo "			}"
	echo "		break;"

elif test "${ENTRY}" = "Control"
then
	echo "		case MENU_${ENTRY}_MODE_Mixer:"
	echo "			if (stage2 == 0) {"
	echo "				if (menu_nav(cmd, id, MIXER_MAX + 1, &stage2, &entry) == 1) {"
	echo "					stage = 0;"
	echo "				}"
	echo "				LCD_Font(1);"
	echo "				num = 0;"
	echo "				start_num = entry - MENU_HEIGHT / 2;"
	echo "				if (start_num < 0) {"
	echo "					start_num = 0;"
	echo "				}"
	echo "				for (num = 0; num < MENU_HEIGHT && num + start_num < MIXER_MAX + 1; num++) {"
	echo "					if (num + start_num == entry) {"
	echo "						LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);"
	echo "					}"
	echo "					if (num + start_num == 0) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Back\", LCD_XOR, LCD_TRANS);"
	echo "					} else if (Rc_Mixer_channel_in[num + start_num - 1] == id) {"
	echo "						LCD_Font(2);"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\">\", LCD_XOR, LCD_TRANS);"
	echo "						print_output(x + 3, 22 + (num * 10), Rc_Mixer_channel_out[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "						LCD_Font(1);"
	echo "					} else if (Rc_Mixer_channel_in[num + start_num - 1] == CONTROL_NONE) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Unbelegt\", LCD_XOR, LCD_TRANS);"
	echo "					} else {"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\"Belegt\", LCD_XOR, LCD_TRANS);"
	echo "						print_control(x + 3, 22 + (num * 10), Rc_Mixer_channel_in[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "					}"
	echo "				}"
	echo "			} else {"
	echo "				if (Rc_Mixer_channel_in[stage2 - 1] == CONTROL_NONE) {"
	echo "					Rc_Mixer_channel_in[stage2 - 1] = id;"
	echo "					stage2 = 0;"
	echo "				}"
	echo "				if (menu_Mixer(cmd, stage2 - 1) == 1) {"
	echo "					stage2 = 0;"
	echo "				}"
	echo "			}"
	echo "		break;"

	echo "		case MENU_${ENTRY}_MODE_Expo:"
	echo "			if (stage2 == 0) {"
	echo "				if (menu_nav(cmd, id, EXPO_MAX + 1, &stage2, &entry) == 1) {"
	echo "					stage = 0;"
	echo "				}"
	echo "				LCD_Font(1);"
	echo "				num = 0;"
	echo "				start_num = entry - MENU_HEIGHT / 2;"
	echo "				if (start_num < 0) {"
	echo "					start_num = 0;"
	echo "				}"
	echo "				for (num = 0; num < MENU_HEIGHT && num + start_num < EXPO_MAX + 1; num++) {"
	echo "					if (num + start_num == entry) {"
	echo "						LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);"
	echo "					}"
	echo "					if (num + start_num == 0) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Back\", LCD_XOR, LCD_TRANS);"
	echo "					} else if (Rc_Expo_channel[num + start_num - 1] == id) {"
	echo "						LCD_Font(2);"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\">\", LCD_XOR, LCD_TRANS);"
	echo "						print_control(x + 3, 22 + (num * 10), Rc_Expo_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "						LCD_Font(1);"
	echo "					} else if (Rc_Expo_channel[num + start_num - 1] == CONTROL_NONE) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Unbelegt\", LCD_XOR, LCD_TRANS);"
	echo "					} else {"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\"Belegt\", LCD_XOR, LCD_TRANS);"
	echo "						print_control(x + 3, 22 + (num * 10), Rc_Expo_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "					}"
	echo "				}"
	echo "			} else {"
	echo "				if (Rc_Expo_channel[stage2 - 1] == CONTROL_NONE) {"
	echo "					Rc_Expo_channel[stage2 - 1] = id;"
	echo "					stage2 = 0;"
	echo "				}"
	echo "				if (menu_Expo(cmd, stage2 - 1) == 1) {"
	echo "					stage2 = 0;"
	echo "				}"
	echo "			}"
	echo "		break;"

	echo "		case MENU_${ENTRY}_MODE_Dualrate:"
	echo "			if (stage2 == 0) {"
	echo "				if (menu_nav(cmd, id, DUALRATE_MAX + 1, &stage2, &entry) == 1) {"
	echo "					stage = 0;"
	echo "				}"
	echo "				LCD_Font(1);"
	echo "				num = 0;"
	echo "				start_num = entry - MENU_HEIGHT / 2;"
	echo "				if (start_num < 0) {"
	echo "					start_num = 0;"
	echo "				}"
	echo "				for (num = 0; num < MENU_HEIGHT && num + start_num < DUALRATE_MAX + 1; num++) {"
	echo "					if (num + start_num == entry) {"
	echo "						LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);"
	echo "					}"
	echo "					if (num + start_num == 0) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Back\", LCD_XOR, LCD_TRANS);"
	echo "					} else if (Rc_Dualrate_channel[num + start_num - 1] == id) {"
	echo "						LCD_Font(2);"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\">\", LCD_XOR, LCD_TRANS);"
	echo "						print_control(x + 3, 22 + (num * 10), Rc_Dualrate_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "						LCD_Font(1);"
	echo "					} else if (Rc_Dualrate_channel[num + start_num - 1] == CONTROL_NONE) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Unbelegt\", LCD_XOR, LCD_TRANS);"
	echo "					} else {"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\"Belegt\", LCD_XOR, LCD_TRANS);"
	echo "						print_control(x + 3, 22 + (num * 10), Rc_Dualrate_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "					}"
	echo "				}"
	echo "			} else {"
	echo "				if (Rc_Dualrate_channel[stage2 - 1] == CONTROL_NONE) {"
	echo "					Rc_Dualrate_channel[stage2 - 1] = id;"
	echo "					stage2 = 0;"
	echo "				}"
	echo "				if (menu_Dualrate(cmd, stage2 - 1) == 1) {"
	echo "					stage2 = 0;"
	echo "				}"
	echo "			}"
	echo "		break;"

	echo "		case MENU_${ENTRY}_MODE_Motion:"
	echo "			if (stage2 == 0) {"
	echo "				if (menu_nav(cmd, id, MOTION_MAX + 1, &stage2, &entry) == 1) {"
	echo "					stage = 0;"
	echo "				}"
	echo "				LCD_Font(1);"
	echo "				num = 0;"
	echo "				start_num = entry - MENU_HEIGHT / 2;"
	echo "				if (start_num < 0) {"
	echo "					start_num = 0;"
	echo "				}"
	echo "				for (num = 0; num < MENU_HEIGHT && num + start_num < MOTION_MAX + 1; num++) {"
	echo "					if (num + start_num == entry) {"
	echo "						LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);"
	echo "					}"
	echo "					if (num + start_num == 0) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Back\", LCD_XOR, LCD_TRANS);"
	echo "					} else if (Rc_Motion_channel[num + start_num - 1] == id) {"
	echo "						LCD_Font(2);"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\">\", LCD_XOR, LCD_TRANS);"
	echo "						print_control(x + 3, 22 + (num * 10), Rc_Motion_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "						LCD_Font(1);"
	echo "					} else if (Rc_Motion_channel[num + start_num - 1] == CONTROL_NONE) {"
	echo "						LCD_PrintXY(3, 22 + (num * 10), (char *)\"Unbelegt\", LCD_XOR, LCD_TRANS);"
	echo "					} else {"
	echo "						x = LCD_PrintXY(3, 22 + (num * 10), (char *)\"Belegt\", LCD_XOR, LCD_TRANS);"
	echo "						print_control(x + 3, 22 + (num * 10), Rc_Motion_channel[num + start_num - 1], LCD_XOR, LCD_TRANS);"
	echo "					}"
	echo "				}"
	echo "			} else {"
	echo "				if (Rc_Motion_channel[stage2 - 1] == CONTROL_NONE) {"
	echo "					Rc_Motion_channel[stage2 - 1] = id;"
	echo "					stage2 = 0;"
	echo "				}"
	echo "				if (menu_Motion(cmd, stage2 - 1) == 1) {"
	echo "					stage2 = 0;"
	echo "				}"
	echo "			}"
	echo "		break;"
fi

	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
	do
		TYPE="`echo "$LINE" | awk '{print $1}'`"
		NAME="`echo "$LINE" | awk '{print $2}'`"
		SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
		LEN="`echo "$LINE" | sed "s|//.*||g" | awk '{print $3}'`"
		LEN2="`echo "$LINE" | sed "s|//.*||g" | awk '{print $4}'`"
		echo "		case MENU_${ENTRY}_MODE_${SUB_NAME}:"
		if test "$LEN" = ""
		then
			if test "$TYPE" = "int8_t"
			then
				echo "			if (menu_edit_int8(cmd, (int8_t *)&Rc_${ENTRY}_${SUB_NAME}) == 1) {"
			elif test "$TYPE" = "int16_t"
			then
				echo "			if (menu_edit_int16(cmd, (int16_t *)&Rc_${ENTRY}_${SUB_NAME}) == 1) {"
			elif test "$TYPE" = "uint16_t"
			then
				echo "			if (menu_edit_uint16(cmd, (uint16_t *)&Rc_${ENTRY}_${SUB_NAME}) == 1) {"
			else
				echo "			if (menu_edit_uint8(cmd, (uint8_t *)&Rc_${ENTRY}_${SUB_NAME}) == 1) {"
			fi
		else
			if test "${SUB_NAME}" = "channel_in"
			then
				echo "			if (menu_edit_control(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
			elif test "${SUB_NAME}" = "channel_out"
			then
				echo "			if (menu_edit_output(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
			elif test "${SUB_NAME}" = "channel"
			then
				echo "			if (menu_edit_control(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
			elif echo "${SUB_NAME}" | grep -s -q "control$\|switch$"
			then
				echo "			if (menu_edit_control(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
			elif echo "${SUB_NAME}" | grep -s -q "alarm\|time$"
			then
				echo "			if (menu_edit_alarm(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
			elif test "${SUB_NAME}" = "name"
			then
				echo "			if (menu_edit_text(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
			elif test "${SUB_NAME}" = "point"
			then
				echo "			if (menu_edit_points(cmd, id) == 1) {"
			elif test "${SUB_NAME}" = "reverse"
			then
				echo "			if (menu_edit_flag(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
			elif test "${SUB_NAME}" = "stat"
			then
				echo "			if (menu_edit_flag(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
			else
				if test "$TYPE" = "int8_t"
				then
					echo "			if (menu_edit_int8(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
				elif test "$TYPE" = "int16_t"
				then
					echo "			if (menu_edit_int16(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
				elif test "$TYPE" = "uint16_t"
				then
					echo "			if (menu_edit_uint16(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
				else
					echo "			if (menu_edit_uint8(cmd, &Rc_${ENTRY}_${SUB_NAME}[id]) == 1) {"
				fi
			fi
		fi
		echo "				stage = 0;"
		echo "			}"
		echo "		break;"
	done

cat <<EOF
	}

	LCD_Update();
	return 0;
}

EOF
done


cat <<EOF
void menu_init (void) {
}

EOF


cat <<EOF
void menu (void) {
	static int8_t encoder = 0;
	int8_t num = 0;
	uint8_t enc_data = 0;
	uint8_t x = 0;
#ifdef PLATFORM_SDL	
	SDL_Event event;
	cmd = CMD_NONE;
	while ( SDL_PollEvent(&event) ) {
		switch (event.type) {
			case SDL_MOUSEBUTTONDOWN:
				if (event.button.button == 5) {
					cmd = CMD_UP;
				} else if (event.button.button == 4) {
					cmd = CMD_DOWN;
				} else if (event.button.button == 1 || event.button.button == 2) {
					cmd = CMD_ENTER;
				} else if (event.button.button == 3) {
					cmd = CMD_BACK;
				}
			break;
			case SDL_QUIT:
				exit(0);
			break;
		}
	}
#endif
#ifdef PLATFORM_STM32
	if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_A_PORT, RC_CONTROL_SW0_A_PIN) != 0) {
		enc_data |= 1;
	}
	if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_B_PORT, RC_CONTROL_SW0_B_PIN) != 0) {
		enc_data |= 2;
	}
	if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_C_PORT, RC_CONTROL_SW0_C_PIN) != 0) {
		enc_data |= 4;
	}
	cmd = Rc_REncoderDecode_menu_byte(enc_data, 0, 1, 2);
	if (cmd == CMD_UP) {
		encoder++;
		if (encoder >= 4) {
			encoder = 0;
			sound(1000, 20);
		} else {
			cmd = 0;
		}
	} else if (cmd == CMD_DOWN) {
		encoder--;
		if (encoder <= -5) {
			encoder = 0;
			sound(1200, 20);
		} else {
			cmd = 0;
		}
	} else if (cmd == CMD_ENTER) {
		sound(1300, 20);
		uint16_t timeout = 60000;
		while (cmd == CMD_ENTER && timeout > 0) {
			if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_A_PORT, RC_CONTROL_SW0_A_PIN) != 0) {
				enc_data |= 1;
			}
			if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_B_PORT, RC_CONTROL_SW0_B_PIN) != 0) {
				enc_data |= 2;
			}
			if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_C_PORT, RC_CONTROL_SW0_C_PIN) != 0) {
				enc_data |= 4;
			}
			cmd = Rc_REncoderDecode_menu_byte(enc_data, 0, 1, 2);
			timeout--;
		}
		if (timeout == 0) {
			sound(1000, 20);
			sound(1100, 20);
			sound(1200, 20);
			sound(1300, 20);
			sound(1400, 20);
			sound(500, 20);
			sound(600, 20);
			sound(700, 20);
			sound(800, 20);
			sound(900, 20);
			while (cmd == CMD_ENTER) {
				if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_A_PORT, RC_CONTROL_SW0_A_PIN) != 0) {
					enc_data |= 1;
				}
				if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_B_PORT, RC_CONTROL_SW0_B_PIN) != 0) {
					enc_data |= 2;
				}
				if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_C_PORT, RC_CONTROL_SW0_C_PIN) != 0) {
					enc_data |= 4;
				}
				cmd = Rc_REncoderDecode_menu_byte(enc_data, 0, 1, 2);
			}
			cmd = CMD_BACK;
		} else {
			sound(1400, 20);
			cmd = CMD_ENTER;
		}
	}
#endif
	if (cmd == CMD_BACK) {
		MainEntry = MENU_MAIN;
		SubEntry = 1;
		redraw = 1;
	} else if (redraw == 1 || cmd != 0) {
		redraw = 250;
		switch (MainEntry) {
			case MENU_MAIN:
				if (cmd == CMD_ENTER) {
					Select = 0;
					MainEntry = SubEntry;
					SubEntry = 0;
					entry = 0;
					redraw = 1;
				} else if (cmd == CMD_UP) {
					if (SubEntry < MENU_MAX - 2) {
						SubEntry++;
					} else {
						SubEntry = 1;
					}
				} else if (cmd == CMD_DOWN) {
					if (SubEntry > 1) {
						SubEntry--;
					} else {
						SubEntry = MENU_MAX - 2;
					}
				}

				LCD_Clear();
				LCD_Header((char *)Rc_Model_name);
				LCD_PrintXY(0, 8, (char *)"Mainmenu:", LCD_XOR, LCD_TRANS);

				int16_t start_num = SubEntry - MENU_HEIGHT / 2;
				if (start_num < 1) {
					start_num = 1;
				}
				for (num = 0; num < MENU_HEIGHT && num + start_num < MENU_MAX - 1; num++) {
					if (num + start_num == SubEntry) {
						LCD_Draw_Box(2, 20 + (num * 10), LCD_W - 13, 10);
					}
					LCD_PrintXY(3, 22 + (num * 10), (char *)global_text[textnum_MAIN[num + start_num]], LCD_XOR, LCD_TRANS);
				}
				LCD_Draw_Rec(0, 18, LCD_W - 1, LCD_H - 19);
				LCD_Draw_Rec(LCD_W - 10, 18, 9, LCD_H - 19);
				LCD_Draw_Box(LCD_W - 8, 19 + SubEntry * (LCD_H - 19 - 3) / MENU_MAX, 6, 3);
			break;
			case MENU_SYSTEM:
				if (menu_system(cmd) == 1) {
					SubEntry = MainEntry;
					MainEntry = 0;
				}
			break;
EOF

for ENTRY in `cat /tmp/menu.txt`
do
	SEARCH="`cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | sed "s|//.*||g" | awk '{print $3}' | head -n1`"
	if echo "$SEARCH" | grep -s -q -i "[a-z]"
	then
		echo "			case MENU_${ENTRY}:"
		if test "${ENTRY}" = "Control" || test "${ENTRY}" = "Dualrate" || test "${ENTRY}" = "Expo" ||  test "${ENTRY}" = "Output" || test "${ENTRY}" = "Atv" || test "${ENTRY}" = "Limiter" || test "${ENTRY}" = "Mixer" || test "${ENTRY}" = "Timer"
		then
			echo "				if (menu_select((char *)global_text[TEXTNUM_${ENTRY}], cmd, $SEARCH, (*menu_list_view_${ENTRY}), (*menu_${ENTRY})) == 1) {"
		else
			echo "				if (menu_select((char *)global_text[TEXTNUM_${ENTRY}], cmd, $SEARCH, (*menu_list_view_id), (*menu_${ENTRY})) == 1) {"
		fi
		echo "					SubEntry = MainEntry;"
		echo "					MainEntry = 0;"
		echo "				}"
		echo "			break;"
	else
		echo "			case MENU_${ENTRY}:"
		echo "				if (menu_${ENTRY}(cmd, 0) == 1) {"
		echo "					SubEntry = MainEntry;"
		echo "					MainEntry = 0;"
		echo "					redraw = 1;"
		echo "				}"
		echo "			break;"
	fi
done

cat <<EOF
			default:
				if (SubEntry == 0) {
					SubEntry = MainEntry;
					MainEntry = 0;
					redraw = 1;
				}
			break;
		}
		LCD_Update();
	} else if (redraw > 1) {
		redraw--;
	}

}

#endif

EOF

echo ""
echo ""

echo "};" >> text.h2
echo "};" >> text.h
cat text.h2 >> text.h
rm -rf text.h2
rm -rf text.txt
