#!/bin/sh
#
#

echo "/*"
echo "	Don't edit this file: menu.c */"
echo "	it is generated by: scripts/pins_txt2nokia-lcd-fe.sh"
echo "*/"
echo ""
(cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
do
	NAME="`echo "$LINE" | awk '{print $2}'`"
	echo "$NAME" | cut -d"_" -f2
done) | sort -u > /tmp/menu.txt

echo ""
echo "#include <rc.h>"
echo ""
echo "enum {"
echo "	CMD_NONE,"
echo "	CMD_UP,"
echo "	CMD_ENTER,"
echo "	CMD_DOWN,"
echo "};"
echo ""
echo "enum {"
echo "	TYPE_NONE,"
echo "	TYPE_SINGLE,"
echo "	TYPE_MULTI,"
echo "	TYPE_CONTROL,"
echo "	TYPE_CHANNEL_IN,"
echo "	TYPE_CHANNEL_OUT,"
echo "	TYPE_CHANNEL,"
echo "	TYPE_POINT_X,"
echo "	TYPE_POINT_Y,"
echo "	TYPE_MAX"
echo "};"
echo ""
echo "enum {"
echo "	MENU_MAIN,"
echo "	MENU_VOLTAGE_TEMP,"
echo "	MENU_MONITOR_CONTROL,"
echo "	MENU_MONITOR_OSC,"
echo "	MENU_MONITOR_INOUT,"
for ENTRY in `cat /tmp/menu.txt`
do
	echo "	MENU_$ENTRY,"
done
echo "	MENU_MAX,"
echo "};"
echo ""
for ENTRY in `cat /tmp/menu.txt`
do
	echo "enum {"
	echo "	MENU_${ENTRY}_BACK,"
	cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
	do
		TYPE="`echo "$LINE" | awk '{print $1}'`"
		NAME="`echo "$LINE" | awk '{print $2}'`"
		SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
		LEN="`echo "$LINE" | awk '{print $3}'`"
		LEN2="`echo "$LINE" | awk '{print $4}'`"

		if test "$LEN2" != ""
		then
			if test "${SUB_NAME}" = "point"
			then
				for NUM in 0 1 2 3 4 5 6
				do
					echo "	MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x,"
					echo "	MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y,"
				done
			else
				echo "	MENU_${ENTRY}_MODE_${SUB_NAME},"
			fi
		else
			echo "	MENU_${ENTRY}_MODE_${SUB_NAME},"
		fi
	done
	echo "	MENU_${ENTRY}_MAX,"
	echo "};"
	echo ""
done
echo ""
echo ""
N="0"
rm -rf /tmp/rcos-names.tmp
for ENTRY in `cat /tmp/menu.txt`
do
	SEARCH="`cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | head -n1`"
	rm -rf /tmp/flag_single.tmp
	cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | while read LINE
	do
		if test "$SEARCH" != "$LINE"
		then
			echo > /tmp/flag_single.tmp
		fi
	done
	if ! echo "$SEARCH" | grep -s -q -i "[a-z]"
	then
		continue;
	fi
	if ! test -e /tmp/flag_single.tmp
	then
		cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			LEN="`echo "$LINE" | awk '{print $3}'`"
			LEN2="`echo "$LINE" | awk '{print $4}'`"
			if test "$LEN2" != ""
			then
				if test "${SUB_NAME}" = "point"
				then
					for NUM in 0 1 2 3 4 5 6
					do
						echo "${SUB_NAME}${NUM}_x" >> /tmp/rcos-names.tmp
						echo "char *text_${SUB_NAME}${NUM}_x = \"$SUB_TITLE `expr ${NUM} + 1`(x)\";"

						echo "${SUB_NAME}${NUM}_y" >> /tmp/rcos-names.tmp
						echo "char *text_${SUB_NAME}${NUM}_y = \"$SUB_TITLE `expr ${NUM} + 1`(y)\";"
						N="`expr $N + 2`"
					done
				else
					echo "$SUB_NAME" >> /tmp/rcos-names.tmp
					echo "char *text_$SUB_NAME = \"$SUB_TITLE\";"
					N="`expr $N + 1`"
				fi
				continue;
			fi
			if grep -s -q "^$SUB_NAME$" /tmp/rcos-names.tmp
			then
				continue;
			fi
			echo "$SUB_NAME" >> /tmp/rcos-names.tmp
			echo "char *text_$SUB_NAME = \"$SUB_TITLE\";"
			N="`expr $N + 1`"
		done
	else
		cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			if grep -s -q "^$SUB_NAME$" /tmp/rcos-names.tmp
			then
				continue;
			fi
			echo "$SUB_NAME" >> /tmp/rcos-names.tmp
			echo "char *text_$SUB_NAME = \"$SUB_TITLE\";"
			N="`expr $N + 1`"
		done
	fi
done
echo ""
echo "char *text[MENU_MAX + 2][20];"
echo "uint8_t *value[MENU_MAX + 2][20];"
echo "uint8_t type[MENU_MAX + 2][20];"
echo "uint8_t extra[MENU_MAX + 2][20];"
echo "uint8_t len[MENU_MAX + 2];"
echo "uint8_t max[MENU_MAX + 2];"
echo ""
echo "uint8_t MainEntry = 0;"
echo "uint8_t SubEntry = 1;"
echo "uint8_t Select = 0;"
echo "uint8_t ModeEntry = 0;"
echo "uint8_t cmd = 0;"
echo ""
echo "char *input_name[16];"
echo "char *output_name[16];"
echo "char *name_aileron = \"Querruder\";"
echo "char *name_aileron1 = \"Querruder R\";"
echo "char *name_aileron2 = \"Querruder L\";"
echo "char *name_elevator = \"Hohenruder\";"
echo "char *name_elevator1 = \"Hohenruder R\";"
echo "char *name_elevator2 = \"Hohenruder L\";"
echo "char *name_rudder = \"Seitenruder\";"
echo "char *name_gear = \"Drossel\";"
echo "char *name_flaps = \"Landeklappen\";"
echo ""
echo "void print_mixer (uint8_t id) {"
echo "	char dat1[8];"
echo "	char dat2[8];"
echo "	char dat3[8];"
echo "	char dat4[8];"
echo "	char dat5[8];"
echo "	char dat6[8];"
echo "	uint8_t n;"
echo "	uint8_t x;"
echo "	uint8_t y;"
echo "	for (n = 0; n < 8; n++) {"
echo "		dat1[n] = 16;"
echo "		dat2[n] = 0;"
echo "		dat3[n] = 1;"
echo "		dat4[n] = 16;"
echo "		dat5[n] = 0;"
echo "		dat6[n] = 1;"
echo "	}"
echo "	dat1[0] = 255;"
echo "	dat2[0] = 255;"
echo "	dat3[0] = 255;"
echo "	dat4[7] = 255;"
echo "	dat5[7] = 255;"
echo "	dat6[7] = 255;"
echo "	for (n = 0; n < 7; n++) {"
echo "		x = 14 - (Rc_Mixer_point[id][n][0] / 8);"
echo "		y = Rc_Mixer_point[id][n][1] / 8 + 1;"
echo "		if (y > 7) {"
echo "			if (x > 10) {"
echo "				dat4[y - 8] |= (1<<(x - 10 - 1));"
echo "			} else if (x > 5) {"
echo "				dat5[y - 8] |= (1<<(x - 5 - 1));"
echo "			} else {"
echo "				dat6[y - 8] |= (1<<(x - 1));"
echo "			}"
echo "		} else {"
echo "			if (x > 10) {"
echo "				dat1[y] |= (1<<(x - 10 - 1));"
echo "			} else if (x > 5) {"
echo "				dat2[y] |= (1<<(x - 5 - 1));"
echo "			} else {"
echo "				dat3[y] |= (1<<(x - 1));"
echo "			}"
echo "		}"
echo "	}"
echo "	LCD_Write(LCD_CGRAM(1), LCD_CMD);"
echo "	for (n = 0; n < 8; n++) {"
echo "		LCD_Write(dat1[n], LCD_CHAR);"
echo "	}"
echo "	for (n = 0; n < 8; n++) {"
echo "		LCD_Write(dat2[n], LCD_CHAR);"
echo "	}"
echo "	for (n = 0; n < 8; n++) {"
echo "		LCD_Write(dat3[n], LCD_CHAR);"
echo "	}"
echo "	for (n = 0; n < 8; n++) {"
echo "		LCD_Write(dat4[n], LCD_CHAR);"
echo "	}"
echo "	for (n = 0; n < 8; n++) {"
echo "		LCD_Write(dat5[n], LCD_CHAR);"
echo "	}"
echo "	for (n = 0; n < 8; n++) {"
echo "		LCD_Write(dat6[n], LCD_CHAR);"
echo "	}"
echo "	LCD_Write(LCD_LINE_1 + 17, LCD_CMD);"
echo "	LCD_Write(1, LCD_CHAR);"
echo "	LCD_Write(2, LCD_CHAR);"
echo "	LCD_Write(3, LCD_CHAR);"
echo "	LCD_Write(LCD_LINE_2 + 17, LCD_CMD);"
echo "	LCD_Write(4, LCD_CHAR);"
echo "	LCD_Write(5, LCD_CHAR);"
echo "	LCD_Write(6, LCD_CHAR);"
echo "}"
echo ""
echo "void print_control (uint8_t y, uint8_t x, uint8_t control_id) {"
echo "	uint8_t tmp_str[10];"
echo "	if (control_id == 0) {"
echo "		LCD_Print(y, x, \"Off\");"
echo "	} else if (control_id < 16 && input_name[control_id] != 0) {"
echo "		LCD_Print(y, x, input_name[control_id - 1]);"
echo "	} else if (control_id == 0) {"
echo "		LCD_Print(y, x, \"Off\");"
echo "	} else if (control_id == 255) {"
echo "		LCD_Print(y, x, \"On\");"
echo "	} else if (control_id < 20) {"
echo "		char tmp_str[] = \"Geber- \";"
echo "		tmp_str[6] = 'A' + control_id - 1;"
echo "		LCD_Print(y, x, tmp_str);"
echo "	} else if (control_id >= 20 && control_id < 50) {"
echo "		char tmp_str[] = \"Geber  \";"
echo "		int2str(tmp_str + 5, control_id - 19, 0);"
echo "		LCD_Print(y, x, tmp_str);"
echo "	} else {"
echo "		LCD_Print(y, x, int2str(tmp_str, control_id, 0));"
echo "	}"
echo "}"
echo ""
echo "void print_output (uint8_t y, uint8_t x, uint8_t output_id) {"
echo "	uint8_t tmp_str[10];"
echo "	if (output_id < 16 && output_name[output_id] != 0) {"
echo "		LCD_Print(y, x, output_name[output_id]);"
echo "	} else if (output_id == 255) {"
echo "		LCD_Print(y, x, \"None\");"
echo "	} else if (output_id < 20) {"
echo "		char tmp_str[] = \"PPM1-\";"
echo "		int2str(tmp_str + 5, output_id + 1, 0);"
echo "		LCD_Print(y, x, tmp_str);"
echo "	} else {"
echo "		LCD_Print(y, x, int2str(tmp_str, output_id, 0));"
echo "	}"
echo "}"
echo ""
echo ""
echo "void setup_plane1 (void) {"
echo "	int8_t num = 0;"
echo "	Rc_Cmd_Init();"
echo ""
echo "	input_name[0] = name_aileron;"
echo "	input_name[1] = name_elevator;"
echo "	input_name[2] = name_gear;"
echo "	input_name[3] = name_rudder;"
echo "	input_name[4] = name_flaps;"
echo ""
echo "	output_name[0] = name_aileron;"
echo "	output_name[1] = name_elevator;"
echo "	output_name[2] = name_gear;"
echo "	output_name[3] = name_rudder;"
echo "	output_name[4] = name_flaps;"
echo ""
echo "	Rc_Input_control[0] = 1;"
echo "	Rc_Input_control[1] = 2;"
echo "	Rc_Input_control[2] = 3;"
echo "	Rc_Input_control[3] = 4;"
echo "	Rc_Input_control[4] = 5;"
echo ""
echo "	for (num = 0; num < INPUT_MAX && num < MIXER_MAX && num < OUTPUT_MAX; num++) {"
echo "		Rc_Mixer_channel_in[num] = num;"
echo "		Rc_Mixer_channel_out[num] = num;"
echo "		Rc_Mixer_percent_value[num] = 100;"
echo "		Rc_Mixer_percent_control[num] = CONTROL_ON;"
echo "	}"
echo "	for (num = 0; num < ATV_MAX; num++) {"
echo "		Rc_Atv_channel[num] = num;"
echo "		Rc_Atv_switch[num] = CONTROL_OFF;"
echo "		Rc_Atv_up_value[num] = 100;"
echo "		Rc_Atv_up_control[num] = CONTROL_ON;"
echo "		Rc_Atv_down_value[num] = 100;"
echo "		Rc_Atv_down_control[num] = CONTROL_ON;"
echo "	}"
echo "	for (num = 0; num < EXPO_MAX; num++) {"
echo "		Rc_Expo_type[num] = 0;"
echo "		Rc_Expo_channel[num] = num;"
echo "		Rc_Expo_switch[num] = CONTROL_OFF;"
echo "		Rc_Expo_gradient_value[num] = 50;"
echo "		Rc_Expo_gradient_control[num] = CONTROL_ON;"
echo "	}"
echo "	for (num = 0; num < DUALRATE_MAX; num++) {"
echo "		Rc_Dualrate_channel[num] = num;"
echo "		Rc_Dualrate_switch[num] = CONTROL_OFF;"
echo "		Rc_Dualrate_limit_value[num] = 80;"
echo "		Rc_Dualrate_limit_control[num] = CONTROL_ON;"
echo "	}"
echo ""
echo "}"
echo ""
echo "void setup_plane2 (void) {"
echo "	int8_t num = 0;"
echo "	input_name[0] = name_aileron;"
echo "	input_name[1] = name_elevator;"
echo "	input_name[2] = name_gear;"
echo "	input_name[3] = name_rudder;"
echo "	input_name[4] = name_flaps;"
echo ""
echo "	output_name[0] = name_aileron1;"
echo "	output_name[1] = name_aileron2;"
echo "	output_name[2] = name_elevator1;"
echo "	output_name[3] = name_elevator2;"
echo "	output_name[4] = name_rudder;"
echo "	output_name[5] = name_gear;"
echo "	output_name[6] = name_flaps;"
echo "}"
echo ""
echo ""
echo "void menu_init (void) {"
echo "	int8_t num = 0;"
echo "	for (num = 0; num < 16; num++) {"
echo "		input_name[num] = 0;"
echo "		output_name[num] = 0;"
echo "	}"
echo "	setup_plane1();"
echo ""
echo "	text[MENU_MAIN][0] = \"Main\";"
echo "	text[MENU_VOLTAGE_TEMP][0] = \"Volt/Temp.\";"
echo "	text[MENU_MONITOR_CONTROL][0] = \"Control-Monitor\";"
echo "	text[MENU_MONITOR_OSC][0] = \"ADC-Monitor\";"
echo "	text[MENU_MONITOR_INOUT][0] = \"IN/Out-Monitor\";"
for ENTRY in `cat /tmp/menu.txt`
do
	SEARCH="`cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | head -n1`"
	rm -rf /tmp/flag_single.tmp
	cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | while read LINE
	do
		if test "$SEARCH" != "$LINE"
		then
			echo > /tmp/flag_single.tmp
		fi
	done
	if ! echo "$SEARCH" | grep -s -q -i "[a-z]"
	then
		continue;
	fi
	echo "	text[MENU_${ENTRY}][0] = \"$ENTRY\";"
	echo "	value[MENU_${ENTRY}][0] = 0;"
	if ! test -e /tmp/flag_single.tmp
	then
		echo "	len[MENU_${ENTRY}] = MENU_${ENTRY}_MAX - 1;"
		echo "	max[MENU_${ENTRY}] = $SEARCH;"
		echo "	type[MENU_${ENTRY}][0] = TYPE_MULTI;"
		N2="1"
		cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			LEN="`echo "$LINE" | awk '{print $3}'`"
			LEN2="`echo "$LINE" | awk '{print $4}'`"
			if test "$LEN2" != ""
			then
				if test "${SUB_NAME}" = "point"
				then
					for NUM in 0 1 2 3 4 5 6
					do
						echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x] = text_${SUB_NAME}${NUM}_x;"
						echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y] = text_${SUB_NAME}${NUM}_y;"
						echo "	value[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x] = &Rc_${ENTRY}_${SUB_NAME};"
						echo "	value[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y] = &Rc_${ENTRY}_${SUB_NAME};"
						echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x] = TYPE_POINT_X;"
						echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y] = TYPE_POINT_Y;"
						echo "	extra[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x] = $NUM;"
						echo "	extra[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y] = $NUM;"
					done
				else
					echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = text_$SUB_NAME;"
				fi
				continue;
			fi
			echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = text_$SUB_NAME;"
			echo "	value[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = &Rc_${ENTRY}_${SUB_NAME};"

			if echo "$SUB_NAME" | grep -s -q "control\|switch"
			then
				echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CONTROL;"
			elif echo "$SUB_NAME" | grep -s -q "channel_in"
			then
				echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL_IN;"
			elif echo "$SUB_NAME" | grep -s -q "channel_out"
			then
				echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL_OUT;"
			elif echo "$SUB_NAME" | grep -s -q "channel"
			then
				if test "${ENTRY}" = "Expo" || test "${ENTRY}" = "Dualrate"
				then
					echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL_IN;"
				elif test "${ENTRY}" = "Limiter" || test "${ENTRY}" = "Atv"
				then
					echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL_OUT;"
				else
					echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL;"
				fi
			else
				echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_NONE;"
			fi
		done
	else
		echo "	len[MENU_${ENTRY}] = MENU_${ENTRY}_MAX - 1;"
		echo "	max[MENU_${ENTRY}] = 1;"
		echo "	type[MENU_${ENTRY}][0] = TYPE_SINGLE;"
		N2="1"
		cat rcos-stm32-0.1/rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"

			echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = text_$SUB_NAME;"
			echo "	value[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = &Rc_${ENTRY}_${SUB_NAME};"
			echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_NONE;"
		done
	fi
done
echo "}"
echo ""
echo "extern uint16_t ADC_RegularConvertedValueTab[ADC_CHANNELS_MAX * 4];"
echo ""
echo "void menu (void) {"
echo "	static uint8_t redraw = 1;"
echo "	static int8_t encoder = 0;"
echo "	int8_t num = 0;"
echo ""
echo "	uint8_t tmp_str[10];"
echo "	uint8_t enc_data[3];"
echo "	Rc_ShiftRegRead_Data(enc_data, 2);"
echo "	cmd = Rc_REncoderDecode_menu_byte(enc_data[1], 3, 4, 2);"
echo ""
echo "	if (cmd == CMD_UP) {"
echo "		encoder++;"
echo "		if (encoder >= 4) {"
echo "			encoder = 0;"
echo "		} else {"
echo "			return;"
echo "		}"
echo "	} else if (cmd == CMD_DOWN) {"
echo "		encoder--;"
echo "		if (encoder <= -5) {"
echo "			encoder = 0;"
echo "		} else {"
echo "			return;"
echo "		}"
echo "	}"
echo ""
echo "	if (cmd != 0) {"
echo "		redraw = 15;"
echo "		if (cmd == CMD_ENTER) {"
echo "			while (cmd == CMD_ENTER) {"
echo "				Rc_ShiftRegRead_Data(enc_data, 2);"
echo "				cmd = Rc_REncoderDecode_menu_byte(enc_data[1], 3, 4, 2);"
echo "			}"
echo "			cmd = CMD_ENTER;"
echo "		}"
echo ""
echo "		uint8_t flag_select = 0;"
echo "		uint8_t flag_mode = 0;"
echo "		uint8_t *tmp = 0;"
echo "		switch (MainEntry) {"
echo "			case MENU_MAIN:"
echo "				if (cmd == CMD_ENTER) {"
echo "					MainEntry = SubEntry;"
echo "					if (type[MainEntry][0] == TYPE_SINGLE) {"
echo "						SubEntry = 1;"
echo "					} else {"
echo "						SubEntry = 0;"
echo "					}"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (SubEntry < MENU_MAX - 2) {"
echo "						SubEntry++;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (SubEntry > 1) {"
echo "						SubEntry--;"
echo "					}"
echo "				}"
echo "			break;"
echo "			case MENU_VOLTAGE_TEMP:"
echo "			case MENU_MONITOR_CONTROL:"
echo "			case MENU_MONITOR_INOUT:"
echo "				if (cmd == CMD_ENTER) {"
echo "					SubEntry = MainEntry;"
echo "					MainEntry = 0;"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (SubEntry < 12) {"
echo "						SubEntry++;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (SubEntry > 0) {"
echo "						SubEntry--;"
echo "					}"
echo "				}"
echo "			break;"
echo "			case MENU_MONITOR_OSC:"
echo "				if (cmd == CMD_ENTER) {"
echo "					SubEntry = MainEntry;"
echo "					MainEntry = 0;"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (SubEntry < 255) {"
echo "						SubEntry++;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (SubEntry > 0) {"
echo "						SubEntry--;"
echo "					}"
echo "				}"
echo "			break;"
echo "			default:"
echo "				if (SubEntry == 0) {"
echo "					if (Select == 0) {"
echo "						if (cmd == CMD_ENTER) {"
echo "							SubEntry = MainEntry;"
echo "							MainEntry = 0;"
echo "						}"
echo "					} else {"
echo "						if (cmd == CMD_ENTER) {"
echo "							SubEntry = Select;"
echo "							Select = 0;"
echo "						}"
echo "					}"
echo "					if (cmd == CMD_UP) {"
echo "						if (Select < max[MainEntry]) {"
echo "							Select++;"
echo "						}"
echo "					} else if (cmd == CMD_DOWN) {"
echo "						if (Select > 0) {"
echo "							Select--;"
echo "						}"
echo "					}"
echo "				} else {"
echo "					if (ModeEntry == 0) {"
echo "						if (Select == 0) {"
echo "							if (cmd == CMD_ENTER) {"
echo "								if (type[MainEntry][0] == TYPE_SINGLE) {"
echo "									SubEntry = MainEntry;"
echo "									MainEntry = 0;"
echo "								} else {"
echo "									SubEntry = 0;"
echo "								}"
echo "								Select = 0;"
echo "							}"
echo "						} else {"
echo "							if (cmd == CMD_ENTER) {"
echo "								ModeEntry = Select;"
echo "								Select = 0;"
echo "							}"
echo "						}"
echo "						if (cmd == CMD_UP) {"
echo "							if (Select < len[MainEntry]) {"
echo "								Select++;"
echo "							}"
echo "						} else if (cmd == CMD_DOWN) {"
echo "							if (Select > 0) {"
echo "								Select--;"
echo "							}"
echo "						}"
echo "					} else {"
echo "						if (type[MainEntry][Select] == TYPE_POINT_X) {"
echo "							tmp = &Rc_Mixer_point[SubEntry - 1][extra[MainEntry][ModeEntry]][0];"
echo "						} else if (type[MainEntry][Select] == TYPE_POINT_Y) {"
echo "							tmp = &Rc_Mixer_point[SubEntry - 1][extra[MainEntry][ModeEntry]][1];"
echo "						} else {"
echo "							tmp = &value[MainEntry][ModeEntry][SubEntry - 1];"
echo "						}"
echo "						if (cmd == CMD_UP) {"
echo "							if (tmp[0] < 255) {"
echo "								tmp[0]++;"
echo "							} else {"
echo "								tmp[0] = 0;"
echo "							}"
echo "						} else if (cmd == CMD_DOWN) {"
echo "							if (tmp[0] > 0) {"
echo "								tmp[0]--;"
echo "							} else {"
echo "								tmp[0] = 255;"
echo "							}"
echo "						} else if (cmd == CMD_ENTER) {"
echo "							Select = ModeEntry;"
echo "							ModeEntry = 0;"
echo "						}"
echo "					}"
echo "				}"
echo "			break;"
echo "		}"
echo "	}"
echo ""
echo "	if (redraw > 1) {"
echo "		redraw--;"
echo "	} else if (redraw == 1) {"
echo "		uint16_t temperature;"
echo "		uint16_t voltage;"
echo "		static uint8_t pos;"
echo "		redraw = 0;"
echo "		if (MainEntry > MENU_MONITOR_INOUT && SubEntry == 0) {"
echo "			LCD_Clear();"
echo "			LCD_Print(LCD_LINE_1, 0, text[MainEntry][0]);"
echo "			if (Select == 0) {"
echo "				LCD_Print(LCD_LINE_2, 0, \"<-Back    \");"
echo "			} else if (MainEntry == MENU_Mixer) {"
echo "				LCD_Print(LCD_LINE_1, 6, int2str(tmp_str, Select, 0));"
echo "				print_control(LCD_LINE_2, 0, Rc_Input_control[Rc_Mixer_channel_in[Select - 1]]);"
echo "				LCD_Print(LCD_LINE_2, 10, \"->\");"
echo "				print_output(LCD_LINE_2, 12, Rc_Mixer_channel_out[Select - 1]);"
echo "			} else if (MainEntry == MENU_Expo) {"
echo "				LCD_Print(LCD_LINE_1, 6, int2str(tmp_str, Select, 0));"
echo "				print_control(LCD_LINE_2, 4, Rc_Input_control[Rc_Expo_channel[Select - 1]]);"
echo "			} else if (MainEntry == MENU_Dualrate) {"
echo "				LCD_Print(LCD_LINE_1, 10, int2str(tmp_str, Select, 0));"
echo "				print_control(LCD_LINE_2, 4, Rc_Input_control[Rc_Dualrate_channel[Select - 1]]);"
echo "			} else if (MainEntry == MENU_Limiter) {"
echo "				LCD_Print(LCD_LINE_1, 7, int2str(tmp_str, Select, 0));"
echo "				print_output(LCD_LINE_2, 4, Rc_Limiter_channel[Select - 1]);"
echo "			} else if (MainEntry == MENU_Atv) {"
echo "				LCD_Print(LCD_LINE_1, 6, int2str(tmp_str, Select, 0));"
echo "				print_output(LCD_LINE_2, 4, Rc_Atv_channel[Select - 1]);"
echo "			} else if (MainEntry == MENU_Input) {"
echo "				LCD_Print(LCD_LINE_1, 6, int2str(tmp_str, Select, 0));"
echo "				print_control(LCD_LINE_2, 4, Rc_Input_control[Select - 1]);"
echo "			} else if (MainEntry == MENU_Output) {"
echo "				LCD_Print(LCD_LINE_1, 7, int2str(tmp_str, Select, 0));"
echo "				print_output(LCD_LINE_2, 4, Select - 1);"
echo "			} else {"
echo "				LCD_Print(LCD_LINE_2, 2, \"Num:\");"
echo "				LCD_Print(LCD_LINE_2, 7, int2str(tmp_str, Select, 0));"
echo "			}"
echo "		} else if (MainEntry > MENU_MONITOR_INOUT) {"
echo "			LCD_Clear();"
echo "			LCD_Print(LCD_LINE_1, 0, text[MainEntry][0]);"
echo "			LCD_Print(LCD_LINE_1, 12, int2str(tmp_str, SubEntry, 0));"
echo "			if (ModeEntry == 0) {"
echo "				if (Select == 0) {"
echo "					LCD_Print(LCD_LINE_2, 0, \"<-Back    \");"
echo "				} else {"
echo "					LCD_Print(LCD_LINE_2, 0, \"->\");"
echo "					LCD_Print(LCD_LINE_2, 2, text[MainEntry][Select]);"
echo "				}"
echo "			} else {"
echo "				Select = ModeEntry;"
echo "				LCD_Print(LCD_LINE_2, 0, text[MainEntry][Select]);"
echo "			}"
echo "		}"
echo "		switch (MainEntry) {"
echo "			case MENU_MAIN:"
echo "				LCD_Clear();"
echo "				LCD_Print(LCD_LINE_1, 0, \"Mainmenu:  \");"
echo "				LCD_Print(LCD_LINE_2, 0, text[SubEntry][0]);"
echo "			break;"
echo "			case MENU_VOLTAGE_TEMP:"
echo "				LCD_Clear();"
echo "				redraw = 10;"
echo "				temperature = (int16_t)(((1.4 - (float)ADC_RegularConvertedValueTab[ADC_CHANNELS_MAX - 1] * 3.3 / 4096.0) / 0.004478) + 25.0 * 10.0);"
echo "				voltage = (int16_t)((float)ADC_RegularConvertedValueTab[ADC_CHANNELS_MAX - 2] * 15.6 / 4096.0 * 100.0);"
echo "				tmp_str[0] = (temperature / 100) + 0x30;"
echo "				tmp_str[1] = ((temperature % 100) / 10) + 0x30;"
echo "				tmp_str[2] = '.';"
echo "				tmp_str[3] = ((temperature % 100) % 10) + 0x30;"
echo "				tmp_str[4] = 'C';"
echo "				tmp_str[5] = 0;"
echo "				LCD_Print(LCD_LINE_1, 0, \"CPU-Temp.  \");"
echo "				LCD_Print(LCD_LINE_1, 13, tmp_str);"
echo "				tmp_str[0] = (voltage / 1000) + 0x30;"
echo "				tmp_str[0] = ((voltage % 1000) / 100) + 0x30;"
echo "				tmp_str[1] = '.';"
echo "				tmp_str[2] = (((voltage % 1000) % 100) / 10) + 0x30;"
echo "				tmp_str[3] = (((voltage % 1000) % 100) % 10) + 0x30;"
echo "				tmp_str[4] = 'V';"
echo "				tmp_str[5] = 0;"
echo "				LCD_Print(LCD_LINE_2, 0, \"Battery   \");"
echo "				LCD_Print(LCD_LINE_2, 13, tmp_str);"
echo "			break;"
echo "			case MENU_MONITOR_CONTROL:"
echo "				LCD_Clear();"
echo "				redraw = 10;"
echo "				LCD_Print(LCD_LINE_1, 0, \"Control: \");"
echo "				LCD_Print(LCD_LINE_1, 9, int2str(tmp_str, (20 * SubEntry) + 1, 0));"
echo "				LCD_Print(LCD_LINE_1, 13, \"->\");"
echo "				LCD_Print(LCD_LINE_1, 16, int2str(tmp_str, (20 * SubEntry) + 20, 0));"
echo "				LCD_Write(LCD_LINE_2, LCD_CMD);"
echo "				for (num = 0; num < INPUT_ADC_MAX; num++) {"
echo "					LCD_Write(((Rc_AdcRead(num) / 8) + 128) / 32 + 1, LCD_CHAR);"
echo "				}"
echo "			break;"
echo "			case MENU_MONITOR_INOUT:"
echo "				LCD_Clear();"
echo "				redraw = 10;"
echo "				LCD_Write(LCD_LINE_1, LCD_CMD);"
echo "				for (num = 0; num < 20; num++) {"
echo "					LCD_Write(((Rc_Input_value[num] / 8) + 128) / 32 + 1, LCD_CHAR);"
echo "				}"
echo "				LCD_Write(LCD_LINE_2, LCD_CMD);"
echo "				for (num = 0; num < 20; num++) {"
echo "					LCD_Write(((Rc_Output_value[num] / 8) + 128) / 32 + 1, LCD_CHAR);"
echo "				}"
echo "			break;"
echo "			case MENU_MONITOR_OSC:"
echo "				redraw = 10;"
echo "				if (pos < 20) {"
echo "					LCD_Write(LCD_LINE_2 + pos, LCD_CMD);"
echo "					LCD_Write(((Rc_AdcRead(SubEntry) / 8) + 128) / 32 + 1, LCD_CHAR);"
echo "					pos++;"
echo "				} else {"
echo "					LCD_Print(LCD_LINE_1, 0, \"ADC-Input:     \");"
echo "					LCD_Print(LCD_LINE_1, 12, int2str(tmp_str, SubEntry + 1, 0));"
echo "					pos = 0;"
echo "				}"
echo "			break;"
echo "			default:"
echo "				if (Select > 0 && SubEntry > 0 && value[MainEntry][Select] != 0) {"
echo "					if (type[MainEntry][Select] == TYPE_CONTROL) {"
echo "						print_control(LCD_LINE_2, 13, value[MainEntry][Select][SubEntry - 1]);"
echo "					} else if (type[MainEntry][Select] == TYPE_CHANNEL_IN) {"
echo "						print_control(LCD_LINE_2, 13, Rc_Input_control[value[MainEntry][Select][SubEntry - 1]]);"
echo "					} else if (type[MainEntry][Select] == TYPE_CHANNEL_OUT) {"
echo "						print_output(LCD_LINE_2, 13, value[MainEntry][Select][SubEntry - 1]);"
echo "					} else if (type[MainEntry][Select] == TYPE_CHANNEL) {"
echo "						LCD_Print(LCD_LINE_2, 12, \"Ch-\");"
echo "						LCD_Print(LCD_LINE_2, 15, int2str(tmp_str, value[MainEntry][Select][SubEntry - 1], 0));"
echo "					} else if (type[MainEntry][Select] == TYPE_POINT_Y || type[MainEntry][Select] == TYPE_POINT_X) {"
echo "						if (type[MainEntry][Select] == TYPE_POINT_X) {"
echo "							LCD_Print(LCD_LINE_2, 12, int2str(tmp_str, Rc_Mixer_point[SubEntry - 1][extra[MainEntry][Select]][0], 0));"
echo "							LCD_Write('%', LCD_CHAR);"
echo "						} else if (type[MainEntry][Select] == TYPE_POINT_Y || type[MainEntry][Select] == TYPE_POINT_X) {"
echo "							LCD_Print(LCD_LINE_2, 12, int2str(tmp_str, Rc_Mixer_point[SubEntry - 1][extra[MainEntry][Select]][1], 0));"
echo "							LCD_Write('%', LCD_CHAR);"
echo "						}"
echo "						print_mixer(SubEntry - 1);"
echo "					} else {"
echo "						LCD_Print(LCD_LINE_2, 17, int2str(tmp_str, value[MainEntry][Select][SubEntry - 1], 0));"
echo "					}"
echo "				}"
echo "			break;"
echo "		}"
echo "	}"
echo "}"






