#!/bin/sh
#
#

echo "/*"
echo "	Don't edit this file: menu.c"
echo "	it is generated by: scripts/pins_txt2nokia-lcd-fe.sh"
echo "*/"
echo ""
cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $2}' | cut -d"_" -f2 | grep -v "\<Flag\>" | grep -v "\<Servo\>" | grep -v "\<Calibrate\>" | grep -v "\<Model\>" | uniq > /tmp/menu.txt

echo ""
echo "#include \"stm32f10x_lib.h\""
echo "#include \"stm32f10x_conf.h\""
echo ""
echo "#include <stdint.h>"
echo "#include <string.h>"
echo "#include <rc.h>"
echo "#include <glcd.h>"
echo "#include <rc_adc.h>"
echo "#include <rc_control.h>"
echo ""
echo "#ifdef SUPPORT_MENU"
echo ""
echo "extern uint8_t load_name_mmc (char *name_str, uint8_t model_id);"
echo "extern uint8_t load_setup_mmc (uint16_t model_id);"
echo "extern uint8_t save_setup_mmc (uint16_t model_id);"
echo "char *int2str (char *str, int value, char mode);"
echo "char *int2str_new (char *str, int16_t value, uint8_t mode, uint8_t digit, uint8_t close_str);"
echo ""
echo "enum {"
echo "	CMD_NONE,"
echo "	CMD_UP,"
echo "	CMD_ENTER,"
echo "	CMD_DOWN,"
echo "};"
echo ""
echo "enum {"
echo "	TYPE_NONE,"
echo "	TYPE_SINGLE,"
echo "	TYPE_MULTI,"
echo "	TYPE_CONTROL,"
echo "	TYPE_CHANNEL_IN,"
echo "	TYPE_CHANNEL_OUT,"
echo "	TYPE_CHANNEL,"
echo "	TYPE_POINT_X,"
echo "	TYPE_POINT_Y,"
echo "	TYPE_POINT_INVERT,"
echo "	TYPE_POINT_LINEAR,"
echo "	TYPE_POINT_HALF,"
echo "	TYPE_MAX"
echo "};"
echo ""
echo "enum {"
echo "	MENU_MAIN,"
echo "	MENU_VOLTAGE_TEMP,"
echo "#ifdef SUPPORT_MMC"
echo "	MENU_NEW,"
echo "	MENU_LOAD,"
echo "	MENU_SAVE,"
echo "	MENU_NAME,"
echo "	MENU_CALIBRATE,"
echo "#endif"
echo "	MENU_MONITOR_CONTROL,"
echo "	MENU_MONITOR_OSC,"
echo "	MENU_MONITOR_INOUT,"
for ENTRY in `cat /tmp/menu.txt`
do
	echo "	MENU_$ENTRY,"
done
echo "	MENU_MAX,"
echo "};"
echo ""
for ENTRY in `cat /tmp/menu.txt`
do
	echo "enum {"
	echo "	MENU_${ENTRY}_BACK,"
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
	do
		TYPE="`echo "$LINE" | awk '{print $1}'`"
		NAME="`echo "$LINE" | awk '{print $2}'`"
		SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
		LEN="`echo "$LINE" | awk '{print $3}'`"
		LEN2="`echo "$LINE" | sed "s|//.*||g" | awk '{print $4}'`"

		if test "$LEN2" != ""
		then
			if test "${SUB_NAME}" = "point"
			then
				for NUM in 0 1 2 3 4 5 6
				do
					echo "	MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x,"
					echo "	MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y,"
				done
				echo "	MENU_${ENTRY}_MODE_${SUB_NAME}_invert,"
				echo "	MENU_${ENTRY}_MODE_${SUB_NAME}_linear,"
				echo "	MENU_${ENTRY}_MODE_${SUB_NAME}_half,"
			else
				echo "	MENU_${ENTRY}_MODE_${SUB_NAME},"
			fi
		else
			echo "	MENU_${ENTRY}_MODE_${SUB_NAME},"
		fi
	done
	echo "	MENU_${ENTRY}_MAX,"
	echo "};"
	echo ""
done
echo ""
echo ""
N="0"
rm -rf /tmp/rcos-names.tmp
for ENTRY in `cat /tmp/menu.txt`
do
	SEARCH="`cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | head -n1`"
	rm -rf /tmp/flag_single.tmp
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | while read LINE
	do
		if test "$SEARCH" != "$LINE"
		then
			echo > /tmp/flag_single.tmp
		fi
	done
	if ! echo "$SEARCH" | grep -s -q -i "[a-z]"
	then
		SEARCH=1;
	fi
	if ! test -e /tmp/flag_single.tmp
	then
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			LEN="`echo "$LINE" | awk '{print $3}'`"
			LEN2="`echo "$LINE" | sed "s|//.*||g" | awk '{print $4}'`"
			if test "$LEN2" != ""
			then
				if test "${SUB_NAME}" = "point"
				then
					for NUM in 0 1 2 3 4 5 6
					do
						echo "${SUB_NAME}${NUM}_x" >> /tmp/rcos-names.tmp
						echo "static const char *text_${SUB_NAME}${NUM} = \"$SUB_TITLE `expr ${NUM} + 1`\";"
						N="`expr $N + 2`"
					done

					echo "${SUB_NAME}_invert" >> /tmp/rcos-names.tmp
					echo "static const char *text_${SUB_NAME}_invert = \"Invert\";"
					echo "${SUB_NAME}_linear" >> /tmp/rcos-names.tmp
					echo "static const char *text_${SUB_NAME}_linear = \"Linear\";"
					echo "${SUB_NAME}_half" >> /tmp/rcos-names.tmp
					echo "static const char *text_${SUB_NAME}_half = \"Half\";"

				else
					if grep -s -q "^$SUB_NAME$" /tmp/rcos-names.tmp
					then
						continue;
					fi
					echo "$SUB_NAME" >> /tmp/rcos-names.tmp
					echo "static const char *text_$SUB_NAME = \"$SUB_TITLE\";"
					N="`expr $N + 1`"
				fi
				continue;
			fi
			if grep -s -q "^$SUB_NAME$" /tmp/rcos-names.tmp
			then
				continue;
			fi
			echo "$SUB_NAME" >> /tmp/rcos-names.tmp
			echo "static const char *text_$SUB_NAME = \"$SUB_TITLE\";"
			N="`expr $N + 1`"
		done
	else
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			if grep -s -q "^$SUB_NAME$" /tmp/rcos-names.tmp
			then
				continue;
			fi
			echo "$SUB_NAME" >> /tmp/rcos-names.tmp
			echo "static const char *text_$SUB_NAME = \"$SUB_TITLE\";"
			N="`expr $N + 1`"
		done
	fi
done
echo ""
echo "char *text[MENU_MAX + 2][MENU_Mixer_MAX + 2];"
echo "uint8_t *value[MENU_MAX + 2][MENU_Mixer_MAX + 2];"
echo "uint8_t type[MENU_MAX + 2][MENU_Mixer_MAX + 2];"
echo "uint8_t extra[MENU_MAX + 2][MENU_Mixer_MAX + 2];"
echo "uint8_t len[MENU_MAX + 2];"
echo "uint8_t max[MENU_MAX + 2];"
echo ""
echo "uint8_t MainEntry = 0;"
echo "uint8_t SubEntry = 1;"
echo "uint8_t Select = 0;"
echo "uint8_t ModeEntry = 0;"
echo "uint8_t cmd = 0;"
echo ""
echo "char input_name[16][16];"
echo "char output_name[16][16];"
echo "static const char *name_aileron = \"Querruder\";"
echo "static const char *name_aileron1 = \"Querruder R\";"
echo "static const char *name_aileron2 = \"Querruder L\";"
echo "static const char *name_elevator = \"Hohenruder\";"
echo "static const char *name_elevator1 = \"Hohenruder R\";"
echo "static const char *name_elevator2 = \"Hohenruder L\";"
echo "static const char *name_rudder = \"Seitenruder\";"
echo "static const char *name_throttle = \"Drossel\";"
echo "static const char *name_flaps = \"Landeklappen\";"
echo "static const char *name_nick = \"Nick\";"
echo "static const char *name_revo = \"Revo\";"
echo "static const char *name_pitch = \"Pitch\";"
echo "static const char *name_roll = \"Roll\";"
echo "static const char *name_roll1 = \"Roll-Rechts\";"
echo "static const char *name_roll2 = \"Roll-Links\";"
echo ""
echo "void print_mixer (uint8_t offset_x, uint8_t offset_y, uint8_t width, uint8_t height, uint8_t id, uint8_t point, uint8_t xy) {"
echo "	uint8_t n;"
echo "	uint8_t x;"
echo "	uint8_t y;"
echo "	uint8_t last_x = 0;"
echo "	uint8_t last_y = 0;"
echo "	for (n = offset_x; n < offset_x + width; n++) {"
echo "		LCD_Pixel(n, offset_y, 1);"
echo "		LCD_Pixel(n, offset_y + height - 1, 1);"
echo "	}"
echo "	for (n = offset_y; n < offset_y + height; n++) {"
echo "		LCD_Pixel(offset_x, n, 1);"
echo "		LCD_Pixel(offset_x + width - 1, n, 1);"
echo "	}"
echo "	x = Rc_Mixer_point[id][0][0] * (width - 2) / 100 + 1;"
echo "	y = (Rc_Mixer_point[id][0][1] * (height - 2) / 100 + 1);"
echo "	last_x = x;"
echo "	last_y = y;"
echo "	for (n = 0; n < MIXER_POINTS_MAX; n++) {"
echo "		x = Rc_Mixer_point[id][n][0] * (width - 2) / 100 + 1;"
echo "		y = (Rc_Mixer_point[id][n][1] * (height - 2) / 100 + 1);"
echo "		y = (y - (height / 2)) * ControlSet(Rc_Mixer_percent_control[id], Rc_Mixer_percent_value[id]) / 100 + (height / 2);"
echo "		if (n == point) {"
echo "			if (xy == 1) {"
echo "				LCD_Pixel(offset_x + x + 6, offset_y + y, 1);"
echo "				LCD_Pixel(offset_x + x - 6, offset_y + y, 1);"
echo "			} else {"
echo "				LCD_Pixel(offset_x + x, offset_y + y + 6, 1);"
echo "				LCD_Pixel(offset_x + x, offset_y + y - 6, 1);"
echo "			}"
echo "			LCD_Pixel(offset_x + x + 4, offset_y + y, 1);"
echo "			LCD_Pixel(offset_x + x + 3, offset_y + y, 1);"
echo "			LCD_Pixel(offset_x + x + 2, offset_y + y, 1);"
echo "			LCD_Pixel(offset_x + x + 1, offset_y + y, 1);"
echo "			LCD_Pixel(offset_x + x - 1, offset_y + y, 1);"
echo "			LCD_Pixel(offset_x + x - 2, offset_y + y, 1);"
echo "			LCD_Pixel(offset_x + x - 3, offset_y + y, 1);"
echo "			LCD_Pixel(offset_x + x - 4, offset_y + y, 1);"
echo "			LCD_Pixel(offset_x + x, offset_y + y + 4, 1);"
echo "			LCD_Pixel(offset_x + x, offset_y + y + 3, 1);"
echo "			LCD_Pixel(offset_x + x, offset_y + y + 2, 1);"
echo "			LCD_Pixel(offset_x + x, offset_y + y + 1, 1);"
echo "			LCD_Pixel(offset_x + x, offset_y + y - 1, 1);"
echo "			LCD_Pixel(offset_x + x, offset_y + y - 2, 1);"
echo "			LCD_Pixel(offset_x + x, offset_y + y - 3, 1);"
echo "			LCD_Pixel(offset_x + x, offset_y + y - 4, 1);"
echo "		}"
echo "		LCD_Draw_Line(offset_x + last_x, offset_y + last_y, offset_x + x, offset_y + y);"
echo "		last_x = x;"
echo "		last_y = y;"
echo "	}"
echo "	x = (Rc_Input_value[Rc_Mixer_channel_in[id]] / 8 + 127) * (width - 2) / 255 + 1;"
echo "	y = (Rc_Output_value[Rc_Mixer_channel_out[id]] / 8 + 127) * (height - 2) / 255 + 1;"
echo "	LCD_Draw_Line(offset_x + x, offset_y, offset_x + x, offset_y + height);"
echo "	LCD_Draw_Line(offset_x, offset_y + y, offset_x + width, offset_y + y);"
echo "	y = ControlSet(Rc_Mixer_percent_control[id], Rc_Mixer_percent_value[id]) * (height - 2) / 200;"
echo "	for (n = offset_x; n < offset_x + width; n += 2) {"
echo "		LCD_Pixel(n, offset_y + (height / 2) + y - 1, 1);"
echo "		LCD_Pixel(n, offset_y + (height / 2) - y - 1, 1);"
echo "	}"
echo "}"
echo ""
echo "void print_bar (uint8_t offset_x, uint8_t offset_y, uint8_t width, uint8_t height, uint8_t value) {"
echo "	uint8_t n;"
echo "	LCD_Draw_Line(offset_x, offset_y, offset_x + width, offset_y);"
echo "	LCD_Draw_Line(offset_x, offset_y + height, offset_x + width, offset_y + height);"
echo "	LCD_Draw_Line(offset_x, offset_y, offset_x, offset_y + height);"
echo "	LCD_Draw_Line(offset_x + width, offset_y, offset_x + width, offset_y + height);"
echo "	LCD_Draw_Line(offset_x + (value * width / 255), offset_y, offset_x + (value * width / 255), offset_y + height);"
echo "	for (n = offset_y; n < offset_y + height; n += 2) {"
echo "		LCD_Pixel(offset_x + (width / 2), n, 1);"
echo "	}"
echo "}"
echo ""
echo "void print_control (uint8_t y, uint8_t x, uint8_t control_id) {"
echo "	uint8_t tmp_str[40];"
echo "	if (control_id == 0) {"
echo "		LCD_Print(y, x, \"Off\");"
echo "	} else if (control_id < 16 && input_name[control_id][0] != 0) {"
echo "		LCD_Print(y, x, (char *)input_name[control_id - 1]);"
echo "	} else if (control_id == 0) {"
echo "		LCD_Print(y, x, \"Off\");"
echo "	} else if (control_id == 255) {"
echo "		LCD_Print(y, x, \"On\");"
echo "	} else if (control_id < 20) {"
echo "		char tmp_str[] = \"Geber- \";"
echo "		tmp_str[6] = 'A' + control_id - 1;"
echo "		LCD_Print(y, x, (char *)tmp_str);"
echo "	} else if (control_id >= 20 && control_id < 50) {"
echo "		char tmp_str[] = \"Geber  \";"
echo "		int2str((char *)tmp_str + 5, control_id - 19, 0);"
echo "		LCD_Print(y, x, (char *)tmp_str);"
echo "	} else {"
echo "		LCD_Print(y, x, (char *)int2str((char *)tmp_str, control_id, 0));"
echo "	}"
echo "}"
echo ""
echo "void print_control_value (uint8_t control_id) {"
echo "	uint8_t tmp_str[40];"
echo "	uint8_t n;"
echo "	int16_t new_value = ControlRead(control_id);"
echo "	print_control(1, 255, control_id);"
echo "	int2str_new((char *)tmp_str, (int16_t)new_value, 0, 0, 1);"
echo "	LCD_Print(LCD_LINE_2, 255, (char *)tmp_str);"
echo "	for (n = 10; n < LCD_W - 10; n++) {"
echo "		LCD_Pixel(n, LCD_H - 12, 1);"
echo "		LCD_Pixel(n, LCD_H - 2, 1);"
echo "	}"
echo "	for (n = LCD_H - 12; n < LCD_H - 2; n++) {"
echo "		LCD_Pixel(10, n, 1);"
echo "		LCD_Pixel(LCD_W - 10, n, 1);"
echo "	}"
echo "	for (n = LCD_H - 10; n < LCD_H - 3; n += 2) {"
echo "		LCD_Pixel((LCD_W / 2), n, 1);"
echo "	}"
echo "	for (n = LCD_H - 12; n < LCD_H - 2; n++) {"
echo "		LCD_Pixel((LCD_W / 2) + (new_value) * (LCD_W - 20) / 255, n, 1);"
echo "	}"
echo "}"
echo ""
echo "void print_output (uint8_t y, uint8_t x, uint8_t output_id) {"
echo "	uint8_t tmp_str[40];"
echo "	if (output_id < 16 && output_name[output_id][0] != 0) {"
echo "		LCD_Print(y, x, (char *)output_name[output_id]);"
echo "	} else if (output_id == 255) {"
echo "		LCD_Print(y, x, \"None\");"
echo "	} else if (output_id < 20) {"
echo "		char tmp_str[] = \"PPM1-\";"
echo "		int2str((char *)tmp_str + 5, output_id + 1, 0);"
echo "		LCD_Print(y, x, (char *)tmp_str);"
echo "	} else {"
echo "		LCD_Print(y, x, (char *)int2str((char *)tmp_str, output_id, 0));"
echo "	}"
echo "}"
echo ""
echo ""
echo "void setup_default (void) {"
echo "	int8_t num = 0;"
echo "	for (num = 0; num < 16; num++) {"
echo "		input_name[num][0] = 0;"
echo "		output_name[num][0] = 0;"
echo "	}"
echo "	for (num = 0; num < CONTROL_MAX && num < MIXER_MAX && num < OUTPUT_MAX; num++) {"
echo "		Rc_Input_control[num] = num + 1;"
echo "		Rc_Mixer_channel_in[num] = num;"
echo "		Rc_Mixer_channel_out[num] = num;"
echo "		Rc_Mixer_percent_value[num] = 100;"
echo "		Rc_Mixer_percent_control[num] = CONTROL_ON;"
echo "	}"
echo "	for (num = 0; num < ATV_MAX; num++) {"
echo "		Rc_Atv_channel[num] = num;"
echo "		Rc_Atv_switch[num] = CONTROL_OFF;"
echo "		Rc_Atv_up_value[num] = 100;"
echo "		Rc_Atv_up_control[num] = CONTROL_ON;"
echo "		Rc_Atv_down_value[num] = 100;"
echo "		Rc_Atv_down_control[num] = CONTROL_ON;"
echo "	}"
echo "	for (num = 0; num < EXPO_MAX; num++) {"
echo "		Rc_Expo_type[num] = 0;"
echo "		Rc_Expo_channel[num] = num;"
echo "		Rc_Expo_switch[num] = CONTROL_OFF;"
echo "		Rc_Expo_gradient_value[num] = 50;"
echo "		Rc_Expo_gradient_control[num] = CONTROL_ON;"
echo "	}"
echo "	for (num = 0; num < DUALRATE_MAX; num++) {"
echo "		Rc_Dualrate_channel[num] = num;"
echo "		Rc_Dualrate_switch[num] = CONTROL_OFF;"
echo "		Rc_Dualrate_limit_value[num] = 80;"
echo "		Rc_Dualrate_limit_control[num] = CONTROL_ON;"
echo "	}"
echo "}"
echo ""
echo "void setup_plane1 (void) {"
echo "	setup_default();"
echo "	strcpy((char *)Rc_Model_name, \"Plane-1\");"
echo "	strcpy(input_name[0], name_aileron);"
echo "	strcpy(input_name[1], name_elevator);"
echo "	strcpy(input_name[2], name_throttle);"
echo "	strcpy(input_name[3], name_rudder);"
echo "	strcpy(input_name[4], name_flaps);"
echo "	strcpy(output_name[0], name_aileron);"
echo "	strcpy(output_name[1], name_elevator);"
echo "	strcpy(output_name[2], name_throttle);"
echo "	strcpy(output_name[3], name_rudder);"
echo "	strcpy(output_name[4], name_flaps);"
echo "}"
echo ""
echo "void setup_plane2 (void) {"
echo "	setup_default();"
echo "	strcpy((char *)Rc_Model_name, \"Plane-2\");"
echo "	strcpy(input_name[0], name_aileron);"
echo "	strcpy(input_name[1], name_elevator);"
echo "	strcpy(input_name[2], name_throttle);"
echo "	strcpy(input_name[3], name_rudder);"
echo "	strcpy(input_name[4], name_flaps);"
echo "	strcpy(output_name[0], name_aileron1);"
echo "	strcpy(output_name[1], name_aileron2);"
echo "	strcpy(output_name[2], name_elevator1);"
echo "	strcpy(output_name[3], name_elevator2);"
echo "	strcpy(output_name[4], name_rudder);"
echo "	strcpy(output_name[5], name_throttle);"
echo "	Rc_Mixer_channel_in[0] = 0;"
echo "	Rc_Mixer_channel_out[0] = 0;"
echo "	Rc_Mixer_channel_in[1] = 0;"
echo "	Rc_Mixer_channel_out[1] = 1;"
echo "	Rc_Mixer_percent_value[1] -= 100;"
echo "	Rc_Mixer_channel_in[2] = 1;"
echo "	Rc_Mixer_channel_out[2] = 2;"
echo "	Rc_Mixer_channel_in[3] = 1;"
echo "	Rc_Mixer_channel_out[3] = 3;"
echo "	Rc_Mixer_channel_in[4] = 2;"
echo "	Rc_Mixer_channel_out[4] = 5;"
echo "	Rc_Mixer_channel_in[5] = 3;"
echo "	Rc_Mixer_channel_out[5] = 4;"
echo "	Rc_Mixer_channel_in[6] = 4;"
echo "	Rc_Mixer_channel_out[6] = 0;"
echo "	Rc_Mixer_channel_in[7] = 4;"
echo "	Rc_Mixer_channel_out[7] = 1;"
echo "}"
echo ""
echo "void setup_heli1 (void) {"
echo "	setup_default();"
echo "	strcpy((char *)Rc_Model_name, \"Heli-1\");"
echo "	strcpy(input_name[0], name_roll);"
echo "	strcpy(input_name[1], name_nick);"
echo "	strcpy(input_name[2], name_pitch);"
echo "	strcpy(input_name[3], name_revo);"
echo "	strcpy(input_name[4], name_throttle);"
echo "	strcpy(output_name[0], name_roll1);"
echo "	strcpy(output_name[1], name_roll2);"
echo "	strcpy(output_name[2], name_nick);"
echo "	strcpy(output_name[3], name_revo);"
echo "	strcpy(output_name[4], name_throttle);"
echo "	// Roll"
echo "	Rc_Mixer_channel_in[0] = 0;"
echo "	Rc_Mixer_channel_out[0] = 0;"
echo "	Rc_Mixer_channel_in[1] = 0;"
echo "	Rc_Mixer_channel_out[1] = 1;"
echo "	// Nick"
echo "	Rc_Mixer_channel_in[2] = 1;"
echo "	Rc_Mixer_channel_out[2] = 0;"
echo "	Rc_Mixer_percent_value[2] = -75;"
echo "	Rc_Mixer_channel_in[3] = 1;"
echo "	Rc_Mixer_channel_out[3] = 1;"
echo "	Rc_Mixer_percent_value[3] = -75;"
echo "	Rc_Mixer_channel_in[4] = 1;"
echo "	Rc_Mixer_channel_out[4] = 2;"
echo "	// Pitch"
echo "	Rc_Mixer_channel_in[5] = 1;"
echo "	Rc_Mixer_channel_out[5] = 0;"
echo "	Rc_Mixer_channel_in[6] = 1;"
echo "	Rc_Mixer_channel_out[6] = 1;"
echo "	Rc_Mixer_channel_in[7] = 1;"
echo "	Rc_Mixer_channel_out[7] = 2;"
echo "}"
echo ""
echo "#ifdef RCOS_MAINBOARD_V1_0"
echo "#define RC_CONTROL_SW0_A_PORT	GPIOE"
echo "#define RC_CONTROL_SW0_A_PIN 	GPIO_Pin_0"
echo "#define RC_CONTROL_SW0_B_PORT	GPIOE"
echo "#define RC_CONTROL_SW0_B_PIN 	GPIO_Pin_1"
echo "#define RC_CONTROL_SW0_C_PORT	GPIOD"
echo "#define RC_CONTROL_SW0_C_PIN 	GPIO_Pin_7"
echo "#endif"
echo ""
echo "#ifdef RCOS_MAINBOARD_FC16"
echo "#define RC_CONTROL_SW0_A_PORT	GPIOC"
echo "#define RC_CONTROL_SW0_A_PIN 	GPIO_Pin_10"
echo "#define RC_CONTROL_SW0_B_PORT	GPIOB"
echo "#define RC_CONTROL_SW0_B_PIN 	GPIO_Pin_5"
echo "#define RC_CONTROL_SW0_C_PORT	GPIOA"
echo "#define RC_CONTROL_SW0_C_PIN 	GPIO_Pin_6"
echo "#endif"
echo ""
echo "void menu_init (void) {"
echo "	GPIO_InitTypeDef GPIO_InitStructure;"
echo "	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW0_A_PIN;"
echo "	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;"
echo "	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;"
echo "	GPIO_Init(RC_CONTROL_SW0_A_PORT, &GPIO_InitStructure);"
echo ""
echo "	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW0_B_PIN;"
echo "	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;"
echo "	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;"
echo "	GPIO_Init(RC_CONTROL_SW0_B_PORT, &GPIO_InitStructure);"
echo ""
echo "	GPIO_InitStructure.GPIO_Pin = 0 | RC_CONTROL_SW0_C_PIN;"
echo "	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;"
echo "	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;"
echo "	GPIO_Init(RC_CONTROL_SW0_C_PORT, &GPIO_InitStructure);"
echo ""
echo "	int8_t num = 0;"
echo "	for (num = 0; num < 16; num++) {"
echo "		input_name[num][0] = 0;"
echo "		output_name[num][0] = 0;"
echo "	}"
echo "	setup_plane1();"
echo ""
echo "	text[MENU_MAIN][0] = \"Main\";"
echo "	text[MENU_VOLTAGE_TEMP][0] = \"Volt/Temp.\";"
echo "#ifdef SUPPORT_MMC"
echo "	text[MENU_NEW][0] = \"New Model\";"
echo "	text[MENU_LOAD][0] = \"Load Model\";"
echo "	text[MENU_SAVE][0] = \"Save Model\";"
echo "	text[MENU_NAME][0] = \"Model-Name\";"
echo "	text[MENU_CALIBRATE][0] = \"Calibrate\";"
echo "#endif"
echo "	text[MENU_MONITOR_CONTROL][0] = \"Ctrl-Monitor\";"
echo "	text[MENU_MONITOR_OSC][0] = \"ADC-Monitor\";"
echo "	text[MENU_MONITOR_INOUT][0] = \"IN/Out-Monitor\";"
for ENTRY in `cat /tmp/menu.txt`
do
	SEARCH="`cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | head -n1`"
	rm -rf /tmp/flag_single.tmp
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | while read LINE
	do
		if test "$SEARCH" != "$LINE"
		then
			echo > /tmp/flag_single.tmp
		fi
	done
	if ! echo "$SEARCH" | grep -s -q -i "[a-z]"
	then
		SEARCH=1;
	fi
	echo "	text[MENU_${ENTRY}][0] = \"$ENTRY\";"
	echo "	value[MENU_${ENTRY}][0] = 0;"
	if ! test -e /tmp/flag_single.tmp
	then
		echo "	len[MENU_${ENTRY}] = MENU_${ENTRY}_MAX - 1;"
		echo "	max[MENU_${ENTRY}] = $SEARCH;"
		echo "	type[MENU_${ENTRY}][0] = TYPE_MULTI;"
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			LEN="`echo "$LINE" | awk '{print $3}'`"
			LEN2="`echo "$LINE" | sed "s|//.*||g" | awk '{print $4}'`"
			if test "$LEN2" != ""
			then
				if test "${SUB_NAME}" = "point"
				then
					for NUM in 0 1 2 3 4 5 6
					do
						echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x] = (char *)text_${SUB_NAME}${NUM};"
						echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y] = (char *)text_${SUB_NAME}${NUM};"
						echo "	value[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x] = (uint8_t *)Rc_${ENTRY}_${SUB_NAME};"
						echo "	value[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y] = (uint8_t *)Rc_${ENTRY}_${SUB_NAME};"
						echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x] = TYPE_POINT_X;"
						echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y] = TYPE_POINT_Y;"
						echo "	extra[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_x] = $NUM;"
						echo "	extra[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}${NUM}_y] = $NUM;"
					done
					echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}_invert] = (char *)text_${SUB_NAME}_invert;"
					echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}_invert] = TYPE_POINT_INVERT;"
					echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}_linear] = (char *)text_${SUB_NAME}_linear;"
					echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}_linear] = TYPE_POINT_LINEAR;"
					echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}_half] = (char *)text_${SUB_NAME}_half;"
					echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}_half] = TYPE_POINT_HALF;"
				else
					echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = (char *)text_$SUB_NAME;"
				fi
				continue;
			fi
			echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = (char *)text_$SUB_NAME;"
			echo "	value[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = (uint8_t *)Rc_${ENTRY}_${SUB_NAME};"

			if echo "$SUB_NAME" | grep -s -q "control\|switch"
			then
				echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CONTROL;"
			elif echo "$SUB_NAME" | grep -s -q "channel_in"
			then
				echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL_IN;"
			elif echo "$SUB_NAME" | grep -s -q "channel_out"
			then
				echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL_OUT;"
			elif echo "$SUB_NAME" | grep -s -q "channel"
			then
				if test "${ENTRY}" = "Expo" || test "${ENTRY}" = "Dualrate"
				then
					echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL_IN;"
				elif test "${ENTRY}" = "Limiter" || test "${ENTRY}" = "Atv"
				then
					echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL_OUT;"
				else
					echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_CHANNEL;"
				fi
			else
				echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_NONE;"
			fi
		done
	else
		echo "	len[MENU_${ENTRY}] = MENU_${ENTRY}_MAX - 1;"
		echo "	max[MENU_${ENTRY}] = 1;"
		echo "	type[MENU_${ENTRY}][0] = TYPE_SINGLE;"
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"

			echo "	text[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = (char *)text_$SUB_NAME;"
			echo "	value[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = &Rc_${ENTRY}_${SUB_NAME};"
			echo "	type[MENU_${ENTRY}][MENU_${ENTRY}_MODE_${SUB_NAME}] = TYPE_NONE;"
		done
	fi
done
echo "}"
echo ""
echo "extern uint16_t ADC_RegularConvertedValueTab[ADC_CHANNELS_MAX * 4];"
echo ""
echo "uint8_t redraw = 10;"
echo ""
echo "#define BATT_X 60"
echo "#define BATT_W 20"
echo ""
echo "void head (char *text) {"
echo "	int8_t num = 0;"
echo "	LCD_Print_Inverted(0, 1, (char *)text);"
echo "	LCD_Draw_Line(BATT_X, 0, BATT_X + BATT_W - 1, 0);"
echo "	LCD_Draw_Line(BATT_X, 7, BATT_X + BATT_W - 1, 7);"
echo "	LCD_Draw_Line(BATT_X, 0, BATT_X, 7);"
echo "	LCD_Draw_Line(BATT_X + BATT_W - 1, 0, BATT_X + BATT_W - 1, 7);"
echo "	LCD_Draw_Line(BATT_X + BATT_W, 2, BATT_X + BATT_W, 5);"
echo ""
echo "	uint16_t volt = GetADCChanel(ADC_CHANNELS_MAX - 2);"
echo "	for (num = 0; num < (volt * (BATT_W - 5) / 4096); num++) {"
echo "		LCD_Draw_Line(BATT_X + num + 2, 2, BATT_X + num + 2, 5);"
echo "	}"
echo "	if (redraw < 1) {"
echo "		redraw = 255;"
echo "	}"
echo "}"
echo ""
echo ""
echo "void menu (void) {"
echo "	static int8_t encoder = 0;"
echo "	int8_t num = 0;"
echo "	uint8_t tmp_str[40];"
echo "	uint8_t enc_data = 0;"
echo "	if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_A_PORT, RC_CONTROL_SW0_A_PIN) != 0) {"
echo "		enc_data |= 1;"
echo "	}"
echo "	if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_B_PORT, RC_CONTROL_SW0_B_PIN) != 0) {"
echo "		enc_data |= 2;"
echo "	}"
echo "	if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_C_PORT, RC_CONTROL_SW0_C_PIN) != 0) {"
echo "		enc_data |= 4;"
echo "	}"
echo "	cmd = Rc_REncoderDecode_menu_byte(enc_data, 0, 1, 2);"
echo ""
echo "	if (cmd == CMD_UP) {"
echo "		encoder++;"
echo "		if (encoder >= 4) {"
echo "			encoder = 0;"
echo "			sound(1000, 10);"
echo "		} else {"
echo "			return;"
echo "		}"
echo "	} else if (cmd == CMD_DOWN) {"
echo "		encoder--;"
echo "		if (encoder <= -5) {"
echo "			encoder = 0;"
echo "			sound(1200, 10);"
echo "		} else {"
echo "			return;"
echo "		}"
echo "	}"
echo ""
echo "	if (cmd != 0) {"
echo "		redraw = 10;"
echo "		if (cmd == CMD_ENTER) {"
echo "			sound(1300, 10);"
echo "			while (cmd == CMD_ENTER) {"
echo "				if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_A_PORT, RC_CONTROL_SW0_A_PIN) != 0) {"
echo "					enc_data |= 1;"
echo "				}"
echo "				if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_B_PORT, RC_CONTROL_SW0_B_PIN) != 0) {"
echo "					enc_data |= 2;"
echo "				}"
echo "				if (GPIO_ReadInputDataBit(RC_CONTROL_SW0_C_PORT, RC_CONTROL_SW0_C_PIN) != 0) {"
echo "					enc_data |= 4;"
echo "				}"
echo "				cmd = Rc_REncoderDecode_menu_byte(enc_data, 0, 1, 2);"
echo "			}"
echo "			sound(1400, 10);"
echo "			cmd = CMD_ENTER;"
echo "		}"
echo ""
echo "		uint8_t *tmp = 0;"
echo "		switch (MainEntry) {"
echo "			case MENU_MAIN:"
echo "				if (cmd == CMD_ENTER) {"
echo "					Select = 0;"
echo "					MainEntry = SubEntry;"
echo "					if (type[MainEntry][0] == TYPE_SINGLE) {"
echo "						SubEntry = 1;"
echo "					} else {"
echo "						SubEntry = 0;"
echo "					}"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (SubEntry < MENU_MAX - 1) {"
echo "						SubEntry++;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (SubEntry > 1) {"
echo "						SubEntry--;"
echo "					}"
echo "				}"
echo "			break;"
echo "#ifdef SUPPORT_MMC"
echo "			case MENU_NEW:"
echo "				if (cmd == CMD_ENTER) {"
echo "					if (SubEntry == 1) {"
echo "						setup_plane1();"
echo "					} else if (SubEntry == 2) {"
echo "						setup_plane2();"
echo "					} else if (SubEntry == 3) {"
echo "						setup_heli1();"
echo "					}"
echo "					SubEntry = MainEntry;"
echo "					MainEntry = 0;"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (SubEntry < 4) {"
echo "						SubEntry++;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (SubEntry > 0) {"
echo "						SubEntry--;"
echo "					}"
echo "				}"
echo "			break;"
echo "			case MENU_LOAD:"
echo "				if (cmd == CMD_ENTER) {"
echo "					if (SubEntry > 0) {"
echo "						load_setup_mmc(SubEntry - 1);"
echo "					}"
echo "					SubEntry = MainEntry;"
echo "					MainEntry = 0;"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (SubEntry < 10) {"
echo "						SubEntry++;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (SubEntry > 0) {"
echo "						SubEntry--;"
echo "					}"
echo "				}"
echo "			break;"
echo "			case MENU_SAVE:"
echo "				if (cmd == CMD_ENTER) {"
echo "					if (SubEntry > 0) {"
echo "						save_setup_mmc(SubEntry - 1);"
echo "					}"
echo "					SubEntry = MainEntry;"
echo "					MainEntry = 0;"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (SubEntry < 10) {"
echo "						SubEntry++;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (SubEntry > 0) {"
echo "						SubEntry--;"
echo "					}"
echo "				}"
echo "			break;"
echo "			case MENU_NAME:"
echo "				if (cmd == CMD_ENTER) {"
echo "					if (Rc_Model_name[Select] == 31) {"
echo "						Select = 0;"
echo "					} else if (Rc_Model_name[Select] == 30) {"
echo "						Rc_Model_name[Select] = 0;"
echo "						SubEntry = MainEntry;"
echo "						MainEntry = 0;"
echo "					} else if (Select < MODEL_NAME_MAX - 2) {"
echo "						Select++;"
echo "						if (Rc_Model_name[Select] == 0) {"
echo "							Rc_Model_name[Select + 1] = 0;"
echo "						}"
echo "					}"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (Rc_Model_name[Select] < 124) {"
echo "						Rc_Model_name[Select]++;"
echo "					} else {"
echo "						Rc_Model_name[Select] = 124;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (Rc_Model_name[Select] > 30) {"
echo "						Rc_Model_name[Select]--;"
echo "					} else {"
echo "						Rc_Model_name[Select] = 30;"
echo "					}"
echo "				}"
echo "			break;"
echo "			case MENU_CALIBRATE:"
echo "				if (cmd == CMD_ENTER) {"
echo "					if (SubEntry == 0) {"
echo "						SubEntry++;"
echo "						for (num = 0; num < 4; num++) {"
echo "							Rc_Calibrate_center[num] = 0;"
echo "							Rc_Calibrate_min[num] = -1024;"
echo "							Rc_Calibrate_max[num] = 1024;"
echo "						}"
echo "						MotionTimer = 0; while (MotionTimer < 250) {}"
echo "						MotionTimer = 0; while (MotionTimer < 250) {}"
echo "						for (num = 0; num < 4; num++) {"
echo "							Rc_Calibrate_center[num] = Rc_AdcRead(num) * -1;"
echo "							Rc_Calibrate_min[num] = 1024;"
echo "							Rc_Calibrate_max[num] = -1024;"
echo "						}"
echo "					} else if (SubEntry == 1) {"
echo "						SubEntry = 0;"
echo "						MainEntry = MENU_MONITOR_CONTROL;"
echo "					}"
echo "				}"
echo "			break;"
echo "#endif"
echo "			case MENU_VOLTAGE_TEMP:"
echo "			case MENU_MONITOR_CONTROL:"
echo "			case MENU_MONITOR_INOUT:"
echo "				if (cmd == CMD_ENTER) {"
echo "					SubEntry = MainEntry;"
echo "					MainEntry = 0;"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (SubEntry < 12) {"
echo "						SubEntry++;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (SubEntry > 0) {"
echo "						SubEntry--;"
echo "					}"
echo "				}"
echo "			break;"
echo "			case MENU_MONITOR_OSC:"
echo "				if (cmd == CMD_ENTER) {"
echo "					SubEntry = MainEntry;"
echo "					MainEntry = 0;"
echo "				} else if (cmd == CMD_UP) {"
echo "					if (SubEntry < 255) {"
echo "						SubEntry++;"
echo "					}"
echo "				} else if (cmd == CMD_DOWN) {"
echo "					if (SubEntry > 0) {"
echo "						SubEntry--;"
echo "					}"
echo "				}"
echo "			break;"
echo "			default:"
echo "				if (SubEntry == 0) {"
echo "					if (Select == 0) {"
echo "						if (cmd == CMD_ENTER) {"
echo "							SubEntry = MainEntry;"
echo "							MainEntry = 0;"
echo "						}"
echo "					} else {"
echo "						if (cmd == CMD_ENTER) {"
echo "							SubEntry = Select;"
echo "							Select = 0;"
echo "						}"
echo "					}"
echo "					if (cmd == CMD_UP) {"
echo "						if (Select < max[MainEntry]) {"
echo "							Select++;"
echo "						}"
echo "					} else if (cmd == CMD_DOWN) {"
echo "						if (Select > 0) {"
echo "							Select--;"
echo "						}"
echo "					}"
echo "				} else {"
echo "					if (ModeEntry == 0) {"
echo "						if (Select == 0) {"
echo "							if (cmd == CMD_ENTER) {"
echo "								if (type[MainEntry][0] == TYPE_SINGLE) {"
echo "									Select = 0;"
echo "									SubEntry = MainEntry;"
echo "									MainEntry = 0;"
echo "								} else {"
echo "									Select = SubEntry;"
echo "									SubEntry = 0;"
echo "								}"
echo "							}"
echo "						} else {"
echo "							if (cmd == CMD_ENTER) {"
echo "								if (type[MainEntry][Select] == TYPE_POINT_INVERT) {"
echo "									for (num = 0; num < MIXER_POINTS_MAX; num++) {"
echo "										Rc_Mixer_point[SubEntry - 1][num][1] = 100 - Rc_Mixer_point[SubEntry - 1][num][1];"
echo "									}"
echo "									ModeEntry = 0;"
echo "									Select -= 2;"
echo "								} else if (type[MainEntry][Select] == TYPE_POINT_LINEAR) {"
echo "									Rc_Mixer_point[SubEntry - 1][0][0] = 0;"
echo "									Rc_Mixer_point[SubEntry - 1][0][1] = 0;"
echo "									Rc_Mixer_point[SubEntry - 1][1][0] = 16;"
echo "									Rc_Mixer_point[SubEntry - 1][1][1] = 16;"
echo "									Rc_Mixer_point[SubEntry - 1][2][0] = 33;"
echo "									Rc_Mixer_point[SubEntry - 1][2][1] = 33;"
echo "									Rc_Mixer_point[SubEntry - 1][3][0] = 50;"
echo "									Rc_Mixer_point[SubEntry - 1][3][1] = 50;"
echo "									Rc_Mixer_point[SubEntry - 1][4][0] = 67;"
echo "									Rc_Mixer_point[SubEntry - 1][4][1] = 67;"
echo "									Rc_Mixer_point[SubEntry - 1][5][0] = 84;"
echo "									Rc_Mixer_point[SubEntry - 1][5][1] = 84;"
echo "									Rc_Mixer_point[SubEntry - 1][6][0] = 100;"
echo "									Rc_Mixer_point[SubEntry - 1][6][1] = 100;"
echo "									ModeEntry = 0;"
echo "									Select -= 3;"
echo "								} else if (type[MainEntry][Select] == TYPE_POINT_HALF) {"
echo "									for (num = 0; num < MIXER_POINTS_MAX; num++) {"
echo "										Rc_Mixer_point[SubEntry - 1][num][1] = (Rc_Mixer_point[SubEntry - 1][num][1] - 50) / 2 + 50;"
echo "									}"
echo "									ModeEntry = 0;"
echo "									Select -= 4;"
echo "								} else {"
echo "									ModeEntry = Select;"
echo "									Select = 0;"
echo "								}"
echo "							}"
echo "						}"
echo "						if (cmd == CMD_UP) {"
echo "							if (Select < len[MainEntry]) {"
echo "								Select++;"
echo "							}"
echo "						} else if (cmd == CMD_DOWN) {"
echo "							if (Select > 0) {"
echo "								Select--;"
echo "							}"
echo "						}"
echo "					} else {"
echo "						if (type[MainEntry][Select] == TYPE_POINT_X) {"
echo "							tmp = &Rc_Mixer_point[SubEntry - 1][extra[MainEntry][ModeEntry]][0];"
echo "						} else if (type[MainEntry][Select] == TYPE_POINT_Y) {"
echo "							tmp = &Rc_Mixer_point[SubEntry - 1][extra[MainEntry][ModeEntry]][1];"
echo "						} else {"
echo "							tmp = &value[MainEntry][ModeEntry][SubEntry - 1];"
echo "						}"
echo "						if (tmp != 0 && cmd == CMD_UP) {"
echo "							if (tmp[0] < 255) {"
echo "								tmp[0]++;"
echo "							} else {"
echo "								tmp[0] = 0;"
echo "							}"
echo "						} else if (tmp != 0 && cmd == CMD_DOWN) {"
echo "							if (tmp[0] > 0) {"
echo "								tmp[0]--;"
echo "							} else {"
echo "								tmp[0] = 255;"
echo "							}"
echo "						} else if (cmd == CMD_ENTER) {"
echo "							Select = ModeEntry;"
echo "							ModeEntry = 0;"
echo "						}"
echo "					}"
echo "				}"
echo "			break;"
echo "		}"
echo "	}"
echo ""
echo "	if (redraw > 1) {"
echo "		redraw--;"
echo "	} else if (redraw == 1) {"
echo "		uint16_t temperature;"
echo "		uint16_t voltage;"
echo "		static uint8_t pos;"
echo "		redraw = 0;"
echo "		if (MainEntry > MENU_MONITOR_INOUT && SubEntry == 0) {"
echo "			LCD_Clear();"
echo "			head((char *)Rc_Model_name);"
echo "			LCD_Print(LCD_LINE_1, 0, (char *)text[MainEntry][0]);"
echo "			if (Select == 0) {"
echo "				LCD_Print(LCD_LINE_3, 255, \"<-Back\");"
echo "			} else if (MainEntry == MENU_Mixer) {"
echo "				LCD_Print(LCD_LINE_1, 6, (char *)int2str((char *)tmp_str, Select, 0));"
echo "				print_control(LCD_LINE_2, 255, Rc_Input_control[Rc_Mixer_channel_in[Select - 1]]);"
echo "				print_mixer(21, (3 * 8) + 1, (6 * 6), (2 * 8) - 2, Select - 1, MIXER_POINTS_MAX, 0);"
echo "				print_output(LCD_LINE_5, 255, Rc_Mixer_channel_out[Select - 1]);"
echo "				if (Last_Control != 255) {"
echo "					for (num = 0; num < MIXER_MAX; num++) {"
echo "						if (Last_Control == Rc_Input_control[Rc_Mixer_channel_in[num]]) {"
echo "							if (Last_Control != 0) {"
echo "								Select = Last_Control;"
echo "								break;"
echo "							}"
echo "						}"
echo "					}"
echo "					Last_Control = 255;"
echo "				}"
echo "			} else if (MainEntry == MENU_Expo) {"
echo "				LCD_Print(LCD_LINE_1, 6, (char *)int2str((char *)tmp_str, Select, 0));"
echo "				print_control(LCD_LINE_3, 255, Rc_Input_control[Rc_Expo_channel[Select - 1]]);"
echo "				if (Last_Control != 255) {"
echo "					for (num = 0; num < EXPO_MAX; num++) {"
echo "						if (Last_Control == Rc_Input_control[Rc_Expo_channel[num]]) {"
echo "							if (Last_Control != 0) {"
echo "								Select = Last_Control;"
echo "								break;"
echo "							}"
echo "						}"
echo "					}"
echo "					Last_Control = 255;"
echo "				}"
echo "			} else if (MainEntry == MENU_Dualrate) {"
echo "				LCD_Print(LCD_LINE_1, 10, (char *)int2str((char *)tmp_str, Select, 0));"
echo "				print_control(LCD_LINE_3, 255, Rc_Input_control[Rc_Dualrate_channel[Select - 1]]);"
echo "				if (Last_Control != 255) {"
echo "					for (num = 0; num < DUALRATE_MAX; num++) {"
echo "						if (Last_Control == Rc_Input_control[Rc_Dualrate_channel[num]]) {"
echo "							if (Last_Control != 0) {"
echo "								Select = Last_Control;"
echo "								break;"
echo "							}"
echo "						}"
echo "					}"
echo "					Last_Control = 255;"
echo "				}"
echo "			} else if (MainEntry == MENU_Limiter) {"
echo "				LCD_Print(LCD_LINE_1, 7, (char *)int2str((char *)tmp_str, Select, 0));"
echo "				print_output(LCD_LINE_3, 255, Rc_Limiter_channel[Select - 1]);"
echo "			} else if (MainEntry == MENU_Atv) {"
echo "				LCD_Print(LCD_LINE_1, 6, (char *)int2str((char *)tmp_str, Select, 0));"
echo "				print_output(LCD_LINE_3, 255, Rc_Atv_channel[Select - 1]);"
echo "				if (Last_Control != 255) {"
echo "					for (num = 0; num < ATV_MAX; num++) {"
echo "						if (Last_Control == Rc_Input_control[Rc_Atv_channel[num]]) {"
echo "							if (Last_Control != 0) {"
echo "								Select = Last_Control;"
echo "								break;"
echo "							}"
echo "						}"
echo "					}"
echo "					Last_Control = 255;"
echo "				}"
echo "			} else if (MainEntry == MENU_Input) {"
echo "				LCD_Print(LCD_LINE_1, 6, (char *)int2str((char *)tmp_str, Select, 0));"
echo "				print_control(LCD_LINE_3, 255, Rc_Input_control[Select - 1]);"
echo "				if (Last_Control != 255) {"
echo "					for (num = 0; num < CONTROL_MAX; num++) {"
echo "						if (Last_Control == Rc_Input_control[num]) {"
echo "							if (Last_Control != 0) {"
echo "								Select = Last_Control;"
echo "								break;"
echo "							}"
echo "						}"
echo "					}"
echo "					Last_Control = 255;"
echo "				}"
echo "			} else if (MainEntry == MENU_Output) {"
echo "				LCD_Print(LCD_LINE_1, 7, (char *)int2str((char *)tmp_str, Select, 0));"
echo "				print_output(LCD_LINE_3, 255, Select - 1);"
echo "			} else {"
echo "				LCD_Print(LCD_LINE_3, 3, \"Num:\");"
echo "				LCD_Print(LCD_LINE_3, 8, (char *)int2str((char *)tmp_str, Select, 0));"
echo "			}"
echo "		} else if (MainEntry > MENU_MONITOR_INOUT) {"
echo "			LCD_Clear();"
echo "			head((char *)Rc_Model_name);"
echo "			LCD_Print(LCD_LINE_1, 0, (char *)text[MainEntry][0]);"
echo "			LCD_Print(LCD_LINE_1, 10, (char *)int2str((char *)tmp_str, SubEntry, 0));"
echo "			if (ModeEntry == 0) {"
echo "				if (Select == 0) {"
echo "					LCD_Print(LCD_LINE_3, 255, \"<-Back\");"
echo "				} else {"
echo "					LCD_Print(LCD_LINE_2, 0, (char *)text[MainEntry][Select]);"
echo "				}"
echo "			} else {"
echo "				Select = ModeEntry;"
echo "				LCD_Print(LCD_LINE_2, 0, (char *)text[MainEntry][Select]);"
echo "			}"
echo "		}"
echo "		switch (MainEntry) {"
echo "			case MENU_MAIN:"
echo "				LCD_Clear();"
echo "				head((char *)Rc_Model_name);"
echo "				LCD_Print(LCD_LINE_1, 0, \"Mainmenu:  \");"
echo "				LCD_Print(LCD_LINE_3, 255, (char *)text[SubEntry][0]);"
echo "			break;"
echo "#ifdef SUPPORT_MMC"
echo "			case MENU_NEW:"
echo "				LCD_Clear();"
echo "				head(\"------\");"
echo "				LCD_Print(LCD_LINE_1, 0, \"New:  \");"
echo "				if (SubEntry == 1) {"
echo "					LCD_Print(LCD_LINE_3, 255, \"Plane-1\");"
echo "				} else if (SubEntry == 2) {"
echo "					LCD_Print(LCD_LINE_3, 255, \"Plane-2\");"
echo "				} else if (SubEntry == 3) {"
echo "					LCD_Print(LCD_LINE_3, 255, \"Heli-1\");"
echo "				} else {"
echo "					LCD_Print(LCD_LINE_3, 255, \"<-Back\");"
echo "				}"
echo "			break;"
echo "			case MENU_LOAD:"
echo "				LCD_Clear();"
echo "				//head((char *)Rc_Model_name);"
echo "				LCD_Print(LCD_LINE_0, 0, \"Load:  \");"
echo "				LCD_Print(LCD_LINE_1, 0, \"ID:   \");"
echo "				LCD_Print(LCD_LINE_1, 5, (char *)int2str((char *)tmp_str, SubEntry, 0));"
echo "				if (SubEntry > 1) {"
echo "					load_name_mmc((char *)tmp_str, SubEntry - 2);"
echo "					LCD_Print(LCD_LINE_2, 1, (char *)tmp_str);"
echo "				} else if (SubEntry == 1) {"
echo "					LCD_Print(LCD_LINE_2, 1, \"Back\");"
echo "				}"
echo "				if (SubEntry == 0) {"
echo "					LCD_Print(LCD_LINE_3, 0, \">Back\");"
echo "					load_name_mmc((char *)tmp_str, SubEntry - 1);"
echo "					LCD_Print(LCD_LINE_4, 1, (char *)tmp_str);"
echo "				} else {"
echo "					load_name_mmc((char *)tmp_str, SubEntry - 1);"
echo "					LCD_Print(LCD_LINE_3, 0, \">\");"
echo "					LCD_Print(LCD_LINE_3, 1, (char *)tmp_str);"
echo "					load_name_mmc((char *)tmp_str, SubEntry);"
echo "					LCD_Print(LCD_LINE_4, 1, (char *)tmp_str);"
echo "				}"
echo "			break;"
echo "			case MENU_SAVE:"
echo "				LCD_Clear();"
echo "				//head((char *)Rc_Model_name);"
echo "				LCD_Print(LCD_LINE_0, 0, \"Save:  \");"
echo "				LCD_Print(LCD_LINE_0, 6, (char *)Rc_Model_name);"
echo "				LCD_Print(LCD_LINE_1, 0, \"ID:   \");"
echo "				LCD_Print(LCD_LINE_1, 5, (char *)int2str((char *)tmp_str, SubEntry, 0));"
echo "				if (SubEntry > 1) {"
echo "					load_name_mmc((char *)tmp_str, SubEntry - 2);"
echo "					LCD_Print(LCD_LINE_2, 1, (char *)tmp_str);"
echo "				} else if (SubEntry == 1) {"
echo "					LCD_Print(LCD_LINE_2, 1, \"Back\");"
echo "				}"
echo "				if (SubEntry == 0) {"
echo "					LCD_Print(LCD_LINE_3, 0, \">Back\");"
echo "					load_name_mmc((char *)tmp_str, SubEntry - 1);"
echo "					LCD_Print(LCD_LINE_4, 1, (char *)tmp_str);"
echo "				} else {"
echo "					load_name_mmc((char *)tmp_str, SubEntry - 1);"
echo "					LCD_Print(LCD_LINE_3, 0, \">\");"
echo "					LCD_Print(LCD_LINE_3, 1, (char *)tmp_str);"
echo "					load_name_mmc((char *)tmp_str, SubEntry);"
echo "					LCD_Print(LCD_LINE_4, 1, (char *)tmp_str);"
echo "				}"
echo "			break;"
echo "			case MENU_CALIBRATE:"
echo "				LCD_Clear();"
echo "				head((char *)Rc_Model_name);"
echo "				LCD_Print(LCD_LINE_1, 0, \"Calibrate:\");"
echo "				if (SubEntry == 0) {"
echo "					LCD_Print(LCD_LINE_2, 255, \"Center\");"
echo "					LCD_Print(LCD_LINE_3, 255, \"all\");"
echo "					LCD_Print(LCD_LINE_4, 255, \"sticks\");"
echo "				} else if (SubEntry == 1) {"
echo "					LCD_Print(LCD_LINE_2, 255, \"Move sticks\");"
echo "					LCD_Print(LCD_LINE_3, 255, \"to each\");"
echo "					LCD_Print(LCD_LINE_4, 255, \"korner\");"
echo "				} else {"
echo "					LCD_Print(LCD_LINE_3, 0, \"...done\");"
echo "				}"
echo "			break;"
echo "			case MENU_NAME:"
echo "				LCD_Clear();"
echo "				LCD_Print(LCD_LINE_0, 255, \"Edit-Name:\");"
echo "				LCD_Print(LCD_LINE_3, 0, (char *)Rc_Model_name);"
echo "				if (Rc_Model_name[Select] == 31) {"
echo "					LCD_Print(LCD_LINE_3, Select, \"        \");"
echo "					LCD_Print(LCD_LINE_5, 255, \">BACK<\");"
echo "				} else if (Rc_Model_name[Select] == 30) {"
echo "					LCD_Print(LCD_LINE_3, Select, \"        \");"
echo "					LCD_Print(LCD_LINE_5, 255, \">SAVE<\");"
echo "				} else {"
echo "					LCD_Write(Select, LCD_LINE_1, &Rc_Model_name[Select] + 2, 0);"
echo "					LCD_Write(Select, LCD_LINE_2, &Rc_Model_name[Select] + 1, 0);"
echo "					LCD_Write(Select, LCD_LINE_4, &Rc_Model_name[Select] - 1, 0);"
echo "					LCD_Write(Select, LCD_LINE_5, &Rc_Model_name[Select] - 2, 0);"
echo "				}"
echo "			break;"
echo "#endif"
echo "			case MENU_VOLTAGE_TEMP:"
echo "				LCD_Clear();"
echo "				head((char *)Rc_Model_name);"
echo "				redraw = 155;"
echo "				temperature = (int16_t)(((1.4 - (float)ADC_RegularConvertedValueTab[ADC_CHANNELS_MAX - 1] * 3.3 / 4096.0) / 0.004478) + 25.0 * 10.0);"
echo "				voltage = (int16_t)((float)ADC_RegularConvertedValueTab[ADC_CHANNELS_MAX - 2] * 15.6 / 4096.0 * 100.0);"
echo "				tmp_str[0] = (temperature / 100) + 0x30;"
echo "				tmp_str[1] = ((temperature % 100) / 10) + 0x30;"
echo "				tmp_str[2] = '.';"
echo "				tmp_str[3] = ((temperature % 100) % 10) + 0x30;"
echo "				tmp_str[4] = 'C';"
echo "				tmp_str[5] = 0;"
echo "				LCD_Print(LCD_LINE_1, 0, \"CPU-Temp.  \");"
echo "				LCD_Font(2);"
echo "				LCD_Print(LCD_LINE_2, 255, (char *)tmp_str);"
echo "				LCD_Font(1);"
echo "				tmp_str[0] = ' ';"
echo "				if (voltage > 1000) {"
echo "					tmp_str[1] = (voltage / 1000) + 0x30;"
echo "				} else {"
echo "					tmp_str[1] = ' ';"
echo "				}"
echo "				tmp_str[2] = ((voltage % 1000) / 100) + 0x30;"
echo "				tmp_str[3] = '.';"
echo "				tmp_str[4] = (((voltage % 1000) % 100) / 10) + 0x30;"
echo "				tmp_str[5] = (((voltage % 1000) % 100) % 10) + 0x30;"
echo "				tmp_str[6] = 'V';"
echo "				tmp_str[7] = 0;"
echo "				LCD_Print(LCD_LINE_3, 0, \"Battery   \");"
echo "				LCD_Font(2);"
echo "				LCD_Print(LCD_LINE_4, 255, (char *)tmp_str);"
echo "				LCD_Font(1);"
echo "			break;"
echo "			case MENU_MONITOR_CONTROL:"
echo "				LCD_Clear();"
echo "				head((char *)Rc_Model_name);"
echo "				redraw = 155;"
echo "				LCD_Print(LCD_LINE_1, 2, (char *)int2str((char *)tmp_str, (SubEntry * 4) + 1, 0));"
echo "				LCD_Print(LCD_LINE_1, 5, \"->\");"
echo "				LCD_Print(LCD_LINE_1, 8, (char *)int2str((char *)tmp_str, (SubEntry * 4) + 7, 0));"
echo "				for (num = 0; num < 4; num++) {"
echo "					print_bar(3, 16 + num * ((LCD_H - 16) / 4) + 1, LCD_W - 6, ((LCD_H - 16) / 4) - 2, (Rc_AdcRead((SubEntry * 4) + num) / 8) + 128);"
echo "				}"
echo "			break;"
echo "			case MENU_MONITOR_INOUT:"
echo "				LCD_Clear();"
echo "				head((char *)Rc_Model_name);"
echo "				redraw = 155;"
echo "				//LCD_Write(LCD_LINE_1, LCD_CMD);"
echo "				for (num = 0; num < 20; num++) {"
echo "				//	LCD_Write(((Rc_Input_value[num] / 8) + 128) / 32 + 1, LCD_CHAR);"
echo "				}"
echo "				//LCD_Write(LCD_LINE_2, LCD_CMD);"
echo "				for (num = 0; num < 20; num++) {"
echo "				//	LCD_Write(((Rc_Output_value[num] / 8) + 128) / 32 + 1, LCD_CHAR);"
echo "				}"
echo "			break;"
echo "			case MENU_MONITOR_OSC:"
echo "				redraw = 10;"
echo "				if (pos < LCD_W - 10) {"
echo "					LCD_Pixel(pos, 30 + ((Rc_AdcRead(SubEntry) / 8) + 128) / 16 + 1, 1);"
echo "					pos++;"
echo "					return;"
echo "				} else {"
echo "					LCD_Update();"
echo "					LCD_Clear();"
echo "					head((char *)Rc_Model_name);"
echo "					LCD_Print(LCD_LINE_1, 0, \"ADC-Input:     \");"
echo "					LCD_Print(LCD_LINE_1, 12, (char *)int2str((char *)tmp_str, SubEntry + 1, 0));"
echo "					pos = 10;"
echo "					return;"
echo "				}"
echo "			break;"
echo "			default:"
echo "				if (Select > 0 && SubEntry > 0 && value[MainEntry][Select] != 0) {"
echo "					if (type[MainEntry][Select] == TYPE_CONTROL) {"
echo "						print_control(LCD_LINE_4, 255, value[MainEntry][Select][SubEntry - 1]);"
echo "						if (Last_Control != 255) {"
echo "							value[MainEntry][Select][SubEntry - 1] = Last_Control;"
echo "							Last_Control = 255;"
echo "						}"
echo "					} else if (type[MainEntry][Select] == TYPE_CHANNEL_IN) {"
echo "						print_control(LCD_LINE_4, 255, Rc_Input_control[value[MainEntry][Select][SubEntry - 1]]);"
echo "					} else if (type[MainEntry][Select] == TYPE_CHANNEL_OUT) {"
echo "						print_output(LCD_LINE_4, 255, value[MainEntry][Select][SubEntry - 1]);"
echo "					} else if (type[MainEntry][Select] == TYPE_CHANNEL) {"
echo "						LCD_Font(2);"
echo "						LCD_Print(LCD_LINE_4, 5, \"Ch-\");"
echo "						LCD_Print(LCD_LINE_4, 9, (char *)int2str((char *)tmp_str, value[MainEntry][Select][SubEntry - 1], 0));"
echo "						LCD_Font(1);"
echo "					} else if (type[MainEntry][Select] == TYPE_POINT_X) {"
echo "						LCD_Font(2);"
echo "						LCD_Print(LCD_LINE_4, 0, (char *)int2str((char *)tmp_str, Rc_Mixer_point[SubEntry - 1][extra[MainEntry][Select]][0], 0));"
echo "						LCD_Font(1);"
echo "						LCD_Print(LCD_LINE_5, 0, \"y\");"
echo "						LCD_Print(LCD_LINE_5, 1, (char *)int2str((char *)tmp_str, Rc_Mixer_point[SubEntry - 1][extra[MainEntry][Select]][1], 0));"
echo "						print_mixer((LCD_W / 2), (LCD_H / 2), (LCD_W / 2), (LCD_H / 2), SubEntry - 1, extra[MainEntry][Select], 0);"
echo "					} else if (type[MainEntry][Select] == TYPE_POINT_Y) {"
echo "						LCD_Print(LCD_LINE_4, 0, \"x\");"
echo "						LCD_Print(LCD_LINE_4, 1, (char *)int2str((char *)tmp_str, Rc_Mixer_point[SubEntry - 1][extra[MainEntry][Select]][0], 0));"
echo "						LCD_Font(2);"
echo "						LCD_Print(LCD_LINE_5, 0, (char *)int2str((char *)tmp_str, Rc_Mixer_point[SubEntry - 1][extra[MainEntry][Select]][1], 0));"
echo "						LCD_Font(1);"
echo "						print_mixer((LCD_W / 2), (LCD_H / 2), (LCD_W / 2), (LCD_H / 2), SubEntry - 1, extra[MainEntry][Select], 1);"
echo "					} else {"
echo "						LCD_Font(2);"
echo "						LCD_Print(LCD_LINE_4, 255, (char *)int2str((char *)tmp_str, value[MainEntry][Select][SubEntry - 1], 0));"
echo "						LCD_Font(1);"
echo "					}"
echo "				}"
echo "			break;"
echo "		}"
echo "		LCD_Update();"
echo "		Last_Control = 255;"
echo "	}"
echo "}"
echo ""
echo "#endif"
echo ""
echo ""






