#!/bin/ash
#
#

echo "/*" > rc_drv_stm32/rc_switches.c
echo "	Don't edit this file: rc_drv_stm32/rc_switches.c" >> rc_drv_stm32/rc_switches.c
echo "	it is generated by: scripts/pins_txt2switches_c.sh" >> rc_drv_stm32/rc_switches.c
echo "*/" >> rc_drv_stm32/rc_switches.c
echo "" >> rc_drv_stm32/rc_switches.c
head -n 36 < main.c >> rc_drv_stm32/rc_switches.c
echo "" >> rc_drv_stm32/rc_switches.c
echo "#define RC_SW_START 30" >> rc_drv_stm32/rc_switches.c


for SW_NUM in 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
do
	for SW_PART in A B C
	do
		for PORT in A B C D E F G H I J
		do
			if grep -s -q "P$PORT.*|SW${SW_NUM}_.*" pins.txt
			then

				for PIN in 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
				do
					if grep -s -q "P$PORT$PIN|SW${SW_NUM}_${SW_PART}" pins.txt
					then
						SWITCH="`grep "P$PORT$PIN|SW${SW_NUM}_${SW_PART}" pins.txt | cut -d"|" -f3`"
						echo "#define RC_CONTROL_${SWITCH}_PORT	GPIO$PORT" >> rc_drv_stm32/rc_switches.c
						echo "#define RC_CONTROL_${SWITCH}_PIN 	GPIO_Pin_$PIN" >> rc_drv_stm32/rc_switches.c
					fi
				done
			fi
		done
	done
done

echo "" >> rc_drv_stm32/rc_switches.c
echo "enum {" >> rc_drv_stm32/rc_switches.c
echo "	RC_SWITCH_TYPE_UPDOWN," >> rc_drv_stm32/rc_switches.c
echo "	RC_SWITCH_TYPE_ONOFF," >> rc_drv_stm32/rc_switches.c
echo "	RC_SWITCH_TYPE_ONOFFON," >> rc_drv_stm32/rc_switches.c
echo "	RC_SWITCH_TYPE_ENCODER," >> rc_drv_stm32/rc_switches.c
echo "};" >> rc_drv_stm32/rc_switches.c
echo "" >> rc_drv_stm32/rc_switches.c
echo "char switch_type[CONTROL_MAX];" >> rc_drv_stm32/rc_switches.c
echo "" >> rc_drv_stm32/rc_switches.c

echo "void switches_init (void) {" >> rc_drv_stm32/rc_switches.c
echo "	GPIO_InitTypeDef GPIO_InitStructure;" >> rc_drv_stm32/rc_switches.c
for SW_NUM in 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
do
	if grep -s -q "#define RC_CONTROL_SW${SW_NUM}_A_PIN" rc_drv_stm32/rc_switches.c 
	then
		if grep -s -q "#define RC_CONTROL_SW${SW_NUM}_C_PIN" rc_drv_stm32/rc_switches.c 
		then
			TYPE="ENCODER"
			echo "	switch_type[RC_SW_START + ${SW_NUM}] = RC_SWITCH_TYPE_$TYPE;" >> rc_drv_stm32/rc_switches.c
		elif grep -s -q "#define RC_CONTROL_SW${SW_NUM}_B_PIN" rc_drv_stm32/rc_switches.c 
		then
			TYPE="ONOFFON"
			echo "	switch_type[RC_SW_START + ${SW_NUM}] = RC_SWITCH_TYPE_$TYPE;" >> rc_drv_stm32/rc_switches.c
		else
			TYPE="ONOFF"
			echo "	switch_type[RC_SW_START + ${SW_NUM}] = RC_SWITCH_TYPE_$TYPE;" >> rc_drv_stm32/rc_switches.c
		fi
	fi
done
echo "" >> rc_drv_stm32/rc_switches.c
for PORT in A B C D E F G H I J
do
	if grep -s -q "P$PORT.*|SW[0-9][0-9]*_.*" pins.txt
	then
		echo -n "	GPIO_InitStructure.GPIO_Pin = 0" >> rc_drv_stm32/rc_switches.c
		for PIN in 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
		do
			if grep -s -q "P$PORT$PIN|SW[0-9][0-9]*_.*" pins.txt
			then
				SWITCH="`grep "P$PORT$PIN|SW[0-9][0-9]*_.*" pins.txt | cut -d"|" -f3`"
				echo -n " | RC_CONTROL_${SWITCH}_PIN" >> rc_drv_stm32/rc_switches.c
			fi
		done
		echo ";" >> rc_drv_stm32/rc_switches.c
		echo "	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;" >> rc_drv_stm32/rc_switches.c
		echo "	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;" >> rc_drv_stm32/rc_switches.c
		echo "	GPIO_Init(GPIO$PORT, &GPIO_InitStructure);" >> rc_drv_stm32/rc_switches.c
		echo "" >> rc_drv_stm32/rc_switches.c
	fi
done
echo "}" >> rc_drv_stm32/rc_switches.c
echo "" >> rc_drv_stm32/rc_switches.c


echo "void switch_update (uint8_t control_num, uint8_t type, uint8_t pins, uint8_t a, uint8_t b, uint8_t c) {" >> rc_drv_stm32/rc_switches.c
echo "	if (pins >= 2 && type == RC_SWITCH_TYPE_UPDOWN) {" >> rc_drv_stm32/rc_switches.c
echo "		if (a == 0) {" >> rc_drv_stm32/rc_switches.c
echo "			Rc_Control_value[control_num]--;" >> rc_drv_stm32/rc_switches.c
echo "		} else if (b == 0) {" >> rc_drv_stm32/rc_switches.c
echo "			Rc_Control_value[control_num]++;" >> rc_drv_stm32/rc_switches.c
echo "		} else if (pins >= 3 && c == 0) {" >> rc_drv_stm32/rc_switches.c
echo "			Rc_Control_value[control_num] = 0;" >> rc_drv_stm32/rc_switches.c
echo "		}" >> rc_drv_stm32/rc_switches.c
echo "	} else if (pins >= 1 && type == RC_SWITCH_TYPE_ONOFF) {" >> rc_drv_stm32/rc_switches.c
echo "		if (a == 0) {" >> rc_drv_stm32/rc_switches.c
echo "			Rc_Control_value[control_num] = 127;" >> rc_drv_stm32/rc_switches.c
echo "		} else if (pins >= 2 && b == 0) {" >> rc_drv_stm32/rc_switches.c
echo "			Rc_Control_value[control_num] = -127;" >> rc_drv_stm32/rc_switches.c
echo "		} else if (pins >= 3 && c == 0) {" >> rc_drv_stm32/rc_switches.c
echo "			Rc_Control_value[control_num] = 0;" >> rc_drv_stm32/rc_switches.c
echo "		}" >> rc_drv_stm32/rc_switches.c
echo "	} else if (pins >= 1 && type == RC_SWITCH_TYPE_ONOFFON) {" >> rc_drv_stm32/rc_switches.c
echo "		if (a == 0) {" >> rc_drv_stm32/rc_switches.c
echo "			Rc_Control_value[control_num] = 127;" >> rc_drv_stm32/rc_switches.c
echo "		} else if (pins >= 2 && b == 0) {" >> rc_drv_stm32/rc_switches.c
echo "			Rc_Control_value[control_num] = -127;" >> rc_drv_stm32/rc_switches.c
echo "		} else {" >> rc_drv_stm32/rc_switches.c
echo "			Rc_Control_value[control_num] = 0;" >> rc_drv_stm32/rc_switches.c
echo "		}" >> rc_drv_stm32/rc_switches.c
echo "	} else if (pins >= 2 && type == RC_SWITCH_TYPE_ENCODER) {" >> rc_drv_stm32/rc_switches.c
echo "		uint8_t enc_data = 0;" >> rc_drv_stm32/rc_switches.c
echo "		if (a != 0) {" >> rc_drv_stm32/rc_switches.c
echo "			enc_data |= 1;" >> rc_drv_stm32/rc_switches.c
echo "		}" >> rc_drv_stm32/rc_switches.c
echo "		if (b != 0) {" >> rc_drv_stm32/rc_switches.c
echo "			enc_data |= 2;" >> rc_drv_stm32/rc_switches.c
echo "		}" >> rc_drv_stm32/rc_switches.c
echo "		if (pins >= 3 && c != 0) {" >> rc_drv_stm32/rc_switches.c
echo "			enc_data |= 4;" >> rc_drv_stm32/rc_switches.c
echo "		}" >> rc_drv_stm32/rc_switches.c
echo "		Rc_REncoderDecode_byte(enc_data, 0, 1, 2, control_num);" >> rc_drv_stm32/rc_switches.c
echo "	}" >> rc_drv_stm32/rc_switches.c
echo "}" >> rc_drv_stm32/rc_switches.c
echo "" >> rc_drv_stm32/rc_switches.c



echo "void switches_check (void) {" >> rc_drv_stm32/rc_switches.c
for SW_NUM in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
do
	if grep -s -q "#define RC_CONTROL_SW${SW_NUM}_A_PIN" rc_drv_stm32/rc_switches.c 
	then
		TYPE="on_off_on"
		if grep -s -q "#define RC_CONTROL_SW${SW_NUM}_C_PIN" rc_drv_stm32/rc_switches.c 
		then
			echo "	switch_update(RC_SW_START + ${SW_NUM}, switch_type[RC_SW_START + ${SW_NUM}], 3, GPIO_ReadInputDataBit(RC_CONTROL_SW${SW_NUM}_A_PORT, RC_CONTROL_SW${SW_NUM}_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW${SW_NUM}_B_PORT, RC_CONTROL_SW${SW_NUM}_B_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW${SW_NUM}_C_PORT, RC_CONTROL_SW${SW_NUM}_C_PIN));" >> rc_drv_stm32/rc_switches.c
		elif grep -s -q "#define RC_CONTROL_SW${SW_NUM}_B_PIN" rc_drv_stm32/rc_switches.c 
		then
			echo "	switch_update(RC_SW_START + ${SW_NUM}, switch_type[RC_SW_START + ${SW_NUM}], 2, GPIO_ReadInputDataBit(RC_CONTROL_SW${SW_NUM}_A_PORT, RC_CONTROL_SW${SW_NUM}_A_PIN), GPIO_ReadInputDataBit(RC_CONTROL_SW${SW_NUM}_B_PORT, RC_CONTROL_SW${SW_NUM}_B_PIN), 0);" >> rc_drv_stm32/rc_switches.c
		else
			echo "	switch_update(RC_SW_START + ${SW_NUM}, switch_type[RC_SW_START + ${SW_NUM}], 1, GPIO_ReadInputDataBit(RC_CONTROL_SW${SW_NUM}_A_PORT, RC_CONTROL_SW${SW_NUM}_A_PIN), 0, 0);" >> rc_drv_stm32/rc_switches.c
		fi
	fi
done
echo "}" >> rc_drv_stm32/rc_switches.c
echo "" >> rc_drv_stm32/rc_switches.c







